/* A Bison parser, made by GNU Bison 3.0.4.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015 Free Software Foundation, Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "3.0.4"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 1

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1




/* Copy the first part of user declarations.  */
#line 28 "parser.y" /* yacc.c:339  */


#define PARSER_VERSION_STRING "parser_version_3"

#include "config.h"
#include <stdlib.h>
#include <termios.h>
#include <sys/types.h>
#include <fcntl.h>
#include <stdio.h>
#include <ctype.h>
#include <string.h>
#include <setjmp.h>
#include <sys/stat.h>                    /* structure stat       */
#include <unistd.h>                      /* prototype for stat() */
#include <sys/wait.h>
#include <signal.h>
#include <stdarg.h>
#include <pwd.h>
#include <syslog.h>
#include <string.h>
#include <errno.h>
#include <assert.h>
#ifdef __linux__
#include <mntent.h>
#endif

#include "dosemu_config.h"
#include "emu.h"
#ifdef X86_EMULATOR
#include "cpu-emu.h"
#endif
#include "disks.h"
#include "port.h"
#define allow_io	port_allow_io
#include "lpt.h"
#include "video.h"
#include "vc.h"
#include "mouse.h"
#include "serial.h"
#include "timers.h"
#include "keyboard/keymaps.h"
#include "keyboard/keyb_server.h"
#include "memory.h"
#include "mapping.h"
#include "utilities.h"
#include "aspi.h"
#include "pktdrvr.h"
#include "iodev.h" /* for TM_BIOS / TM_PIT / TM_LINUX */

#define USERVAR_PREF	"dosemu_"
static int user_scope_level;

static int after_secure_check = 0;
static serial_t *sptr;
static serial_t nullser;
static mouse_t *mptr = &config.mouse;
static int c_ser = 0;

static struct disk *dptr;
static struct disk nulldisk;
static int c_hdisks = 0;
static int c_fdisks = 0;

int dexe_running = 0;
static int dexe_forbid_disk = 1;
char own_hostname[128];

static struct printer nullptr;
static struct printer *pptr = &nullptr;
static int c_printers = 0;

static int ports_permission = IO_RDWR;
static unsigned int ports_ormask = 0;
static unsigned int ports_andmask = 0xFFFF;
static unsigned int portspeed = 0;
static char dev_name[255]= "";

static int errors = 0;
static int warnings = 0;

static int priv_lvl = 0;
static int saved_priv_lvl = 0; 


static char *file_being_parsed;

			/* this to ensure we are parsing a new style */
static int parser_version_3_style_used = 0;
#define CONFNAME_V3USED "version_3_style_used"

	/* local procedures */

static void start_ports(void);
static void start_mouse(void);
static void stop_mouse(void);
static void start_debug(void);
static void start_video(void);
static void stop_video(void);
static void set_vesamodes(int width, int height, int color_bits);
static int detect_vbios_seg(void);
static int detect_vbios_size(void);
static void stop_ttylocks(void);
static void start_serial(void);
static void stop_serial(void);
static void start_printer(void);
static void stop_printer(void);
static void start_keyboard(void);
static void keytable_start(int layout);
static void keytable_stop(void);
static void dump_keytables_to_file(char *name);
static void stop_terminal(void);
static void start_disk(void);
static void do_part(char *);
static void start_floppy(void);
static void stop_disk(int token);
static void start_vnet(char *);
static FILE* open_file(char* filename);
static void close_file(FILE* file);
static void write_to_syslog(char *message);
static void set_irq_value(int bits, int i1);
static void set_irq_range(int bits, int i1, int i2);
static int undefine_config_variable(char *name);
static void check_user_var(char *name);
static char *run_shell(char *command);
static int for_each_handling(int loopid, char *varname, char *delim, char *list);
static void enter_user_scope(int incstackptr);
static void leave_user_scope(int incstackptr);
static void handle_features(int which, int value);
static void set_joy_device(char *devstring);
static int parse_timemode(const char *);

	/* class stuff */
#define IFCLASS(m) if (is_in_allowed_classes(m))

#define CL_ALL			-1
#define CL_VAR		    0x200
#define CL_VPORT	   0x2000
#define CL_PORT		  0x20000
#define CL_PCI		  0x40000
#define CL_IRQ		 0x200000
#define CL_HARDRAM	0x1000000
#define CL_NET		0x2000000

static int is_in_allowed_classes(int mask);

#define TOF(x) ( x.type == TYPE_REAL ? x.value.r : x.value.i )
#define V_VAL(x,y,z) \
do { x.type = y.type; if (x.type == TYPE_REAL) x.value.r = (z); \
      else x.value.i = (z); } \
while (0)

	/* variables in lexer.l */




	/* for unicode keyboard plugin */
static void keyb_mod(int wich, t_keysym keynum, int unicode);
static void dump_keytable_part(FILE *f, t_keysym *map, int size);



#include "translate/translate.h"
#include "translate/dosemu_charset.h"
	/* for translate plugin */

static void set_internal_charset(char *charset_name);
static void set_external_charset(char *charset_name);


#line 238 "parser.c" /* yacc.c:339  */

# ifndef YY_NULLPTR
#  if defined __cplusplus && 201103L <= __cplusplus
#   define YY_NULLPTR nullptr
#  else
#   define YY_NULLPTR 0
#  endif
# endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* In a future release of Bison, this section will be replaced
   by #include "parser.h".  */
#ifndef YY_YY_PARSER_H_INCLUDED
# define YY_YY_PARSER_H_INCLUDED
/* Debug traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif
#if YYDEBUG
extern int yydebug;
#endif

/* Token type.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
  enum yytokentype
  {
    INTEGER = 258,
    L_OFF = 259,
    L_ON = 260,
    L_AUTO = 261,
    L_YES = 262,
    L_NO = 263,
    CHIPSET_TYPE = 264,
    KEYB_LAYOUT = 265,
    REAL = 266,
    STRING = 267,
    VARIABLE = 268,
    EXPRTEST = 269,
    INTCAST = 270,
    REALCAST = 271,
    AND_OP = 272,
    OR_OP = 273,
    XOR_OP = 274,
    SHR_OP = 275,
    SHL_OP = 276,
    NOT_OP = 277,
    EQ_OP = 278,
    GE_OP = 279,
    LE_OP = 280,
    NEQ_OP = 281,
    STR_EQ_OP = 282,
    STR_NEQ_OP = 283,
    L_AND_OP = 284,
    L_OR_OP = 285,
    UMINUS = 286,
    UPLUS = 287,
    BIT_NOT_OP = 288,
    STRLEN = 289,
    STRTOL = 290,
    STRNCMP = 291,
    STRCAT = 292,
    STRPBRK = 293,
    STRSPLIT = 294,
    STRCHR = 295,
    STRRCHR = 296,
    STRSTR = 297,
    STRDEL = 298,
    STRSPN = 299,
    STRCSPN = 300,
    SHELL = 301,
    DEFINED = 302,
    DEFINE = 303,
    UNDEF = 304,
    IFSTATEMENT = 305,
    WHILESTATEMENT = 306,
    FOREACHSTATEMENT = 307,
    ENTER_USER_SPACE = 308,
    LEAVE_USER_SPACE = 309,
    CHECKUSERVAR = 310,
    DOSBANNER = 311,
    FASTFLOPPY = 312,
    HOGTHRESH = 313,
    SPEAKER = 314,
    IPXSUPPORT = 315,
    IPXNETWORK = 316,
    NOVELLHACK = 317,
    ETHDEV = 318,
    TAPDEV = 319,
    VDESWITCH = 320,
    SLIRPARGS = 321,
    VNET = 322,
    DEBUG = 323,
    MOUSE = 324,
    SERIAL = 325,
    COM = 326,
    KEYBOARD = 327,
    TERMINAL = 328,
    VIDEO = 329,
    EMURETRACE = 330,
    TIMER = 331,
    MATHCO = 332,
    CPU = 333,
    CPUSPEED = 334,
    RDTSC = 335,
    BOOTDRIVE = 336,
    SWAP_BOOTDRIVE = 337,
    L_XMS = 338,
    L_DPMI = 339,
    DPMI_LIN_RSV_BASE = 340,
    DPMI_LIN_RSV_SIZE = 341,
    PM_DOS_API = 342,
    NO_NULL_CHECKS = 343,
    PORTS = 344,
    DISK = 345,
    DOSMEM = 346,
    EXT_MEM = 347,
    L_EMS = 348,
    UMB_A0 = 349,
    UMB_B0 = 350,
    UMB_F0 = 351,
    EMS_SIZE = 352,
    EMS_FRAME = 353,
    EMS_UMA_PAGES = 354,
    EMS_CONV_PAGES = 355,
    TTYLOCKS = 356,
    L_SOUND = 357,
    L_SND_OSS = 358,
    L_JOYSTICK = 359,
    FULL_FILE_LOCKS = 360,
    DEXE = 361,
    ALLOWDISK = 362,
    FORCEXDOS = 363,
    XDOSONLY = 364,
    ABORT = 365,
    WARN = 366,
    L_FLOPPY = 367,
    EMUSYS = 368,
    EMUINI = 369,
    L_X = 370,
    L_SDL = 371,
    DOSEMUMAP = 372,
    LOGBUFSIZE = 373,
    LOGFILESIZE = 374,
    MAPPINGDRIVER = 375,
    LFN_SUPPORT = 376,
    EMULATED = 377,
    NATIVE = 378,
    CPUEMU = 379,
    CPU_VM = 380,
    VM86 = 381,
    FULL = 382,
    VM86SIM = 383,
    FULLSIM = 384,
    KVM = 385,
    RAWKEYBOARD = 386,
    PRESTROKE = 387,
    KEYTABLE = 388,
    SHIFT_MAP = 389,
    ALT_MAP = 390,
    NUMPAD_MAP = 391,
    DUMP = 392,
    DGRAVE = 393,
    DACUTE = 394,
    DCIRCUM = 395,
    DTILDE = 396,
    DBREVE = 397,
    DABOVED = 398,
    DDIARES = 399,
    DABOVER = 400,
    DDACUTE = 401,
    DCEDILLA = 402,
    DIOTA = 403,
    DOGONEK = 404,
    DCARON = 405,
    NETWORK = 406,
    PKTDRIVER = 407,
    DIRECTORY = 408,
    NAMESTUB = 409,
    BINARY = 410,
    BASE = 411,
    IRQ = 412,
    DEVICE = 413,
    CHARSET = 414,
    BAUDRATE = 415,
    VIRTUAL = 416,
    VMODEM = 417,
    PSEUDO = 418,
    RTSCTS = 419,
    LOWLAT = 420,
    PCCOM = 421,
    MICROSOFT = 422,
    MS3BUTTON = 423,
    LOGITECH = 424,
    MMSERIES = 425,
    MOUSEMAN = 426,
    HITACHI = 427,
    MOUSESYSTEMS = 428,
    BUSMOUSE = 429,
    PS2 = 430,
    IMPS2 = 431,
    INTERNALDRIVER = 432,
    EMULATE3BUTTONS = 433,
    CLEARDTR = 434,
    L_DISPLAY = 435,
    L_TITLE = 436,
    X_TITLE_SHOW_APPNAME = 437,
    ICON_NAME = 438,
    X_KEYCODE = 439,
    X_BLINKRATE = 440,
    X_SHARECMAP = 441,
    X_MITSHM = 442,
    X_FONT = 443,
    X_FIXED_ASPECT = 444,
    X_ASPECT_43 = 445,
    X_LIN_FILT = 446,
    X_BILIN_FILT = 447,
    X_MODE13FACT = 448,
    X_WINSIZE = 449,
    X_GAMMA = 450,
    X_FULLSCREEN = 451,
    VGAEMU_MEMSIZE = 452,
    VESAMODE = 453,
    X_LFB = 454,
    X_PM_INTERFACE = 455,
    X_MGRAB_KEY = 456,
    X_BACKGROUND_PAUSE = 457,
    SDL_HWREND = 458,
    VGA = 459,
    MGA = 460,
    CGA = 461,
    EGA = 462,
    NONE = 463,
    CONSOLE = 464,
    GRAPHICS = 465,
    CHIPSET = 466,
    FULLREST = 467,
    PARTREST = 468,
    MEMSIZE = 469,
    VBIOS_SIZE_TOK = 470,
    VBIOS_SEG = 471,
    VGAEMUBIOS_FILE = 472,
    VBIOS_FILE = 473,
    VBIOS_COPY = 474,
    VBIOS_MMAP = 475,
    DUALMON = 476,
    VBIOS_POST = 477,
    FORCE_VT_SWITCH = 478,
    PCI = 479,
    COLOR = 480,
    ESCCHAR = 481,
    XTERM_TITLE = 482,
    IO = 483,
    PORT = 484,
    CONFIG = 485,
    READ = 486,
    WRITE = 487,
    KEYB = 488,
    PRINTER = 489,
    WARNING = 490,
    GENERAL = 491,
    HARDWARE = 492,
    L_IPC = 493,
    SOUND = 494,
    TRACE = 495,
    CLEAR = 496,
    LPT = 497,
    COMMAND = 498,
    TIMEOUT = 499,
    L_FILE = 500,
    L_PARTITION = 501,
    WHOLEDISK = 502,
    THREEINCH = 503,
    THREEINCH_720 = 504,
    THREEINCH_2880 = 505,
    FIVEINCH = 506,
    FIVEINCH_360 = 507,
    READONLY = 508,
    LAYOUT = 509,
    SECTORS = 510,
    CYLINDERS = 511,
    TRACKS = 512,
    HEADS = 513,
    OFFSET = 514,
    HDIMAGE = 515,
    HDTYPE1 = 516,
    HDTYPE2 = 517,
    HDTYPE9 = 518,
    DISKCYL4096 = 519,
    RDONLY = 520,
    WRONLY = 521,
    RDWR = 522,
    ORMASK = 523,
    ANDMASK = 524,
    RANGE = 525,
    FAST = 526,
    SLOW = 527,
    SILLYINT = 528,
    USE_SIGIO = 529,
    HARDWARE_RAM = 530,
    SB_BASE = 531,
    SB_IRQ = 532,
    SB_DMA = 533,
    SB_HDMA = 534,
    MPU_BASE = 535,
    MPU_IRQ = 536,
    MPU_IRQ_MT32 = 537,
    MIDI_SYNTH = 538,
    SOUND_DRIVER = 539,
    MIDI_DRIVER = 540,
    MUNT_ROMS = 541,
    SND_PLUGIN_PARAMS = 542,
    PCM_HPF = 543,
    MIDI_FILE = 544,
    WAV_FILE = 545,
    CDROM = 546,
    ASPI = 547,
    DEVICETYPE = 548,
    TARGET = 549,
    FEATURE = 550,
    JOYSTICK = 551,
    JOY_DEVICE = 552,
    JOY_DOS_MIN = 553,
    JOY_DOS_MAX = 554,
    JOY_GRANULARITY = 555,
    JOY_LATENCY = 556,
    CLI_TIMEOUT = 557,
    TIMEMODE = 558,
    UNICODE = 559,
    SHIFT_ALT_MAP = 560,
    CTRL_MAP = 561,
    CTRL_ALT_MAP = 562,
    INTERNAL = 563,
    EXTERNAL = 564
  };
#endif
/* Tokens.  */
#define INTEGER 258
#define L_OFF 259
#define L_ON 260
#define L_AUTO 261
#define L_YES 262
#define L_NO 263
#define CHIPSET_TYPE 264
#define KEYB_LAYOUT 265
#define REAL 266
#define STRING 267
#define VARIABLE 268
#define EXPRTEST 269
#define INTCAST 270
#define REALCAST 271
#define AND_OP 272
#define OR_OP 273
#define XOR_OP 274
#define SHR_OP 275
#define SHL_OP 276
#define NOT_OP 277
#define EQ_OP 278
#define GE_OP 279
#define LE_OP 280
#define NEQ_OP 281
#define STR_EQ_OP 282
#define STR_NEQ_OP 283
#define L_AND_OP 284
#define L_OR_OP 285
#define UMINUS 286
#define UPLUS 287
#define BIT_NOT_OP 288
#define STRLEN 289
#define STRTOL 290
#define STRNCMP 291
#define STRCAT 292
#define STRPBRK 293
#define STRSPLIT 294
#define STRCHR 295
#define STRRCHR 296
#define STRSTR 297
#define STRDEL 298
#define STRSPN 299
#define STRCSPN 300
#define SHELL 301
#define DEFINED 302
#define DEFINE 303
#define UNDEF 304
#define IFSTATEMENT 305
#define WHILESTATEMENT 306
#define FOREACHSTATEMENT 307
#define ENTER_USER_SPACE 308
#define LEAVE_USER_SPACE 309
#define CHECKUSERVAR 310
#define DOSBANNER 311
#define FASTFLOPPY 312
#define HOGTHRESH 313
#define SPEAKER 314
#define IPXSUPPORT 315
#define IPXNETWORK 316
#define NOVELLHACK 317
#define ETHDEV 318
#define TAPDEV 319
#define VDESWITCH 320
#define SLIRPARGS 321
#define VNET 322
#define DEBUG 323
#define MOUSE 324
#define SERIAL 325
#define COM 326
#define KEYBOARD 327
#define TERMINAL 328
#define VIDEO 329
#define EMURETRACE 330
#define TIMER 331
#define MATHCO 332
#define CPU 333
#define CPUSPEED 334
#define RDTSC 335
#define BOOTDRIVE 336
#define SWAP_BOOTDRIVE 337
#define L_XMS 338
#define L_DPMI 339
#define DPMI_LIN_RSV_BASE 340
#define DPMI_LIN_RSV_SIZE 341
#define PM_DOS_API 342
#define NO_NULL_CHECKS 343
#define PORTS 344
#define DISK 345
#define DOSMEM 346
#define EXT_MEM 347
#define L_EMS 348
#define UMB_A0 349
#define UMB_B0 350
#define UMB_F0 351
#define EMS_SIZE 352
#define EMS_FRAME 353
#define EMS_UMA_PAGES 354
#define EMS_CONV_PAGES 355
#define TTYLOCKS 356
#define L_SOUND 357
#define L_SND_OSS 358
#define L_JOYSTICK 359
#define FULL_FILE_LOCKS 360
#define DEXE 361
#define ALLOWDISK 362
#define FORCEXDOS 363
#define XDOSONLY 364
#define ABORT 365
#define WARN 366
#define L_FLOPPY 367
#define EMUSYS 368
#define EMUINI 369
#define L_X 370
#define L_SDL 371
#define DOSEMUMAP 372
#define LOGBUFSIZE 373
#define LOGFILESIZE 374
#define MAPPINGDRIVER 375
#define LFN_SUPPORT 376
#define EMULATED 377
#define NATIVE 378
#define CPUEMU 379
#define CPU_VM 380
#define VM86 381
#define FULL 382
#define VM86SIM 383
#define FULLSIM 384
#define KVM 385
#define RAWKEYBOARD 386
#define PRESTROKE 387
#define KEYTABLE 388
#define SHIFT_MAP 389
#define ALT_MAP 390
#define NUMPAD_MAP 391
#define DUMP 392
#define DGRAVE 393
#define DACUTE 394
#define DCIRCUM 395
#define DTILDE 396
#define DBREVE 397
#define DABOVED 398
#define DDIARES 399
#define DABOVER 400
#define DDACUTE 401
#define DCEDILLA 402
#define DIOTA 403
#define DOGONEK 404
#define DCARON 405
#define NETWORK 406
#define PKTDRIVER 407
#define DIRECTORY 408
#define NAMESTUB 409
#define BINARY 410
#define BASE 411
#define IRQ 412
#define DEVICE 413
#define CHARSET 414
#define BAUDRATE 415
#define VIRTUAL 416
#define VMODEM 417
#define PSEUDO 418
#define RTSCTS 419
#define LOWLAT 420
#define PCCOM 421
#define MICROSOFT 422
#define MS3BUTTON 423
#define LOGITECH 424
#define MMSERIES 425
#define MOUSEMAN 426
#define HITACHI 427
#define MOUSESYSTEMS 428
#define BUSMOUSE 429
#define PS2 430
#define IMPS2 431
#define INTERNALDRIVER 432
#define EMULATE3BUTTONS 433
#define CLEARDTR 434
#define L_DISPLAY 435
#define L_TITLE 436
#define X_TITLE_SHOW_APPNAME 437
#define ICON_NAME 438
#define X_KEYCODE 439
#define X_BLINKRATE 440
#define X_SHARECMAP 441
#define X_MITSHM 442
#define X_FONT 443
#define X_FIXED_ASPECT 444
#define X_ASPECT_43 445
#define X_LIN_FILT 446
#define X_BILIN_FILT 447
#define X_MODE13FACT 448
#define X_WINSIZE 449
#define X_GAMMA 450
#define X_FULLSCREEN 451
#define VGAEMU_MEMSIZE 452
#define VESAMODE 453
#define X_LFB 454
#define X_PM_INTERFACE 455
#define X_MGRAB_KEY 456
#define X_BACKGROUND_PAUSE 457
#define SDL_HWREND 458
#define VGA 459
#define MGA 460
#define CGA 461
#define EGA 462
#define NONE 463
#define CONSOLE 464
#define GRAPHICS 465
#define CHIPSET 466
#define FULLREST 467
#define PARTREST 468
#define MEMSIZE 469
#define VBIOS_SIZE_TOK 470
#define VBIOS_SEG 471
#define VGAEMUBIOS_FILE 472
#define VBIOS_FILE 473
#define VBIOS_COPY 474
#define VBIOS_MMAP 475
#define DUALMON 476
#define VBIOS_POST 477
#define FORCE_VT_SWITCH 478
#define PCI 479
#define COLOR 480
#define ESCCHAR 481
#define XTERM_TITLE 482
#define IO 483
#define PORT 484
#define CONFIG 485
#define READ 486
#define WRITE 487
#define KEYB 488
#define PRINTER 489
#define WARNING 490
#define GENERAL 491
#define HARDWARE 492
#define L_IPC 493
#define SOUND 494
#define TRACE 495
#define CLEAR 496
#define LPT 497
#define COMMAND 498
#define TIMEOUT 499
#define L_FILE 500
#define L_PARTITION 501
#define WHOLEDISK 502
#define THREEINCH 503
#define THREEINCH_720 504
#define THREEINCH_2880 505
#define FIVEINCH 506
#define FIVEINCH_360 507
#define READONLY 508
#define LAYOUT 509
#define SECTORS 510
#define CYLINDERS 511
#define TRACKS 512
#define HEADS 513
#define OFFSET 514
#define HDIMAGE 515
#define HDTYPE1 516
#define HDTYPE2 517
#define HDTYPE9 518
#define DISKCYL4096 519
#define RDONLY 520
#define WRONLY 521
#define RDWR 522
#define ORMASK 523
#define ANDMASK 524
#define RANGE 525
#define FAST 526
#define SLOW 527
#define SILLYINT 528
#define USE_SIGIO 529
#define HARDWARE_RAM 530
#define SB_BASE 531
#define SB_IRQ 532
#define SB_DMA 533
#define SB_HDMA 534
#define MPU_BASE 535
#define MPU_IRQ 536
#define MPU_IRQ_MT32 537
#define MIDI_SYNTH 538
#define SOUND_DRIVER 539
#define MIDI_DRIVER 540
#define MUNT_ROMS 541
#define SND_PLUGIN_PARAMS 542
#define PCM_HPF 543
#define MIDI_FILE 544
#define WAV_FILE 545
#define CDROM 546
#define ASPI 547
#define DEVICETYPE 548
#define TARGET 549
#define FEATURE 550
#define JOYSTICK 551
#define JOY_DEVICE 552
#define JOY_DOS_MIN 553
#define JOY_DOS_MAX 554
#define JOY_GRANULARITY 555
#define JOY_LATENCY 556
#define CLI_TIMEOUT 557
#define TIMEMODE 558
#define UNICODE 559
#define SHIFT_ALT_MAP 560
#define CTRL_MAP 561
#define CTRL_ALT_MAP 562
#define INTERNAL 563
#define EXTERNAL 564

/* Value type.  */
#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED

union YYSTYPE
{
#line 206 "parser.y" /* yacc.c:355  */

	int i_value;
	char *s_value;
	float r_value;
	struct {
		enum {
			TYPE_NONE,
			TYPE_INTEGER,
			TYPE_BOOLEAN,
			TYPE_REAL
		} type;
		union {
			int i;
			float r;
		} value;
	} t_value;

#line 914 "parser.c" /* yacc.c:355  */
};

typedef union YYSTYPE YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define YYSTYPE_IS_DECLARED 1
#endif



int yyparse (void);

#endif /* !YY_YY_PARSER_H_INCLUDED  */

/* Copy the second part of user declarations.  */
#line 224 "parser.y" /* yacc.c:358  */

#include "lexer.h"

#line 933 "parser.c" /* yacc.c:358  */

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif

#ifndef YY_ATTRIBUTE
# if (defined __GNUC__                                               \
      && (2 < __GNUC__ || (__GNUC__ == 2 && 96 <= __GNUC_MINOR__)))  \
     || defined __SUNPRO_C && 0x5110 <= __SUNPRO_C
#  define YY_ATTRIBUTE(Spec) __attribute__(Spec)
# else
#  define YY_ATTRIBUTE(Spec) /* empty */
# endif
#endif

#ifndef YY_ATTRIBUTE_PURE
# define YY_ATTRIBUTE_PURE   YY_ATTRIBUTE ((__pure__))
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# define YY_ATTRIBUTE_UNUSED YY_ATTRIBUTE ((__unused__))
#endif

#if !defined _Noreturn \
     && (!defined __STDC_VERSION__ || __STDC_VERSION__ < 201112)
# if defined _MSC_VER && 1200 <= _MSC_VER
#  define _Noreturn __declspec (noreturn)
# else
#  define _Noreturn YY_ATTRIBUTE ((__noreturn__))
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif

#if defined __GNUC__ && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN \
    _Pragma ("GCC diagnostic push") \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")\
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif


#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYSIZE_T yynewbytes;                                            \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / sizeof (*yyptr);                          \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, (Count) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYSIZE_T yyi;                         \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  248
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   3208

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  323
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  89
/* YYNRULES -- Number of rules.  */
#define YYNRULES  511
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  951

/* YYTRANSLATE[YYX] -- Symbol number corresponding to YYX as returned
   by yylex, with out-of-bounds checking.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   564

#define YYTRANSLATE(YYX)                                                \
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, without out-of-bounds checking.  */
static const yytype_uint16 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     320,   321,    36,    34,   322,    35,     2,    37,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,   317,
      27,    26,    28,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,   318,     2,   319,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    29,    30,    31,    32,    33,    38,    39,    40,    41,
      42,    43,    44,    45,    46,    47,    48,    49,    50,    51,
      52,    53,    54,    55,    56,    57,    58,    59,    60,    61,
      62,    63,    64,    65,    66,    67,    68,    69,    70,    71,
      72,    73,    74,    75,    76,    77,    78,    79,    80,    81,
      82,    83,    84,    85,    86,    87,    88,    89,    90,    91,
      92,    93,    94,    95,    96,    97,    98,    99,   100,   101,
     102,   103,   104,   105,   106,   107,   108,   109,   110,   111,
     112,   113,   114,   115,   116,   117,   118,   119,   120,   121,
     122,   123,   124,   125,   126,   127,   128,   129,   130,   131,
     132,   133,   134,   135,   136,   137,   138,   139,   140,   141,
     142,   143,   144,   145,   146,   147,   148,   149,   150,   151,
     152,   153,   154,   155,   156,   157,   158,   159,   160,   161,
     162,   163,   164,   165,   166,   167,   168,   169,   170,   171,
     172,   173,   174,   175,   176,   177,   178,   179,   180,   181,
     182,   183,   184,   185,   186,   187,   188,   189,   190,   191,
     192,   193,   194,   195,   196,   197,   198,   199,   200,   201,
     202,   203,   204,   205,   206,   207,   208,   209,   210,   211,
     212,   213,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,   290,   291,
     292,   293,   294,   295,   296,   297,   298,   299,   300,   301,
     302,   303,   304,   305,   306,   307,   308,   309,   310,   311,
     312,   313,   314,   315,   316
};

#if YYDEBUG
  /* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   355,   355,   356,   357,   360,   361,   364,   366,   367,
     368,   369,   391,   394,   398,   403,   404,   405,   424,   425,
     435,   439,   440,   445,   450,   455,   460,   465,   470,   474,
     478,   483,   493,   502,   507,   522,   532,   542,   548,   554,
     566,   570,   581,   593,   597,   602,   609,   610,   615,   620,
     625,   630,   635,   640,   645,   650,   655,   656,   661,   662,
     667,   668,   676,   677,   678,   679,   680,   681,   682,   697,
     696,   700,   701,   704,   709,   708,   712,   711,   715,   719,
     718,   723,   722,   726,   725,   729,   735,   740,   739,   742,
     744,   743,   748,   747,   751,   764,   776,   775,   779,   780,
     781,   782,   783,   784,   786,   785,   788,   794,   796,   795,
     801,   805,   807,   813,   815,   818,   821,   826,   827,   828,
     829,   831,   833,   835,   839,   841,   843,   847,   851,   863,
     866,   867,   869,   871,   873,   875,   876,   877,   881,   885,
     889,   895,   901,   907,   913,   917,   921,   929,   931,   933,
     935,   937,   939,   941,   943,   945,   947,   949,   950,   951,
     952,   953,   954,   960,   961,   965,   982,   992,   993,   994,
    1007,  1019,  1023,  1026,  1027,  1036,  1037,  1050,  1054,  1062,
    1063,  1065,  1066,  1067,  1068,  1069,  1070,  1071,  1072,  1073,
    1074,  1075,  1076,  1077,  1078,  1079,  1080,  1085,  1090,  1091,
    1092,  1093,  1094,  1095,  1096,  1098,  1099,  1100,  1101,  1105,
    1106,  1108,  1111,  1112,  1115,  1116,  1120,  1132,  1133,  1135,
    1136,  1137,  1138,  1139,  1140,  1141,  1142,  1143,  1144,  1145,
    1151,  1152,  1153,  1154,  1159,  1160,  1162,  1163,  1164,  1165,
    1166,  1171,  1172,  1174,  1175,  1176,  1177,  1178,  1179,  1184,
    1185,  1188,  1191,  1194,  1197,  1198,  1199,  1202,  1203,  1207,
    1211,  1222,  1233,  1234,  1235,  1236,  1237,  1240,  1245,  1246,
    1248,  1249,  1250,  1253,  1262,  1263,  1265,  1266,  1267,  1268,
    1269,  1270,  1271,  1272,  1273,  1274,  1275,  1276,  1277,  1278,
    1279,  1280,  1281,  1282,  1283,  1284,  1285,  1286,  1287,  1288,
    1289,  1290,  1292,  1297,  1298,  1300,  1301,  1302,  1303,  1304,
    1310,  1315,  1320,  1326,  1331,  1336,  1341,  1346,  1351,  1356,
    1361,  1363,  1368,  1369,  1371,  1372,  1372,  1373,  1374,  1375,
    1376,  1379,  1382,  1383,  1386,  1386,  1387,  1387,  1388,  1388,
    1389,  1389,  1390,  1390,  1391,  1391,  1392,  1392,  1395,  1396,
    1399,  1400,  1401,  1402,  1403,  1404,  1405,  1406,  1407,  1408,
    1409,  1410,  1411,  1412,  1413,  1414,  1415,  1424,  1425,  1427,
    1428,  1429,  1430,  1432,  1437,  1438,  1440,  1441,  1453,  1454,
    1455,  1456,  1457,  1458,  1459,  1460,  1461,  1462,  1464,  1469,
    1470,  1472,  1473,  1474,  1475,  1476,  1477,  1479,  1484,  1485,
    1487,  1488,  1489,  1490,  1491,  1492,  1493,  1514,  1520,  1527,
    1529,  1532,  1533,  1535,  1536,  1537,  1538,  1539,  1540,  1541,
    1542,  1543,  1544,  1545,  1551,  1557,  1565,  1572,  1579,  1581,
    1588,  1590,  1595,  1596,  1598,  1605,  1611,  1621,  1631,  1632,
    1633,  1634,  1635,  1636,  1637,  1638,  1639,  1642,  1645,  1646,
    1648,  1650,  1652,  1654,  1656,  1657,  1660,  1665,  1666,  1668,
    1669,  1670,  1671,  1672,  1673,  1674,  1675,  1678,  1683,  1684,
    1686,  1691,  1696,  1701,  1715,  1719,  1723,  1726,  1731,  1732,
    1734,  1740,  1746,  1753,  1760,  1763,  1768,  1771,  1774,  1782,
    1791,  1792,  1793,  1794,  1796,  1801,  1802,  1803,  1804,  1805,
    1806,  1808,  1811,  1812,  1813,  1814,  1815,  1817,  1820,  1821,
    1824,  1825
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || 0
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "INTEGER", "L_OFF", "L_ON", "L_AUTO",
  "L_YES", "L_NO", "CHIPSET_TYPE", "KEYB_LAYOUT", "REAL", "STRING",
  "VARIABLE", "EXPRTEST", "INTCAST", "REALCAST", "AND_OP", "OR_OP",
  "XOR_OP", "SHR_OP", "SHL_OP", "NOT_OP", "EQ_OP", "GE_OP", "LE_OP", "'='",
  "'<'", "'>'", "NEQ_OP", "STR_EQ_OP", "STR_NEQ_OP", "L_AND_OP", "L_OR_OP",
  "'+'", "'-'", "'*'", "'/'", "UMINUS", "UPLUS", "BIT_NOT_OP", "STRLEN",
  "STRTOL", "STRNCMP", "STRCAT", "STRPBRK", "STRSPLIT", "STRCHR",
  "STRRCHR", "STRSTR", "STRDEL", "STRSPN", "STRCSPN", "SHELL", "DEFINED",
  "DEFINE", "UNDEF", "IFSTATEMENT", "WHILESTATEMENT", "FOREACHSTATEMENT",
  "ENTER_USER_SPACE", "LEAVE_USER_SPACE", "CHECKUSERVAR", "DOSBANNER",
  "FASTFLOPPY", "HOGTHRESH", "SPEAKER", "IPXSUPPORT", "IPXNETWORK",
  "NOVELLHACK", "ETHDEV", "TAPDEV", "VDESWITCH", "SLIRPARGS", "VNET",
  "DEBUG", "MOUSE", "SERIAL", "COM", "KEYBOARD", "TERMINAL", "VIDEO",
  "EMURETRACE", "TIMER", "MATHCO", "CPU", "CPUSPEED", "RDTSC", "BOOTDRIVE",
  "SWAP_BOOTDRIVE", "L_XMS", "L_DPMI", "DPMI_LIN_RSV_BASE",
  "DPMI_LIN_RSV_SIZE", "PM_DOS_API", "NO_NULL_CHECKS", "PORTS", "DISK",
  "DOSMEM", "EXT_MEM", "L_EMS", "UMB_A0", "UMB_B0", "UMB_F0", "EMS_SIZE",
  "EMS_FRAME", "EMS_UMA_PAGES", "EMS_CONV_PAGES", "TTYLOCKS", "L_SOUND",
  "L_SND_OSS", "L_JOYSTICK", "FULL_FILE_LOCKS", "DEXE", "ALLOWDISK",
  "FORCEXDOS", "XDOSONLY", "ABORT", "WARN", "L_FLOPPY", "EMUSYS", "EMUINI",
  "L_X", "L_SDL", "DOSEMUMAP", "LOGBUFSIZE", "LOGFILESIZE",
  "MAPPINGDRIVER", "LFN_SUPPORT", "EMULATED", "NATIVE", "CPUEMU", "CPU_VM",
  "VM86", "FULL", "VM86SIM", "FULLSIM", "KVM", "RAWKEYBOARD", "PRESTROKE",
  "KEYTABLE", "SHIFT_MAP", "ALT_MAP", "NUMPAD_MAP", "DUMP", "DGRAVE",
  "DACUTE", "DCIRCUM", "DTILDE", "DBREVE", "DABOVED", "DDIARES", "DABOVER",
  "DDACUTE", "DCEDILLA", "DIOTA", "DOGONEK", "DCARON", "NETWORK",
  "PKTDRIVER", "DIRECTORY", "NAMESTUB", "BINARY", "BASE", "IRQ", "DEVICE",
  "CHARSET", "BAUDRATE", "VIRTUAL", "VMODEM", "PSEUDO", "RTSCTS", "LOWLAT",
  "PCCOM", "MICROSOFT", "MS3BUTTON", "LOGITECH", "MMSERIES", "MOUSEMAN",
  "HITACHI", "MOUSESYSTEMS", "BUSMOUSE", "PS2", "IMPS2", "INTERNALDRIVER",
  "EMULATE3BUTTONS", "CLEARDTR", "L_DISPLAY", "L_TITLE",
  "X_TITLE_SHOW_APPNAME", "ICON_NAME", "X_KEYCODE", "X_BLINKRATE",
  "X_SHARECMAP", "X_MITSHM", "X_FONT", "X_FIXED_ASPECT", "X_ASPECT_43",
  "X_LIN_FILT", "X_BILIN_FILT", "X_MODE13FACT", "X_WINSIZE", "X_GAMMA",
  "X_FULLSCREEN", "VGAEMU_MEMSIZE", "VESAMODE", "X_LFB", "X_PM_INTERFACE",
  "X_MGRAB_KEY", "X_BACKGROUND_PAUSE", "SDL_HWREND", "VGA", "MGA", "CGA",
  "EGA", "NONE", "CONSOLE", "GRAPHICS", "CHIPSET", "FULLREST", "PARTREST",
  "MEMSIZE", "VBIOS_SIZE_TOK", "VBIOS_SEG", "VGAEMUBIOS_FILE",
  "VBIOS_FILE", "VBIOS_COPY", "VBIOS_MMAP", "DUALMON", "VBIOS_POST",
  "FORCE_VT_SWITCH", "PCI", "COLOR", "ESCCHAR", "XTERM_TITLE", "IO",
  "PORT", "CONFIG", "READ", "WRITE", "KEYB", "PRINTER", "WARNING",
  "GENERAL", "HARDWARE", "L_IPC", "SOUND", "TRACE", "CLEAR", "LPT",
  "COMMAND", "TIMEOUT", "L_FILE", "L_PARTITION", "WHOLEDISK", "THREEINCH",
  "THREEINCH_720", "THREEINCH_2880", "FIVEINCH", "FIVEINCH_360",
  "READONLY", "LAYOUT", "SECTORS", "CYLINDERS", "TRACKS", "HEADS",
  "OFFSET", "HDIMAGE", "HDTYPE1", "HDTYPE2", "HDTYPE9", "DISKCYL4096",
  "RDONLY", "WRONLY", "RDWR", "ORMASK", "ANDMASK", "RANGE", "FAST", "SLOW",
  "SILLYINT", "USE_SIGIO", "HARDWARE_RAM", "SB_BASE", "SB_IRQ", "SB_DMA",
  "SB_HDMA", "MPU_BASE", "MPU_IRQ", "MPU_IRQ_MT32", "MIDI_SYNTH",
  "SOUND_DRIVER", "MIDI_DRIVER", "MUNT_ROMS", "SND_PLUGIN_PARAMS",
  "PCM_HPF", "MIDI_FILE", "WAV_FILE", "CDROM", "ASPI", "DEVICETYPE",
  "TARGET", "FEATURE", "JOYSTICK", "JOY_DEVICE", "JOY_DOS_MIN",
  "JOY_DOS_MAX", "JOY_GRANULARITY", "JOY_LATENCY", "CLI_TIMEOUT",
  "TIMEMODE", "UNICODE", "SHIFT_ALT_MAP", "CTRL_MAP", "CTRL_ALT_MAP",
  "INTERNAL", "EXTERNAL", "';'", "'{'", "'}'", "'('", "')'", "','",
  "$accept", "lines", "optdelim", "line", "$@1", "$@2", "$@3", "$@4",
  "$@5", "$@6", "$@7", "$@8", "$@9", "$@10", "$@11", "$@12", "expression",
  "real_expression", "typed_expr", "int_expr", "bool_expr", "real_expr",
  "variable_content", "string_unquoted", "string_expr", "strarglist",
  "strarglist_item", "check_user_var_list", "x_flags", "x_flag",
  "sdl_flags", "sdl_flag", "dexeflags", "dexeflag", "sound_flags",
  "sound_flag", "joystick_flags", "joystick_flag", "video_flags",
  "video_flag", "term_flags", "term_flag", "debug_flags", "debug_flag",
  "mouse_flags", "mouse_flag", "keyboard_flags", "keyboard_flag", "$@13",
  "keyboard_mods", "keyboard_mod", "$@14", "$@15", "$@16", "$@17", "$@18",
  "$@19", "$@20", "keyboard_modvals", "keyboard_modval", "ttylocks_flags",
  "ttylocks_flag", "serial_flags", "serial_flag", "printer_flags",
  "printer_flag", "floppy_flags", "floppy_flag", "disk_flags", "disk_flag",
  "port_flags", "port_flag", "trace_port_flags", "trace_port_flag",
  "sillyint_flags", "sillyint_flag", "ems_flags", "ems_flag",
  "hardware_ram_flags", "hardware_ram_flag", "bool", "floppy_bool",
  "int_bool", "irq_bool", "speaker", "cpuemu", "cpu_vm", "charset_flags",
  "charset_flag", YY_NULLPTR
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[NUM] -- (External) token number corresponding to the
   (internal) symbol number NUM (which must be that of a token).  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,    61,    60,    62,   281,
     282,   283,   284,   285,    43,    45,    42,    47,   286,   287,
     288,   289,   290,   291,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,   316,   317,
     318,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,   344,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,   461,   462,   463,   464,   465,   466,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,   514,   515,   516,   517,
     518,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,   532,   533,   534,   535,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,   550,   551,   552,   553,   554,   555,   556,   557,
     558,   559,   560,   561,   562,   563,   564,    59,   123,   125,
      40,    41,    44
};
# endif

#define YYPACT_NINF -804

#define yypact_value_is_default(Yystate) \
  (!!((Yystate) == (-804)))

#define YYTABLE_NINF -326

#define yytable_value_is_error(Yytable_value) \
  0

  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
     STATE-NUM.  */
static const yytype_int16 yypact[] =
{
    2802,  -804,  -804,   -15,  2068,  -303,    11,    11,  -294,    29,
      48,  -804,  -804,    32,  2068,  2068,  2068,    95,  2068,  2068,
    2068,   141,   141,   141,   141,   141,    76,  -804,  -804,  -804,
    -255,  -804,  2068,  2068,  2068,  1901,  2120,  2068,   141,  2068,
    2068,  2068,  2068,  2068,  2068,  -804,  -804,  2068,  2068,  1012,
    2068,  2068,  2068,  -253,  -247,  1953,  2068,  -234,    76,    76,
    -804,   111,   136,  -231,  -228,   141,  2068,  2068,   141,  2068,
     535,    94,   141,     8,  2068,  -213,  2068,   141,  -804,  2068,
      14,  2068,  -804,  -203,  -201,  -191,  2068,   141,  1400,  -804,
      76,  -804,  -804,  -804,  -804,  -804,  -804,  -804,    72,  -804,
    -189,  -187,  2068,  2068,  2068,  2068,  -182,  -179,  -160,  -155,
    -150,  -145,  -141,  -139,  -132,  -130,  -125,  -119,  -111,  -108,
    2068,  1190,  -804,  -804,  -804,    78,  -804,   112,    76,  -804,
    -804,  -804,  2068,  -159,   -96,  -804,   -93,  -804,  1190,  -804,
    -804,  -804,  -804,  -804,  -804,  -804,  -804,  -804,  -804,  -804,
    -804,  -804,  -804,  -804,  -804,  -804,  -804,  -804,  -804,  2068,
     -88,  -804,   -87,  -804,   -84,   -81,   -60,   113,   -59,  -804,
    -804,  -804,  -804,  -804,   259,  -804,  1190,  -804,  -804,  -804,
    -804,  -804,  -804,  -804,  -804,   -44,   -43,  -804,  -804,    40,
    -804,  -804,  -804,  -804,    36,  2287,   261,  -804,  -804,   -58,
     -87,   -87,   -42,   141,  -804,   141,  -804,  2535,    57,  -804,
    -804,  -804,  -804,  -804,  -804,  -804,  -804,  -804,  -804,  -804,
    -804,  -804,  -804,  -804,  -804,  -804,  -804,  -804,  -804,  -804,
    -804,   141,  -804,  -157,  -804,  -804,   -40,  -804,   -38,   -27,
    -804,  -804,   -26,   141,   141,  2068,  -804,  -804,  -804,  -804,
    2539,  -804,   -87,  2068,  2068,   712,  -804,  -804,  -804,   141,
     141,   141,    76,   141,   141,   141,   141,   141,   141,   141,
     141,    76,    11,   557,  2068,  2068,  2068,  2068,  2068,  2068,
    2068,  2068,  2068,  2068,  2068,  2068,  2068,  2068,  2068,  2068,
    2068,   141,   141,  -149,   -28,   -25,   283,   284,   780,  2905,
      76,  1098,   964,    18,  -804,  -804,  2068,  2068,   138,  -804,
     937,  -804,    37,  1179,  -804,  -804,  -804,  2068,  2068,  2068,
    2068,  2068,    30,  -804,  -804,  -804,   141,   141,  -804,   165,
    -804,  2068,  2068,  2068,  2068,  2068,  2068,  2068,   141,   141,
     141,   141,   141,  2068,   141,   141,  1365,  -804,   141,  2068,
    2068,  2068,  2068,   -91,  -804,  -804,  -804,  -804,    53,  -804,
     663,    -2,    15,   141,   141,  2068,   141,  2068,  2068,  -804,
    2068,   141,  2068,  -804,  -804,  -804,  2068,  2182,  2068,  2068,
    2068,  2234,  2068,  2068,   141,  2068,  1381,  -804,  2068,  -206,
    -804,    23,  -804,   318,   330,  -269,  -804,   390,    13,    66,
      79,    33,    51,   327,  -804,  -804,   927,   950,    38,    45,
      39,  -138,    54,    59,    62,    67,    70,    73,    75,    81,
    -129,    52,  -804,   712,   712,   712,   712,   712,   207,   207,
     207,   207,   207,   207,   170,   170,   163,   163,  -804,  -804,
    -804,  -804,  -804,  -804,  2068,    60,  -804,  -804,  -804,  -804,
    -804,  2068,  2068,  2068,  2068,  2068,  2068,  2068,  2068,  2068,
    2068,  2068,  2068,  2068,  2068,  2068,  2068,  2068,  2068,  2068,
    2068,  2068,  2068,  2068,  2068,   526,  -804,  -804,  -804,  -804,
     141,  2068,  -804,  -804,  -804,  -804,  -804,  -804,  -804,  -804,
    -804,  -804,  -804,  -804,  -804,    71,  -804,  -804,  -804,  -804,
    2068,  2068,  2068,   141,  -804,  -804,  -804,  -804,  -804,  -804,
     100,  -804,  -804,  -804,  2068,   122,   139,  -804,  -804,  -804,
    -804,  -804,  -804,  -804,  -804,  -804,  -804,  -804,  -804,   352,
     373,   379,  -804,  -804,  2068,  2068,  2068,   141,   141,  -804,
    -804,  -804,  -804,  -804,  -804,   221,  -804,  -804,  -804,  -804,
     141,  -804,  -804,  -804,  2068,  2068,  2297,  -804,  -804,  2068,
       9,  -804,  -804,  -804,   141,   141,   141,   141,   381,  -804,
    2068,  2068,  2068,  2068,  2068,   141,  -804,  -804,  -804,  -804,
     209,  -804,  -804,  -804,  -804,  -804,    80,  -804,  -804,  -804,
    -804,  -804,  -804,  -804,  -804,  -804,  -804,  -804,  -804,  -804,
    -804,  -804,  -804,  -804,  -804,  -804,  -804,  -804,  -804,  -804,
    -804,  -804,  -804,  -804,  -804,  -804,  -804,  -804,  -804,  -804,
    -804,   141,   141,   141,  -804,  -804,  -804,  -804,  -804,  -804,
      43,  -804,  -804,  -804,  -804,  -804,  -804,  -804,  -804,  -804,
    -804,  -804,  -804,  -804,   391,    82,  -804,  -804,  -804,   402,
      84,  -804,  -804,  -804,  -804,  -804,  -804,  -804,  -804,  -804,
    1838,  -804,  -804,  -804,  -804,  -804,  -804,  2068,  2068,   141,
    2068,   141,   386,  -804,  -804,  -804,  -804,  -804,  2349,  2068,
      12,  -804,  -804,  -804,  -804,  2401,  2016,  2068,    63,  -804,
    -804,  -804,  -804,  2463,  2068,    58,  -804,  -804,   141,  2068,
    -804,  -804,  -804,  -804,   141,  -804,   141,  2068,   141,   141,
     141,  2068,   141,   141,  -804,  -804,    87,   141,  -804,  -804,
    -804,  -804,  -804,  -804,  -804,  -804,  -804,  -804,  -804,  -804,
    -804,  -804,  -804,  -804,  -804,  -804,  -804,  -804,  -804,  -804,
    -804,  -804,  -804,  -804,  -804,  -804,  -804,  -804,  -804,  -804,
    -804,  -804,  -804,  -804,  -804,  -804,  -804,    91,  -804,  -804,
    -804,  -804,  -804,  -804,  -804,  -804,  -804,  -804,  -804,  -804,
    -804,  -804,  -804,   407,    89,    92,  -804,  -804,  -804,  -804,
    -804,   412,  -804,  -804,  -804,  -804,  -804,  -804,  -804,  -804,
    -804,  -804,  -804,  -804,  -804,  -804,  -804,  -804,  2068,   413,
    2068,  2068,  2068,  2068,  2068,  2068,  2068,   392,  1734,  -804,
    -804,  -804,  -804,  -804,  -804,  -804,  -804,   414,    98,   101,
    -804,  -804,   420,   104,  2515,  -804,   107,  -804,  -804,   427,
     131,   134,  -804,  -804,   155,   140,   142,   144,   145,   149,
     160,   161,   164,   162,   169,  -804,   195,   148,  -804,  2068,
    -804,  -804,  -804,  -804,   196,   434,   459,   465,   466,   493,
     494,  -804,  -804,  -804,  -804,  2068,  -804,  -804,  2068,   531,
     213,  -804,  -804,  2068,  -804,  2068,  -804,  2068,  -804,  2068,
    -804,  -804,  -804,  2068,  -804,  -804,    76,  1838,  -804,  2068,
    -804,  -804,  -804,  -804,  -804,  -804,   561,  -804,  -804,  -804,
    2068,  -804,   210,   216,   223,   224,  -103,  1786,  -804,   561,
     561,   561,   561,   561,   561,  -804,  -804,  -804,  -804,  -804,
    -804,  -804,  -804,  -804,  -804,  -804,  -804,  -804,  -804,  -804,
    2068,  -804,   226,  -804,  -804,  -804,  -804,  -804,  -804,  -804,
    -804,   226,   226,   226,   226,   226,   226,   229,   561,  -804,
    -804
};

  /* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
     Performed when YYTABLE does not specify something else to do.  Zero
     means the default is an error.  */
static const yytype_uint16 yydefact[] =
{
       0,   114,   113,     0,     0,     0,     0,     0,     0,     0,
       0,    15,    16,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    74,    76,    79,    81,
       0,    69,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    87,    90,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      92,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    96,     0,
       0,   104,   108,     0,     0,     0,     0,     0,     0,     2,
       0,   130,   161,   160,   135,   158,   159,   163,   146,   165,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    19,   117,   118,   119,   128,   167,     0,     0,   166,
       9,    10,     0,     0,     0,   177,    18,   486,   115,    44,
     487,    30,     8,   494,   490,   493,   492,   491,    68,    59,
     488,    60,    66,   172,    62,    63,    64,    65,    67,     0,
       0,   175,    73,   173,     0,     0,     0,     0,     0,    45,
      41,    58,    32,    31,   130,    35,   116,    37,    39,    40,
      51,    52,    53,    54,    55,     0,     0,    56,    57,     0,
      47,    48,    49,    50,     0,     0,     0,   102,    28,     0,
      20,    21,     0,     0,    22,     0,    26,     0,     0,    24,
      42,    43,    25,    29,   501,   495,   500,   496,   497,   498,
     499,    34,   507,   502,   506,   505,   503,   504,    33,    85,
      83,     0,    61,     0,    38,    71,     0,   100,     0,     0,
     489,   106,     0,     0,     0,     0,   111,   112,     1,     5,
       0,     3,    17,     0,     0,   157,   125,   124,   134,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   273,   272,     0,     0,     0,   268,
       0,    36,     0,     0,   477,   470,   476,     0,     0,     0,
       0,     0,     0,   468,   373,   372,     0,     0,   371,     0,
     367,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   217,     0,     0,
       0,     0,     0,     0,   234,   214,   215,   216,     0,   212,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   187,
     188,     0,     0,   192,   193,   194,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   179,     0,     0,
     209,     0,    86,     0,     0,     0,   508,     0,     0,     0,
       0,     0,     0,     0,     6,     4,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   129,   131,   132,   133,   126,   127,   147,   149,
     150,   151,   152,   148,   153,   154,   120,   121,   122,   123,
     155,   156,    14,    11,     0,     0,   178,   176,   302,   277,
     301,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   274,   174,   321,   320,
       0,     0,   310,   311,   314,   313,   317,   318,   312,   319,
     315,   316,   306,   307,   309,     0,   303,   388,   387,   386,
       0,     0,     0,     0,   377,   379,   378,   380,   381,   382,
       0,   374,   331,   330,     0,     0,     0,   322,   271,   270,
      72,   269,   267,   266,   243,   244,   245,   246,   247,   252,
     250,     0,   254,   255,     0,     0,     0,     0,     0,   258,
     259,   263,   262,   264,   265,     0,   241,   447,   434,   446,
       0,   438,   439,   440,     0,     0,     0,   443,   444,     0,
       0,   432,   431,   430,     0,     0,     0,     0,     0,   413,
       0,     0,     0,     0,     0,     0,   415,   416,   417,   414,
       0,   411,   472,   473,   474,   475,     0,    46,   469,   369,
     370,    78,   368,   219,   222,   220,   221,   223,   225,   226,
     224,   227,   228,   229,   230,   231,   232,   233,   101,   218,
     236,   237,   238,   239,   240,   103,   235,   107,   213,   410,
     409,     0,     0,     0,   401,   403,   402,   404,   405,   400,
       0,   398,    23,    27,   181,   182,   183,   184,   185,   186,
     189,   190,   191,   195,   130,     0,   198,   199,   200,   130,
       0,   205,   206,   207,   208,    98,   180,   211,    99,   210,
       0,   510,   511,     7,   509,   397,   396,     0,     0,     0,
       0,     0,     0,   389,   456,   450,   455,   454,     0,     0,
       0,   448,   467,   459,   466,     0,     0,     0,     0,   457,
     485,   480,   484,     0,     0,     0,   478,    94,     0,     0,
     136,   164,   138,   137,     0,   168,     0,     0,     0,     0,
       0,     0,     0,     0,   171,   162,     0,     0,   292,   278,
     284,   276,   290,   291,   280,   295,   297,   298,   296,   286,
     287,   279,   281,   282,   283,   285,   288,   289,   293,   294,
     299,   300,    75,   275,   305,   308,    77,   304,   383,   384,
     385,   376,    80,   375,   329,   328,   327,   324,    82,   323,
     253,   251,   248,   249,   261,   260,   257,   256,    70,   242,
     445,   441,   442,   130,     0,     0,    88,   433,   429,   423,
     424,   428,   426,   418,   419,   420,   421,   422,   425,    91,
     412,   471,   406,   408,   407,    93,   399,   196,     0,   201,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   332,
     395,   391,   392,   393,   394,    97,   390,   130,     0,     0,
      89,   449,   130,     0,     0,   461,     0,   105,   458,   130,
       0,     0,   109,   479,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    12,     0,     0,   436,     0,
     435,   427,   197,   202,   203,     0,     0,     0,     0,     0,
       0,   340,    84,   333,   452,     0,   451,   462,     0,   130,
       0,   460,   482,     0,   481,     0,   110,     0,   140,     0,
     141,   142,   143,     0,   144,   145,     0,     0,   437,     0,
     342,   344,   346,   336,   334,   338,     0,   453,   463,   464,
       0,   483,     0,     0,     0,     0,     0,     0,   204,     0,
       0,     0,     0,     0,     0,   364,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   350,
       0,   366,   341,   348,   465,    95,   139,   169,   170,    13,
     326,   343,   345,   347,   337,   335,   339,     0,     0,   365,
     349
};

  /* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -804,  -804,  -804,   -79,  -804,  -804,  -804,  -804,  -804,  -804,
    -804,  -804,  -804,  -804,  -804,  -804,   -13,  -804,  2912,  -804,
    -804,  -804,   666,    -6,  1054,   -51,   251,  -804,  -804,   166,
    -804,   173,  -804,   197,  -804,   208,  -804,   218,  -804,    27,
    -804,   255,  -804,   108,  -804,    93,  -804,    85,  -804,  -308,
    -803,  -804,  -804,  -804,  -804,  -804,  -804,  -804,  -314,  -361,
    -804,   275,  -804,    96,  -804,   -64,  -804,   -21,  -804,    31,
    -804,    50,  -804,   -68,  -804,   -75,  -804,   292,  -804,   -80,
      42,  -804,   484,  -804,  -804,  -804,  -804,  -804,   225
};

  /* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,    88,   250,    89,   168,   160,   164,   165,   166,   391,
     185,   186,   202,   236,   239,   242,   137,   175,   138,   122,
     123,   124,   125,   126,   127,   162,   163,   136,   386,   387,
     389,   390,   358,   359,   346,   347,   353,   354,   545,   546,
     308,   309,   475,   476,   495,   496,   516,   517,   847,   808,
     809,   913,   912,   914,   896,   909,   910,   911,   932,   933,
     329,   330,   510,   511,   672,   673,   630,   631,   580,   581,
     560,   561,   680,   681,   688,   689,   322,   323,   695,   696,
     139,   141,   151,   241,   148,   221,   228,   395,   396
};

  /* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule whose
     number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
     130,   131,   140,   142,   388,   863,   150,   200,   201,   251,
     547,    90,   548,   674,   674,   675,   675,   128,   230,   512,
     170,   549,   173,   129,   676,   676,   132,   150,   150,   150,
     513,   314,   133,   315,   150,   150,   150,   324,   547,   252,
     548,   314,   316,   315,   619,   135,   393,   394,   325,   549,
     663,   134,   316,   210,   211,   620,   355,   356,   357,   690,
     149,   691,   152,   167,   682,   194,   683,   682,   240,   683,
     692,   195,   478,   150,   169,   684,   171,   293,   684,   177,
     690,   179,   691,   479,   199,   183,   184,   207,   129,    99,
     208,   692,   191,   192,   193,   222,   143,   197,   198,   144,
     223,   497,  -166,  -166,   863,   233,   224,   145,  -172,  -172,
     238,   213,   498,   658,   304,   243,   232,   244,   234,   294,
     109,   237,   111,   129,    99,   305,   115,   245,   755,   118,
     756,   253,   757,   254,   317,   318,   319,   320,   259,   304,
     512,   260,   291,   292,   317,   318,   319,   320,   129,    99,
     305,   513,   231,   129,    99,   109,   514,   111,   393,   394,
     261,   115,   621,   295,   118,   262,   324,   355,   356,   357,
     263,   405,   442,   300,   550,   264,   499,   325,   500,   265,
     109,   266,   111,   705,   300,   109,   115,   111,   267,   118,
     268,   115,   714,   300,   118,   269,   326,   327,   328,   289,
     290,   270,   550,   622,   287,   288,   289,   290,   623,   271,
     562,   411,   272,   348,   349,   350,   351,   352,   939,   300,
     420,   563,   522,   225,   146,   147,   296,   226,   615,   297,
     299,   227,   403,   523,   301,   300,   480,   302,   481,   285,
     286,   287,   288,   289,   290,   482,   483,   484,   485,   486,
     487,   488,   489,   490,   491,   492,   493,   494,   303,   310,
     677,   677,   311,   501,   502,   503,   421,   388,   504,   505,
     506,   507,   508,   509,   312,   313,   360,   514,   397,   515,
     398,   551,   552,   553,   554,   555,   556,   557,   558,   678,
     678,   399,   400,   443,   519,   444,   445,   446,   624,   625,
     626,   627,   628,   629,   582,   583,   584,   585,   586,   551,
     552,   553,   554,   555,   556,   557,   558,   632,   593,   594,
     595,   596,   597,   150,   599,   326,   327,   328,   776,   559,
     661,   820,   679,   679,   633,   693,   611,   612,   613,   614,
     685,   660,   662,   685,   686,   306,   307,   686,   518,   587,
     321,   698,   697,   699,   638,   639,   693,   559,   760,   702,
     321,   704,   795,   643,   645,   646,   703,   648,   650,   564,
     306,   307,   617,   715,   565,   657,   706,   832,   694,   761,
     717,   707,   827,   687,   708,   605,   687,   665,   762,   709,
     746,   665,   710,   782,   797,   711,   159,   712,   666,   694,
     515,   791,   666,   713,   798,   799,   800,   636,   845,  -325,
     848,   849,   640,   850,   642,   851,   853,   864,   861,   752,
     865,   647,   866,   867,   651,   652,   868,   654,   871,   203,
     872,   716,   524,   525,   526,   527,   528,   529,   530,   531,
     532,   533,   534,   535,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   873,   205,   874,   875,   520,   758,   876,
     890,   566,   567,   568,   877,   878,   887,   879,   745,   569,
     880,   570,   571,   572,   573,   574,   575,   576,   577,   578,
     579,   881,   882,   884,   591,   891,   883,   748,   749,   750,
     885,   892,   893,   718,   719,   720,   721,   722,   723,   724,
     725,   726,   727,   728,   729,   730,   731,   732,   733,   734,
     735,   736,   737,   738,   739,   740,   741,   886,   889,   894,
     895,   763,   764,   765,   180,   181,   182,   448,   789,   935,
     449,   187,   188,   190,   899,   900,   214,   936,   450,   215,
     768,   771,   772,   774,   937,   938,   775,   216,   948,   667,
     949,   477,   656,   667,   609,   618,   754,   783,   784,   785,
     786,   787,   659,   521,   915,   348,   349,   350,   351,   352,
     246,   616,   769,   129,   274,   275,   276,   277,   278,   907,
     279,   280,   281,   743,   282,   283,   284,   950,   747,   285,
     286,   287,   288,   289,   290,   941,   942,   943,   944,   945,
     946,   759,   451,   452,   592,   453,   753,   454,   816,   796,
     777,   790,   821,   828,   588,   833,   455,   456,     0,     0,
     664,     0,     0,   457,     0,     0,   458,     0,     0,     0,
       0,     0,     0,     0,     0,   668,   669,   670,   671,   668,
     669,   670,   671,     0,     0,     0,     0,   807,   459,   460,
       0,     0,     0,     0,   810,   811,     0,   813,     0,     0,
       0,     0,     0,     0,   619,   818,   819,     0,   217,   218,
     219,   220,   823,   825,   826,   620,     0,     0,     0,     0,
     830,   831,     0,     0,   461,     0,   835,   153,   153,   153,
     153,   153,   153,     0,   838,     0,     0,     0,   842,     0,
       0,     0,     0,     0,   153,   815,   916,   917,   918,   919,
     920,   921,   922,   923,   924,   925,   926,   927,   928,     0,
       0,     0,     0,     0,   153,   153,     0,   153,   153,     0,
       0,   153,     0,     0,   153,   279,   280,   281,   153,   282,
     283,   284,     0,   153,   285,   286,   287,   288,   289,   290,
       0,     0,     0,   153,     0,     0,   153,     0,     0,     0,
       0,   462,   463,   464,   465,   466,   467,   468,   469,   470,
     471,   472,   473,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   621,     0,     0,   852,     0,   854,   855,   856,
     857,   858,   859,   860,   153,   807,     0,   274,   275,   276,
     277,   278,     0,   279,   280,   281,     0,   282,   283,   284,
       0,   870,   285,   286,   287,   288,   289,   290,     0,     0,
     598,     0,     0,   622,     0,     0,     0,     0,   623,   474,
       0,     0,     0,     0,     0,   906,   888,     0,     0,     0,
       0,     0,     0,     0,     0,   742,     0,     0,     0,     0,
       0,     0,   897,     0,     0,   898,     0,     0,     0,     0,
     901,     0,   902,     0,   903,     0,   904,     0,     0,   153,
     905,   153,   929,     0,   807,     0,   908,     0,   422,     0,
       0,   930,     0,     0,     0,     0,     0,   934,     0,     0,
     931,     0,     0,     0,   807,     0,     0,   153,     0,     0,
       0,     0,     0,   931,   931,   931,   931,   931,   931,   153,
     153,     0,     0,     0,     0,     0,     0,   947,   624,   625,
     626,   627,   628,   629,     0,   153,   153,   153,   153,   153,
     153,   153,   153,   153,   153,   153,   153,   153,   522,     0,
       0,     0,   931,     0,   274,   275,   276,   277,   278,   523,
     279,   280,   281,     0,   282,   283,   284,   153,   153,   285,
     286,   287,   288,   289,   290,   497,   153,   274,   275,   276,
     277,   278,     0,   279,   280,   281,   498,   282,   283,   284,
       0,     0,   285,   286,   287,   288,   289,   290,     0,     0,
       0,     0,   153,   153,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   153,   153,   153,   153,   153,     0,
     153,   153,     0,     0,   153,    91,    92,    93,    94,    95,
      96,     0,     0,    97,    98,    99,     0,   100,   101,   153,
     153,     0,   153,     0,   102,     0,     0,   153,     0,     0,
     499,     0,   500,     0,     0,     0,   103,   104,     0,     0,
     153,     0,   105,   106,   107,   108,   109,   110,   111,   112,
     113,   114,   115,   116,   117,   118,   119,     0,     0,     0,
       0,     0,     0,     0,     0,   154,   155,   156,   157,   158,
     161,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   178,     0,     0,     0,     0,     0,     0,   478,
       0,   447,     0,     0,     0,     0,     0,     0,     0,     0,
     479,     0,   161,   161,     0,   204,   206,     0,     0,   209,
       0,     0,   212,     0,     0,     0,   229,   501,   502,   503,
       0,   235,   504,   505,   506,   507,   508,   509,     0,     0,
       0,   247,     0,     0,   161,     0,   153,     0,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
     536,   537,   538,   539,   540,   541,   542,   543,   544,   153,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     562,     0,   161,     0,     0,     0,     0,     0,     0,     0,
       0,   563,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   153,   153,     0,     0,   274,   275,   276,
     277,   278,     0,   279,   280,   281,   153,   282,   283,   284,
       0,     0,   285,   286,   287,   288,   289,   290,     0,     0,
     153,   153,   153,   153,     0,     0,     0,     0,     0,     0,
       0,   153,     0,     0,     0,     0,     0,     0,   700,     0,
       0,     0,     0,     0,     0,     0,     0,   361,     0,   362,
       0,     0,     0,   480,     0,   481,     0,     0,     0,     0,
       0,   701,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   392,     0,   153,   153,   153,
       0,     0,     0,     0,     0,     0,     0,   401,   402,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   408,   409,   410,   161,   412,   413,   414,
     415,   416,   417,   418,   419,   161,     0,     0,     0,     0,
     189,     0,   120,     0,     0,   153,     0,   153,     0,   564,
       0,     0,     0,     0,   565,   440,   441,     0,     0,     0,
       0,     0,     0,     0,   161,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   153,     0,     0,     0,     0,     0,
     153,     0,   153,     0,   153,   153,   153,     0,   153,   153,
     589,   590,     0,   153,     0,     0,     0,     0,     0,     0,
       0,     0,   600,   601,   602,   603,   604,     0,   606,   607,
     248,     1,   610,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     2,     3,     4,     0,     0,   634,   635,     0,
     637,     0,     0,     0,     0,   641,     0,     0,     0,     0,
       0,   566,   567,   568,     0,     0,     0,     0,   653,   569,
       0,   570,   571,   572,   573,   574,   575,   576,   577,   578,
     579,     0,     0,     5,     0,     6,     7,     8,     9,    10,
      11,    12,    13,    14,    15,    16,    17,    18,    19,    20,
      21,    22,    23,    24,    25,    26,    27,    28,     0,    29,
      30,    31,    32,    33,    34,    35,    36,    37,    38,    39,
       0,    40,    41,    42,    43,    44,    45,    46,    47,    48,
      49,    50,    51,    52,     0,     0,     0,     0,    53,    54,
       0,    55,    56,    57,     0,     0,     0,    58,    59,    60,
      61,    62,    63,    64,    65,    66,    67,    68,    69,     0,
       0,    70,    71,     0,   744,     0,     0,     0,     0,    72,
      73,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   153,     0,     0,     0,     0,   751,     0,    74,
       0,     0,     0,     0,     0,     0,    75,     0,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   766,   767,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   770,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   778,   779,
     780,   781,     0,     0,     0,     0,     0,     0,     0,   788,
       0,    76,     0,     0,    77,     0,     0,     0,     0,     0,
       0,    78,     0,     0,     0,     0,    79,    80,   331,   332,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,   344,   345,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   792,   793,   794,     0,     0,
      81,     0,    82,     0,   608,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    83,    84,
     655,     0,    85,     0,     0,     0,     0,     0,     0,    86,
      87,     0,     0,     0,     0,     0,     0,   249,     0,     0,
       0,     0,     0,   812,     0,   814,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    91,    92,    93,
      94,    95,    96,     0,     0,    97,    98,    99,     0,   100,
     101,     0,   834,     0,     0,     0,   102,     0,   836,     0,
     837,     0,   839,   840,   841,     0,   843,   844,   103,   104,
       0,   846,     0,     0,   105,   106,   107,   108,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   118,   119,    91,
      92,    93,    94,    95,    96,     0,     0,    97,    98,    99,
       0,   100,   101,     0,     0,     0,     0,     0,   102,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     103,   104,     0,     0,     0,     0,   105,   106,   107,   108,
     109,   110,   111,   112,   113,   114,   115,   116,   117,   118,
     119,    91,    92,    93,    94,    95,    96,     0,     0,    97,
      98,    99,     0,   100,   101,     0,     0,     0,     0,     0,
     102,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   103,   104,     0,   801,   802,   803,   105,   106,
     107,   108,   109,   110,   111,   112,   113,   114,   115,   116,
     117,   118,   119,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    91,    92,    93,    94,    95,    96,
       0,     0,    97,    98,    99,     0,   100,   101,     0,     0,
       0,     0,     0,   102,     0,     0,     0,   801,   802,   803,
       0,     0,     0,     0,     0,   103,   104,     0,     0,     0,
     161,   105,   106,   107,   108,   109,   110,   111,   112,   113,
     114,   115,   116,   117,   118,   119,    91,    92,    93,    94,
      95,    96,     0,     0,    97,    98,    99,     0,   100,   101,
       0,     0,     0,     0,     0,   102,     0,     0,     0,   801,
     802,   803,     0,     0,     0,     0,     0,   103,   104,     0,
       0,     0,     0,   105,   106,   107,   108,   109,   110,   111,
     112,   113,   114,   115,   116,   117,   118,   119,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    91,
      92,    93,    94,    95,    96,     0,     0,    97,    98,    99,
     172,   100,   101,     0,     0,     0,     0,     0,   102,     0,
       0,     0,     0,     0,     0,     0,   804,   805,   806,     0,
     103,   104,     0,   862,   120,     0,   105,   106,   107,   108,
     109,   110,   111,   112,   113,   114,   115,   116,   117,   118,
     119,    91,    92,    93,    94,    95,    96,     0,     0,    97,
      98,    99,     0,   100,   101,     0,     0,     0,     0,     0,
     102,     0,     0,     0,     0,     0,     0,     0,   804,   805,
     806,     0,   103,   104,     0,   940,   120,     0,   105,   106,
     107,   108,   109,   110,   111,   112,   113,   114,   115,   116,
     117,   118,   119,   174,    92,    93,    94,    95,    96,     0,
       0,    97,    98,    99,     0,   100,   101,     0,     0,     0,
       0,     0,   102,     0,     0,     0,     0,     0,     0,     0,
     804,   805,   806,     0,   103,   104,     0,     0,   120,     0,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   644,    92,    93,    94,    95,
      96,     0,     0,    97,    98,    99,     0,   100,   101,     0,
       0,     0,     0,     0,   102,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   103,   104,     0,     0,
       0,   120,   105,   106,   107,   108,   109,   110,   111,   112,
     113,   114,   115,   116,   117,   118,   119,   649,    92,    93,
      94,    95,    96,     0,     0,    97,    98,    99,     0,   100,
     101,     0,     0,     0,     0,     0,   102,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   103,   104,
       0,   196,     0,   120,   105,   106,   107,   108,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   118,   119,     0,
       0,     0,     0,   824,     0,     0,     0,     0,     0,     0,
     773,    92,    93,    94,    95,    96,     0,     0,    97,    98,
      99,     0,   100,   101,     0,     0,     0,     0,     0,   102,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   103,   104,     0,     0,     0,   120,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   115,   116,   117,
     118,   119,   817,    92,    93,    94,    95,    96,     0,     0,
      97,    98,    99,     0,   100,   101,     0,     0,     0,     0,
       0,   102,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   103,   104,     0,     0,     0,   120,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   118,   119,   822,    92,    93,    94,    95,    96,
       0,     0,    97,    98,    99,     0,   100,   101,     0,     0,
       0,     0,     0,   102,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   103,   104,     0,     0,     0,
     120,   105,   106,   107,   108,   109,   110,   111,   112,   113,
     114,   115,   116,   117,   118,   119,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   829,    92,    93,    94,
      95,    96,     0,     0,    97,    98,    99,     0,   100,   101,
       0,     0,     0,     0,     0,   102,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   103,   104,     0,
       0,     0,   120,   105,   106,   107,   108,   109,   110,   111,
     112,   113,   114,   115,   116,   117,   118,   119,   869,    92,
      93,    94,    95,    96,     0,     0,    97,    98,    99,     0,
     100,   101,     0,     0,     0,     0,     0,   102,     0,     0,
       1,     0,     0,     0,     0,     0,     0,     0,     0,   103,
     104,     2,     3,     4,   120,   105,   106,   107,   108,   109,
     110,   111,   112,   113,   114,   115,   116,   117,   118,   119,
     331,   332,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,   345,     0,     0,     0,     0,     0,
       0,     0,     5,     0,     6,     7,     8,     9,    10,    11,
      12,    13,    14,    15,    16,    17,    18,    19,    20,    21,
      22,    23,    24,    25,    26,    27,    28,   120,    29,    30,
      31,    32,    33,    34,    35,    36,    37,    38,    39,     0,
      40,    41,    42,    43,    44,    45,    46,    47,    48,    49,
      50,    51,    52,     0,     0,     0,     0,    53,    54,     0,
      55,    56,    57,     0,     0,     0,    58,    59,    60,    61,
      62,    63,    64,    65,    66,    67,    68,    69,     0,   120,
      70,    71,     0,     0,     0,     0,     0,     0,    72,    73,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    74,     0,
       0,     0,     0,     0,     0,    75,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   120,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,   378,   379,   380,
     381,   382,   383,   384,   385,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      76,     0,     0,    77,     0,     0,     0,     0,     0,     0,
      78,     0,     0,   120,     0,    79,    80,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     1,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     2,     3,     4,     0,     0,    81,
       0,    82,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   120,     0,    83,    84,     0,
       0,    85,     0,     0,     0,     0,     0,     0,    86,    87,
       0,     0,     0,     0,     0,     5,   404,     6,     7,     8,
       9,    10,    11,    12,    13,    14,    15,    16,    17,    18,
      19,    20,    21,    22,    23,    24,    25,    26,    27,    28,
       0,    29,    30,    31,    32,    33,    34,    35,    36,    37,
      38,    39,     0,    40,    41,    42,    43,    44,    45,    46,
      47,    48,    49,    50,    51,    52,   448,     0,     0,   449,
      53,    54,     0,    55,    56,    57,   121,   450,     0,    58,
      59,    60,    61,    62,    63,    64,    65,    66,    67,    68,
      69,     0,     0,    70,    71,     0,     0,     0,     0,     0,
       0,    72,    73,     0,     0,     0,     0,     0,   176,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    74,     0,     0,     0,     0,     0,     0,    75,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   451,   452,     0,   453,     0,   454,     0,     0,     0,
       0,     0,     0,     0,     0,   455,   456,     0,     0,     0,
       0,     0,   457,     0,     0,   458,     0,     0,     0,     0,
       0,     0,     0,     0,   255,   256,   257,   258,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   459,   460,     0,
       0,     0,   273,    76,     0,     0,    77,     0,     0,     0,
       0,     0,     0,    78,     0,     0,     0,     0,    79,    80,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   461,     0,     0,     0,     0,     0,     0,
       0,   298,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    81,     0,    82,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      83,    84,     0,     0,    85,     0,     0,     0,     0,     0,
       0,    86,    87,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     462,   463,   464,   465,   466,   467,   468,   469,   470,   471,
     472,   473,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   406,   407,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,   439,     0,     0,     0,     0,     0,   474
};

static const yytype_int16 yycheck[] =
{
       6,     7,    15,    16,   210,   808,    19,    58,    59,    88,
       1,    26,     3,     1,     1,     3,     3,   320,    10,     1,
      33,    12,    35,    12,    12,    12,   320,    40,    41,    42,
      12,     1,     3,     3,    47,    48,    49,     1,     1,    90,
       3,     1,    12,     3,     1,    13,   315,   316,    12,    12,
     319,     3,    12,    66,    67,    12,   114,   115,   116,     1,
      18,     3,    20,   318,     1,   318,     3,     1,    81,     3,
      12,   318,     1,    86,    32,    12,    34,   128,    12,    37,
       1,    39,     3,    12,   318,    43,    44,   318,    12,    13,
     318,    12,    50,    51,    52,     1,     1,    55,    56,     4,
       6,     1,    30,    31,   907,   318,    12,    12,    30,    31,
      96,    69,    12,   319,     1,   318,    74,   318,    76,   132,
      44,    79,    46,    12,    13,    12,    50,   318,     6,    53,
       8,   320,    10,   320,   104,   105,   106,   107,   320,     1,
       1,   320,    30,    31,   104,   105,   106,   107,    12,    13,
      12,    12,   144,    12,    13,    44,   138,    46,   315,   316,
     320,    50,   119,   322,    53,   320,     1,   114,   115,   116,
     320,   250,   321,   322,   165,   320,    76,    12,    78,   320,
      44,   320,    46,   321,   322,    44,    50,    46,   320,    53,
     320,    50,   321,   322,    53,   320,   160,   161,   162,    36,
      37,   320,   165,   160,    34,    35,    36,    37,   165,   320,
       1,   262,   320,   304,   305,   306,   307,   308,   321,   322,
     271,    12,     1,   129,   129,   130,   322,   133,   319,   322,
     318,   137,   245,    12,   318,   322,   165,   318,   167,    32,
      33,    34,    35,    36,    37,   174,   175,   176,   177,   178,
     179,   180,   181,   182,   183,   184,   185,   186,   318,   318,
     248,   248,     3,   163,   164,   165,   272,   210,   168,   169,
     170,   171,   172,   173,   318,   318,   318,   138,   318,   261,
     318,   272,   273,   274,   275,   276,   277,   278,   279,   277,
     277,   318,   318,   321,   307,   320,    13,    13,   255,   256,
     257,   258,   259,   260,   317,   318,   319,   320,   321,   272,
     273,   274,   275,   276,   277,   278,   279,   319,   331,   332,
     333,   334,   335,   336,   337,   160,   161,   162,   319,   320,
      12,   319,   320,   320,   319,   277,   349,   350,   351,   352,
     277,   318,    12,   277,   281,   232,   233,   281,   306,   319,
     320,   300,   319,    26,   367,   368,   277,   320,     6,   321,
     320,   322,   319,   376,   377,   378,   321,   380,   381,   160,
     232,   233,   319,   321,   165,   388,   322,   319,   320,     6,
     320,   322,   319,   320,   322,   343,   320,     1,     9,   322,
     319,     1,   322,    12,     3,   322,   320,   322,    12,   320,
     261,   321,    12,   322,   322,     3,   322,   365,   321,   318,
       3,   322,   370,   321,   372,     3,     3,     3,    26,   319,
     322,   379,   321,     3,   382,   383,   322,   385,   321,   318,
       3,   444,   211,   212,   213,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   322,   318,   321,   301,   319,   319,   319,
      26,   252,   253,   254,   322,   321,   318,   322,   481,   260,
     321,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   321,   321,   321,   319,    26,   322,   500,   501,   502,
     321,    26,    26,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,   461,   462,   463,   464,   465,   466,   467,
     468,   469,   470,   471,   472,   473,   474,   322,   322,    26,
      26,   534,   535,   536,    40,    41,    42,     1,   319,   319,
       4,    47,    48,    49,     3,   322,     1,   321,    12,     4,
     319,   554,   555,   556,   321,   321,   559,    12,   322,   163,
     321,   300,   386,   163,   346,   358,   514,   570,   571,   572,
     573,   574,   389,   308,     3,   304,   305,   306,   307,   308,
      86,   353,   545,    12,    17,    18,    19,    20,    21,   887,
      23,    24,    25,   475,    27,    28,    29,   948,   495,    32,
      33,    34,    35,    36,    37,   909,   910,   911,   912,   913,
     914,   516,    76,    77,   329,    79,   510,    81,   672,   630,
     560,   580,   680,   688,   322,   695,    90,    91,    -1,    -1,
     395,    -1,    -1,    97,    -1,    -1,   100,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   249,   250,   251,   252,   249,
     250,   251,   252,    -1,    -1,    -1,    -1,   660,   122,   123,
      -1,    -1,    -1,    -1,   667,   668,    -1,   670,    -1,    -1,
      -1,    -1,    -1,    -1,     1,   678,   679,    -1,   133,   134,
     135,   136,   685,   686,   687,    12,    -1,    -1,    -1,    -1,
     693,   694,    -1,    -1,   158,    -1,   699,    21,    22,    23,
      24,    25,    26,    -1,   707,    -1,    -1,    -1,   711,    -1,
      -1,    -1,    -1,    -1,    38,   319,   145,   146,   147,   148,
     149,   150,   151,   152,   153,   154,   155,   156,   157,    -1,
      -1,    -1,    -1,    -1,    58,    59,    -1,    61,    62,    -1,
      -1,    65,    -1,    -1,    68,    23,    24,    25,    72,    27,
      28,    29,    -1,    77,    32,    33,    34,    35,    36,    37,
      -1,    -1,    -1,    87,    -1,    -1,    90,    -1,    -1,    -1,
      -1,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,   246,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   119,    -1,    -1,   798,    -1,   800,   801,   802,
     803,   804,   805,   806,   128,   808,    -1,    17,    18,    19,
      20,    21,    -1,    23,    24,    25,    -1,    27,    28,    29,
      -1,   824,    32,    33,    34,    35,    36,    37,    -1,    -1,
     336,    -1,    -1,   160,    -1,    -1,    -1,    -1,   165,   303,
      -1,    -1,    -1,    -1,    -1,   886,   849,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   319,    -1,    -1,    -1,    -1,
      -1,    -1,   865,    -1,    -1,   868,    -1,    -1,    -1,    -1,
     873,    -1,   875,    -1,   877,    -1,   879,    -1,    -1,   203,
     883,   205,   311,    -1,   887,    -1,   889,    -1,   321,    -1,
      -1,   320,    -1,    -1,    -1,    -1,    -1,   900,    -1,    -1,
     896,    -1,    -1,    -1,   907,    -1,    -1,   231,    -1,    -1,
      -1,    -1,    -1,   909,   910,   911,   912,   913,   914,   243,
     244,    -1,    -1,    -1,    -1,    -1,    -1,   930,   255,   256,
     257,   258,   259,   260,    -1,   259,   260,   261,   262,   263,
     264,   265,   266,   267,   268,   269,   270,   271,     1,    -1,
      -1,    -1,   948,    -1,    17,    18,    19,    20,    21,    12,
      23,    24,    25,    -1,    27,    28,    29,   291,   292,    32,
      33,    34,    35,    36,    37,     1,   300,    17,    18,    19,
      20,    21,    -1,    23,    24,    25,    12,    27,    28,    29,
      -1,    -1,    32,    33,    34,    35,    36,    37,    -1,    -1,
      -1,    -1,   326,   327,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   338,   339,   340,   341,   342,    -1,
     344,   345,    -1,    -1,   348,     3,     4,     5,     6,     7,
       8,    -1,    -1,    11,    12,    13,    -1,    15,    16,   363,
     364,    -1,   366,    -1,    22,    -1,    -1,   371,    -1,    -1,
      76,    -1,    78,    -1,    -1,    -1,    34,    35,    -1,    -1,
     384,    -1,    40,    41,    42,    43,    44,    45,    46,    47,
      48,    49,    50,    51,    52,    53,    54,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    21,    22,    23,    24,    25,
      26,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    38,    -1,    -1,    -1,    -1,    -1,    -1,     1,
      -1,   321,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      12,    -1,    58,    59,    -1,    61,    62,    -1,    -1,    65,
      -1,    -1,    68,    -1,    -1,    -1,    72,   163,   164,   165,
      -1,    77,   168,   169,   170,   171,   172,   173,    -1,    -1,
      -1,    87,    -1,    -1,    90,    -1,   480,    -1,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   503,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
       1,    -1,   128,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    12,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   537,   538,    -1,    -1,    17,    18,    19,
      20,    21,    -1,    23,    24,    25,   550,    27,    28,    29,
      -1,    -1,    32,    33,    34,    35,    36,    37,    -1,    -1,
     564,   565,   566,   567,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   575,    -1,    -1,    -1,    -1,    -1,    -1,   321,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   203,    -1,   205,
      -1,    -1,    -1,   165,    -1,   167,    -1,    -1,    -1,    -1,
      -1,   321,   174,   175,   176,   177,   178,   179,   180,   181,
     182,   183,   184,   185,   186,   231,    -1,   621,   622,   623,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   243,   244,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,   271,    -1,    -1,    -1,    -1,
     318,    -1,   320,    -1,    -1,   669,    -1,   671,    -1,   160,
      -1,    -1,    -1,    -1,   165,   291,   292,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   300,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   698,    -1,    -1,    -1,    -1,    -1,
     704,    -1,   706,    -1,   708,   709,   710,    -1,   712,   713,
     326,   327,    -1,   717,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   338,   339,   340,   341,   342,    -1,   344,   345,
       0,     1,   348,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    12,    13,    14,    -1,    -1,   363,   364,    -1,
     366,    -1,    -1,    -1,    -1,   371,    -1,    -1,    -1,    -1,
      -1,   252,   253,   254,    -1,    -1,    -1,    -1,   384,   260,
      -1,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,    -1,    -1,    53,    -1,    55,    56,    57,    58,    59,
      60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
      70,    71,    72,    73,    74,    75,    76,    77,    -1,    79,
      80,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      -1,    91,    92,    93,    94,    95,    96,    97,    98,    99,
     100,   101,   102,   103,    -1,    -1,    -1,    -1,   108,   109,
      -1,   111,   112,   113,    -1,    -1,    -1,   117,   118,   119,
     120,   121,   122,   123,   124,   125,   126,   127,   128,    -1,
      -1,   131,   132,    -1,   480,    -1,    -1,    -1,    -1,   139,
     140,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   886,    -1,    -1,    -1,    -1,   503,    -1,   159,
      -1,    -1,    -1,    -1,    -1,    -1,   166,    -1,   187,   188,
     189,   190,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,   202,   203,   204,   205,   206,   207,   208,
     209,   537,   538,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   550,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   564,   565,
     566,   567,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   575,
      -1,   231,    -1,    -1,   234,    -1,    -1,    -1,    -1,    -1,
      -1,   241,    -1,    -1,    -1,    -1,   246,   247,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   621,   622,   623,    -1,    -1,
     280,    -1,   282,    -1,   319,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   298,   299,
     319,    -1,   302,    -1,    -1,    -1,    -1,    -1,    -1,   309,
     310,    -1,    -1,    -1,    -1,    -1,    -1,   317,    -1,    -1,
      -1,    -1,    -1,   669,    -1,   671,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,     3,     4,     5,
       6,     7,     8,    -1,    -1,    11,    12,    13,    -1,    15,
      16,    -1,   698,    -1,    -1,    -1,    22,    -1,   704,    -1,
     706,    -1,   708,   709,   710,    -1,   712,   713,    34,    35,
      -1,   717,    -1,    -1,    40,    41,    42,    43,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,     3,
       4,     5,     6,     7,     8,    -1,    -1,    11,    12,    13,
      -1,    15,    16,    -1,    -1,    -1,    -1,    -1,    22,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      34,    35,    -1,    -1,    -1,    -1,    40,    41,    42,    43,
      44,    45,    46,    47,    48,    49,    50,    51,    52,    53,
      54,     3,     4,     5,     6,     7,     8,    -1,    -1,    11,
      12,    13,    -1,    15,    16,    -1,    -1,    -1,    -1,    -1,
      22,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    34,    35,    -1,   141,   142,   143,    40,    41,
      42,    43,    44,    45,    46,    47,    48,    49,    50,    51,
      52,    53,    54,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,     3,     4,     5,     6,     7,     8,
      -1,    -1,    11,    12,    13,    -1,    15,    16,    -1,    -1,
      -1,    -1,    -1,    22,    -1,    -1,    -1,   141,   142,   143,
      -1,    -1,    -1,    -1,    -1,    34,    35,    -1,    -1,    -1,
     886,    40,    41,    42,    43,    44,    45,    46,    47,    48,
      49,    50,    51,    52,    53,    54,     3,     4,     5,     6,
       7,     8,    -1,    -1,    11,    12,    13,    -1,    15,    16,
      -1,    -1,    -1,    -1,    -1,    22,    -1,    -1,    -1,   141,
     142,   143,    -1,    -1,    -1,    -1,    -1,    34,    35,    -1,
      -1,    -1,    -1,    40,    41,    42,    43,    44,    45,    46,
      47,    48,    49,    50,    51,    52,    53,    54,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,     3,
       4,     5,     6,     7,     8,    -1,    -1,    11,    12,    13,
     129,    15,    16,    -1,    -1,    -1,    -1,    -1,    22,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   312,   313,   314,    -1,
      34,    35,    -1,   319,   320,    -1,    40,    41,    42,    43,
      44,    45,    46,    47,    48,    49,    50,    51,    52,    53,
      54,     3,     4,     5,     6,     7,     8,    -1,    -1,    11,
      12,    13,    -1,    15,    16,    -1,    -1,    -1,    -1,    -1,
      22,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   312,   313,
     314,    -1,    34,    35,    -1,   319,   320,    -1,    40,    41,
      42,    43,    44,    45,    46,    47,    48,    49,    50,    51,
      52,    53,    54,     3,     4,     5,     6,     7,     8,    -1,
      -1,    11,    12,    13,    -1,    15,    16,    -1,    -1,    -1,
      -1,    -1,    22,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     312,   313,   314,    -1,    34,    35,    -1,    -1,   320,    -1,
      40,    41,    42,    43,    44,    45,    46,    47,    48,    49,
      50,    51,    52,    53,    54,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,     3,     4,     5,     6,     7,
       8,    -1,    -1,    11,    12,    13,    -1,    15,    16,    -1,
      -1,    -1,    -1,    -1,    22,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    34,    35,    -1,    -1,
      -1,   320,    40,    41,    42,    43,    44,    45,    46,    47,
      48,    49,    50,    51,    52,    53,    54,     3,     4,     5,
       6,     7,     8,    -1,    -1,    11,    12,    13,    -1,    15,
      16,    -1,    -1,    -1,    -1,    -1,    22,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    34,    35,
      -1,   318,    -1,   320,    40,    41,    42,    43,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    -1,
      -1,    -1,    -1,   277,    -1,    -1,    -1,    -1,    -1,    -1,
       3,     4,     5,     6,     7,     8,    -1,    -1,    11,    12,
      13,    -1,    15,    16,    -1,    -1,    -1,    -1,    -1,    22,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    34,    35,    -1,    -1,    -1,   320,    40,    41,    42,
      43,    44,    45,    46,    47,    48,    49,    50,    51,    52,
      53,    54,     3,     4,     5,     6,     7,     8,    -1,    -1,
      11,    12,    13,    -1,    15,    16,    -1,    -1,    -1,    -1,
      -1,    22,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    34,    35,    -1,    -1,    -1,   320,    40,
      41,    42,    43,    44,    45,    46,    47,    48,    49,    50,
      51,    52,    53,    54,     3,     4,     5,     6,     7,     8,
      -1,    -1,    11,    12,    13,    -1,    15,    16,    -1,    -1,
      -1,    -1,    -1,    22,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    34,    35,    -1,    -1,    -1,
     320,    40,    41,    42,    43,    44,    45,    46,    47,    48,
      49,    50,    51,    52,    53,    54,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,     3,     4,     5,     6,
       7,     8,    -1,    -1,    11,    12,    13,    -1,    15,    16,
      -1,    -1,    -1,    -1,    -1,    22,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    34,    35,    -1,
      -1,    -1,   320,    40,    41,    42,    43,    44,    45,    46,
      47,    48,    49,    50,    51,    52,    53,    54,     3,     4,
       5,     6,     7,     8,    -1,    -1,    11,    12,    13,    -1,
      15,    16,    -1,    -1,    -1,    -1,    -1,    22,    -1,    -1,
       1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    34,
      35,    12,    13,    14,   320,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
     283,   284,   285,   286,   287,   288,   289,   290,   291,   292,
     293,   294,   295,   296,   297,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    53,    -1,    55,    56,    57,    58,    59,    60,
      61,    62,    63,    64,    65,    66,    67,    68,    69,    70,
      71,    72,    73,    74,    75,    76,    77,   320,    79,    80,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    -1,
      91,    92,    93,    94,    95,    96,    97,    98,    99,   100,
     101,   102,   103,    -1,    -1,    -1,    -1,   108,   109,    -1,
     111,   112,   113,    -1,    -1,    -1,   117,   118,   119,   120,
     121,   122,   123,   124,   125,   126,   127,   128,    -1,   320,
     131,   132,    -1,    -1,    -1,    -1,    -1,    -1,   139,   140,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   159,    -1,
      -1,    -1,    -1,    -1,    -1,   166,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   320,   187,   188,   189,   190,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   202,   203,   204,
     205,   206,   207,   208,   209,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     231,    -1,    -1,   234,    -1,    -1,    -1,    -1,    -1,    -1,
     241,    -1,    -1,   320,    -1,   246,   247,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,     1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    12,    13,    14,    -1,    -1,   280,
      -1,   282,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   320,    -1,   298,   299,    -1,
      -1,   302,    -1,    -1,    -1,    -1,    -1,    -1,   309,   310,
      -1,    -1,    -1,    -1,    -1,    53,   317,    55,    56,    57,
      58,    59,    60,    61,    62,    63,    64,    65,    66,    67,
      68,    69,    70,    71,    72,    73,    74,    75,    76,    77,
      -1,    79,    80,    81,    82,    83,    84,    85,    86,    87,
      88,    89,    -1,    91,    92,    93,    94,    95,    96,    97,
      98,    99,   100,   101,   102,   103,     1,    -1,    -1,     4,
     108,   109,    -1,   111,   112,   113,     4,    12,    -1,   117,
     118,   119,   120,   121,   122,   123,   124,   125,   126,   127,
     128,    -1,    -1,   131,   132,    -1,    -1,    -1,    -1,    -1,
      -1,   139,   140,    -1,    -1,    -1,    -1,    -1,    36,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   159,    -1,    -1,    -1,    -1,    -1,    -1,   166,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    76,    77,    -1,    79,    -1,    81,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    90,    91,    -1,    -1,    -1,
      -1,    -1,    97,    -1,    -1,   100,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   102,   103,   104,   105,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   122,   123,    -1,
      -1,    -1,   120,   231,    -1,    -1,   234,    -1,    -1,    -1,
      -1,    -1,    -1,   241,    -1,    -1,    -1,    -1,   246,   247,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   158,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   159,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   280,    -1,   282,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     298,   299,    -1,    -1,   302,    -1,    -1,    -1,    -1,    -1,
      -1,   309,   310,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   253,   254,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   274,   275,   276,   277,
     278,   279,   280,   281,   282,   283,   284,   285,   286,   287,
     288,   289,   290,    -1,    -1,    -1,    -1,    -1,   303
};

  /* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.  */
static const yytype_uint16 yystos[] =
{
       0,     1,    12,    13,    14,    53,    55,    56,    57,    58,
      59,    60,    61,    62,    63,    64,    65,    66,    67,    68,
      69,    70,    71,    72,    73,    74,    75,    76,    77,    79,
      80,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      91,    92,    93,    94,    95,    96,    97,    98,    99,   100,
     101,   102,   103,   108,   109,   111,   112,   113,   117,   118,
     119,   120,   121,   122,   123,   124,   125,   126,   127,   128,
     131,   132,   139,   140,   159,   166,   231,   234,   241,   246,
     247,   280,   282,   298,   299,   302,   309,   310,   324,   326,
      26,     3,     4,     5,     6,     7,     8,    11,    12,    13,
      15,    16,    22,    34,    35,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
     320,   341,   342,   343,   344,   345,   346,   347,   320,    12,
     346,   346,   320,     3,     3,    13,   350,   339,   341,   403,
     339,   404,   339,     1,     4,    12,   129,   130,   407,   403,
     339,   405,   403,   345,   347,   347,   347,   347,   347,   320,
     328,   347,   348,   349,   329,   330,   331,   318,   327,   403,
     339,   403,   129,   339,     3,   340,   341,   403,   347,   403,
     405,   405,   405,   403,   403,   333,   334,   405,   405,   318,
     405,   403,   403,   403,   318,   318,   318,   403,   403,   318,
     348,   348,   335,   318,   347,   318,   347,   318,   318,   347,
     339,   339,   347,   403,     1,     4,    12,   133,   134,   135,
     136,   408,     1,     6,    12,   129,   133,   137,   409,   347,
      10,   144,   403,   318,   403,   347,   336,   403,    96,   337,
     339,   406,   338,   318,   318,   318,   405,   347,     0,   317,
     325,   326,   348,   320,   320,   341,   341,   341,   341,   320,
     320,   320,   320,   320,   320,   320,   320,   320,   320,   320,
     320,   320,   320,   341,    17,    18,    19,    20,    21,    23,
      24,    25,    27,    28,    29,    32,    33,    34,    35,    36,
      37,    30,    31,   348,   339,   322,   322,   322,   341,   318,
     322,   318,   318,   318,     1,    12,   232,   233,   363,   364,
     318,     3,   318,   318,     1,     3,    12,   104,   105,   106,
     107,   320,   399,   400,     1,    12,   160,   161,   162,   383,
     384,   283,   284,   285,   286,   287,   288,   289,   290,   291,
     292,   293,   294,   295,   296,   297,   357,   358,   304,   305,
     306,   307,   308,   359,   360,   114,   115,   116,   355,   356,
     318,   347,   347,   187,   188,   189,   190,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,   203,
     204,   205,   206,   207,   208,   209,   351,   352,   210,   353,
     354,   332,   347,   315,   316,   410,   411,   318,   318,   318,
     318,   347,   347,   339,   317,   326,   341,   341,   347,   347,
     347,   348,   347,   347,   347,   347,   347,   347,   347,   347,
     348,   346,   321,   341,   341,   341,   341,   341,   341,   341,
     341,   341,   341,   341,   341,   341,   341,   341,   341,   341,
     347,   347,   321,   321,   320,    13,    13,   321,     1,     4,
      12,    76,    77,    79,    81,    90,    91,    97,   100,   122,
     123,   158,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   246,   303,   365,   366,   349,     1,    12,
     165,   167,   174,   175,   176,   177,   178,   179,   180,   181,
     182,   183,   184,   185,   186,   367,   368,     1,    12,    76,
      78,   163,   164,   165,   168,   169,   170,   171,   172,   173,
     385,   386,     1,    12,   138,   261,   369,   370,   403,   339,
     319,   364,     1,    12,   211,   212,   213,   214,   215,   216,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   361,   362,     1,     3,    12,
     165,   272,   273,   274,   275,   276,   277,   278,   279,   320,
     393,   394,     1,    12,   160,   165,   252,   253,   254,   260,
     262,   263,   264,   265,   266,   267,   268,   269,   270,   271,
     391,   392,   339,   339,   339,   339,   339,   319,   400,   347,
     347,   319,   384,   339,   339,   339,   339,   339,   405,   339,
     347,   347,   347,   347,   347,   403,   347,   347,   319,   358,
     347,   339,   339,   339,   339,   319,   360,   319,   356,     1,
      12,   119,   160,   165,   255,   256,   257,   258,   259,   260,
     389,   390,   319,   319,   347,   347,   403,   347,   339,   339,
     403,   347,   403,   339,     3,   339,   339,   403,   339,     3,
     339,   403,   403,   347,   403,   319,   352,   339,   319,   354,
     318,    12,    12,   319,   411,     1,    12,   163,   249,   250,
     251,   252,   387,   388,     1,     3,    12,   248,   277,   320,
     395,   396,     1,     3,    12,   277,   281,   320,   397,   398,
       1,     3,    12,   277,   320,   401,   402,   319,   300,    26,
     321,   321,   321,   321,   322,   321,   322,   322,   322,   322,
     322,   322,   322,   322,   321,   321,   339,   320,   403,   403,
     403,   403,   403,   403,   403,   403,   403,   403,   403,   403,
     403,   403,   403,   403,   403,   403,   403,   403,   403,   403,
     403,   403,   319,   366,   347,   339,   319,   368,   339,   339,
     339,   347,   319,   386,   403,     6,     8,    10,   319,   370,
       6,     6,     9,   339,   339,   339,   347,   347,   319,   362,
     347,   339,   339,     3,   339,   339,   319,   394,   347,   347,
     347,   347,    12,   339,   339,   339,   339,   339,   347,   319,
     392,   321,   347,   347,   347,   319,   390,     3,   322,     3,
     322,   141,   142,   143,   312,   313,   314,   339,   372,   373,
     339,   339,   347,   339,   347,   319,   388,     3,   339,   339,
     319,   396,     3,   339,   277,   339,   339,   319,   398,     3,
     339,   339,   319,   402,   347,   339,   347,   347,   339,   347,
     347,   347,   339,   347,   347,   321,   347,   371,     3,   322,
     321,     3,   339,     3,   339,   339,   339,   339,   339,   339,
     339,    26,   319,   373,     3,   322,   321,     3,   322,     3,
     339,   321,     3,   322,   321,   301,   319,   322,   321,   322,
     321,   321,   321,   322,   321,   321,   322,   318,   339,   322,
      26,    26,    26,    26,    26,    26,   377,   339,   339,     3,
     322,   339,   339,   339,   339,   339,   348,   372,   339,   378,
     379,   380,   375,   374,   376,     3,   145,   146,   147,   148,
     149,   150,   151,   152,   153,   154,   155,   156,   157,   311,
     320,   346,   381,   382,   339,   319,   321,   321,   321,   321,
     319,   381,   381,   381,   381,   381,   381,   339,   322,   321,
     382
};

  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint16 yyr1[] =
{
       0,   323,   324,   324,   324,   325,   325,   326,   326,   326,
     326,   326,   326,   326,   326,   326,   326,   326,   326,   326,
     326,   326,   326,   326,   326,   326,   326,   326,   326,   326,
     326,   326,   326,   326,   326,   326,   326,   326,   326,   326,
     326,   326,   326,   326,   326,   326,   326,   326,   326,   326,
     326,   326,   326,   326,   326,   326,   326,   326,   326,   326,
     326,   326,   326,   326,   326,   326,   326,   326,   326,   327,
     326,   326,   326,   326,   328,   326,   329,   326,   326,   330,
     326,   331,   326,   332,   326,   326,   326,   333,   326,   326,
     334,   326,   335,   326,   326,   326,   336,   326,   326,   326,
     326,   326,   326,   326,   337,   326,   326,   326,   338,   326,
     326,   326,   326,   326,   326,   339,   340,   341,   341,   341,
     341,   341,   341,   341,   341,   341,   341,   341,   341,   341,
     342,   342,   342,   342,   342,   342,   342,   342,   342,   342,
     342,   342,   342,   342,   342,   342,   342,   343,   343,   343,
     343,   343,   343,   343,   343,   343,   343,   343,   343,   343,
     343,   343,   343,   344,   344,   345,   346,   347,   347,   347,
     347,   347,   347,   348,   348,   349,   349,   350,   350,   351,
     351,   352,   352,   352,   352,   352,   352,   352,   352,   352,
     352,   352,   352,   352,   352,   352,   352,   352,   352,   352,
     352,   352,   352,   352,   352,   352,   352,   352,   352,   353,
     353,   354,   355,   355,   356,   356,   356,   357,   357,   358,
     358,   358,   358,   358,   358,   358,   358,   358,   358,   358,
     358,   358,   358,   358,   359,   359,   360,   360,   360,   360,
     360,   361,   361,   362,   362,   362,   362,   362,   362,   362,
     362,   362,   362,   362,   362,   362,   362,   362,   362,   362,
     362,   362,   362,   362,   362,   362,   362,   362,   363,   363,
     364,   364,   364,   364,   365,   365,   366,   366,   366,   366,
     366,   366,   366,   366,   366,   366,   366,   366,   366,   366,
     366,   366,   366,   366,   366,   366,   366,   366,   366,   366,
     366,   366,   366,   367,   367,   368,   368,   368,   368,   368,
     368,   368,   368,   368,   368,   368,   368,   368,   368,   368,
     368,   368,   369,   369,   370,   371,   370,   370,   370,   370,
     370,   370,   372,   372,   374,   373,   375,   373,   376,   373,
     377,   373,   378,   373,   379,   373,   380,   373,   381,   381,
     382,   382,   382,   382,   382,   382,   382,   382,   382,   382,
     382,   382,   382,   382,   382,   382,   382,   383,   383,   384,
     384,   384,   384,   384,   385,   385,   386,   386,   386,   386,
     386,   386,   386,   386,   386,   386,   386,   386,   386,   387,
     387,   388,   388,   388,   388,   388,   388,   388,   389,   389,
     390,   390,   390,   390,   390,   390,   390,   390,   390,   390,
     390,   391,   391,   392,   392,   392,   392,   392,   392,   392,
     392,   392,   392,   392,   392,   392,   392,   392,   392,   392,
     392,   392,   393,   393,   394,   394,   394,   394,   394,   394,
     394,   394,   394,   394,   394,   394,   394,   394,   395,   395,
     396,   396,   396,   396,   396,   396,   396,   397,   397,   398,
     398,   398,   398,   398,   398,   398,   398,   398,   399,   399,
     400,   400,   400,   400,   400,   400,   400,   400,   401,   401,
     402,   402,   402,   402,   402,   402,   403,   404,   405,   406,
     407,   407,   407,   407,   407,   408,   408,   408,   408,   408,
     408,   408,   409,   409,   409,   409,   409,   409,   410,   410,
     411,   411
};

  /* YYR2[YYN] -- Number of symbols on the right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     1,     2,     3,     1,     2,     4,     2,     2,
       2,     4,     6,     9,     4,     1,     1,     3,     2,     2,
       2,     2,     2,     4,     2,     2,     2,     4,     2,     2,
       2,     2,     2,     2,     2,     2,     3,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     4,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     0,
       5,     2,     4,     2,     0,     5,     0,     5,     4,     0,
       5,     0,     5,     0,     6,     2,     3,     0,     5,     5,
       0,     5,     0,     5,     4,     8,     0,     5,     4,     4,
       2,     4,     2,     4,     0,     5,     2,     4,     0,     5,
       6,     2,     2,     1,     1,     1,     1,     1,     1,     1,
       3,     3,     3,     3,     2,     2,     3,     3,     1,     3,
       1,     3,     3,     3,     2,     1,     4,     4,     4,     8,
       6,     6,     6,     6,     6,     6,     1,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     2,     1,     1,
       1,     1,     4,     1,     4,     1,     1,     1,     4,     8,
       8,     4,     1,     1,     3,     1,     3,     1,     3,     1,
       2,     2,     2,     2,     2,     2,     2,     1,     1,     2,
       2,     2,     1,     1,     1,     2,     3,     4,     2,     2,
       2,     3,     4,     4,     6,     2,     2,     2,     2,     1,
       2,     2,     1,     2,     1,     1,     1,     1,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     1,     2,     2,     2,     2,     2,
       2,     1,     2,     1,     1,     1,     1,     1,     2,     2,
       1,     2,     1,     2,     1,     1,     2,     2,     1,     1,
       2,     2,     1,     1,     1,     1,     1,     1,     1,     2,
       2,     2,     1,     1,     1,     2,     2,     1,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     1,     1,     1,     2,     2,     1,     1,     2,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     2,     2,     0,     6,     2,     2,     2,
       1,     1,     1,     2,     0,     5,     0,     5,     0,     5,
       0,     4,     0,     5,     0,     5,     0,     5,     1,     3,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     3,     1,     1,     2,     2,
       2,     1,     1,     1,     1,     2,     2,     1,     1,     1,
       1,     1,     1,     2,     2,     2,     1,     1,     1,     1,
       2,     2,     2,     2,     2,     2,     1,     1,     1,     2,
       1,     1,     1,     1,     1,     1,     2,     2,     2,     1,
       1,     1,     2,     1,     1,     1,     1,     1,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     3,     2,     2,
       1,     1,     1,     2,     1,     3,     3,     4,     1,     1,
       1,     2,     2,     1,     1,     2,     1,     1,     1,     2,
       1,     3,     3,     4,     1,     1,     1,     1,     2,     1,
       3,     2,     3,     4,     4,     5,     1,     1,     1,     2,
       1,     3,     2,     2,     2,     2,     1,     1,     1,     2,
       1,     3,     3,     4,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     2,
       2,     2
};


#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)
#define YYEMPTY         (-2)
#define YYEOF           0

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                  \
do                                                              \
  if (yychar == YYEMPTY)                                        \
    {                                                           \
      yychar = (Token);                                         \
      yylval = (Value);                                         \
      YYPOPSTACK (yylen);                                       \
      yystate = *yyssp;                                         \
      goto yybackup;                                            \
    }                                                           \
  else                                                          \
    {                                                           \
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;                                                  \
    }                                                           \
while (0)

/* Error token number */
#define YYTERROR        1
#define YYERRCODE       256



/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)

/* This macro is provided for backward compatibility. */
#ifndef YY_LOCATION_PRINT
# define YY_LOCATION_PRINT(File, Loc) ((void) 0)
#endif


# define YY_SYMBOL_PRINT(Title, Type, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Type, Value); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*----------------------------------------.
| Print this symbol's value on YYOUTPUT.  |
`----------------------------------------*/

static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
{
  FILE *yyo = yyoutput;
  YYUSE (yyo);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# endif
  YYUSE (yytype);
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
{
  YYFPRINTF (yyoutput, "%s %s (",
             yytype < YYNTOKENS ? "token" : "nterm", yytname[yytype]);

  yy_symbol_value_print (yyoutput, yytype, yyvaluep);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yytype_int16 *yyssp, YYSTYPE *yyvsp, int yyrule)
{
  unsigned long int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       yystos[yyssp[yyi + 1 - yynrhs]],
                       &(yyvsp[(yyi + 1) - (yynrhs)])
                                              );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
yystrlen (const char *yystr)
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
yystpcpy (char *yydest, const char *yysrc)
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
        switch (*++yyp)
          {
          case '\'':
          case ',':
            goto do_not_strip_quotes;

          case '\\':
            if (*++yyp != '\\')
              goto do_not_strip_quotes;
            /* Fall through.  */
          default:
            if (yyres)
              yyres[yyn] = *yyp;
            yyn++;
            break;

          case '"':
            if (yyres)
              yyres[yyn] = '\0';
            return yyn;
          }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return 1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return 2 if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYSIZE_T *yymsg_alloc, char **yymsg,
                yytype_int16 *yyssp, int yytoken)
{
  YYSIZE_T yysize0 = yytnamerr (YY_NULLPTR, yytname[yytoken]);
  YYSIZE_T yysize = yysize0;
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULLPTR;
  /* Arguments of yyformat. */
  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Number of reported tokens (one for the "unexpected", one per
     "expected"). */
  int yycount = 0;

  /* There are many possibilities here to consider:
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yytoken != YYEMPTY)
    {
      int yyn = yypact[*yyssp];
      yyarg[yycount++] = yytname[yytoken];
      if (!yypact_value_is_default (yyn))
        {
          /* Start YYX at -YYN if negative to avoid negative indexes in
             YYCHECK.  In other words, skip the first -YYN actions for
             this state because they are default actions.  */
          int yyxbegin = yyn < 0 ? -yyn : 0;
          /* Stay within bounds of both yycheck and yytname.  */
          int yychecklim = YYLAST - yyn + 1;
          int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
          int yyx;

          for (yyx = yyxbegin; yyx < yyxend; ++yyx)
            if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR
                && !yytable_value_is_error (yytable[yyx + yyn]))
              {
                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    yycount = 1;
                    yysize = yysize0;
                    break;
                  }
                yyarg[yycount++] = yytname[yyx];
                {
                  YYSIZE_T yysize1 = yysize + yytnamerr (YY_NULLPTR, yytname[yyx]);
                  if (! (yysize <= yysize1
                         && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
                    return 2;
                  yysize = yysize1;
                }
              }
        }
    }

  switch (yycount)
    {
# define YYCASE_(N, S)                      \
      case N:                               \
        yyformat = S;                       \
      break
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
# undef YYCASE_
    }

  {
    YYSIZE_T yysize1 = yysize + yystrlen (yyformat);
    if (! (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
      return 2;
    yysize = yysize1;
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return 1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yyarg[yyi++]);
          yyformat += 2;
        }
      else
        {
          yyp++;
          yyformat++;
        }
  }
  return 0;
}
#endif /* YYERROR_VERBOSE */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
{
  YYUSE (yyvaluep);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YYUSE (yytype);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}




/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
/* The lookahead symbol.  */
int yychar;


/* The semantic value of the lookahead symbol.  */
/* Default value used for initialization, for pacifying older GCCs
   or non-GCC compilers.  */
YY_INITIAL_VALUE (static YYSTYPE yyval_default;)
YYSTYPE yylval YY_INITIAL_VALUE (= yyval_default);

    /* Number of syntax errors so far.  */
    int yynerrs;

    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       'yyss': related to states.
       'yyvs': related to semantic values.

       Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yyssp = yyss = yyssa;
  yyvsp = yyvs = yyvsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */
  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        YYSTYPE *yyvs1 = yyvs;
        yytype_int16 *yyss1 = yyss;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * sizeof (*yyssp),
                    &yyvs1, yysize * sizeof (*yyvsp),
                    &yystacksize);

        yyss = yyss1;
        yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yytype_int16 *yyss1 = yyss;
        union yyalloc *yyptr =
          (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
        if (! yyptr)
          goto yyexhaustedlab;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
                  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = yylex (&yylval);
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 7:
#line 364 "parser.y" /* yacc.c:1646  */
    {}
#line 3230 "parser.c" /* yacc.c:1646  */
    break;

  case 8:
#line 366 "parser.y" /* yacc.c:1646  */
    { config.hogthreshold = (yyvsp[0].i_value); }
#line 3236 "parser.c" /* yacc.c:1646  */
    break;

  case 9:
#line 367 "parser.y" /* yacc.c:1646  */
    { IFCLASS(CL_VAR){ define_config_variable((yyvsp[0].s_value));} free((yyvsp[0].s_value)); }
#line 3242 "parser.c" /* yacc.c:1646  */
    break;

  case 10:
#line 368 "parser.y" /* yacc.c:1646  */
    { IFCLASS(CL_VAR){ undefine_config_variable((yyvsp[0].s_value));} free((yyvsp[0].s_value)); }
#line 3248 "parser.c" /* yacc.c:1646  */
    break;

  case 11:
#line 369 "parser.y" /* yacc.c:1646  */
    {
			/* NOTE:
			 * We _need_ absolutely to return to state stack 0
			 * because we 'backward' modify the input stream for
			 * the parser (in lexer). Hence, _if_ the parser needs
			 * to read one token more than needed, we are lost,
			 * because we can't discard it. So please, don't
			 * play with the grammar without knowing what you do.
			 * The ')' _will_ return to state stack 0, but fiddling
			 * with brackets '()' in the underlaying 'expression'
			 * rules may distroy this.
			 *                          -- Hans 971231
			 */
			tell_lexer_if((yyvsp[-1].i_value));
		}
#line 3268 "parser.c" /* yacc.c:1646  */
    break;

  case 12:
#line 391 "parser.y" /* yacc.c:1646  */
    {
			tell_lexer_loop((yyvsp[-4].i_value), (yyvsp[-1].i_value));
		}
#line 3276 "parser.c" /* yacc.c:1646  */
    break;

  case 13:
#line 394 "parser.y" /* yacc.c:1646  */
    {
			tell_lexer_loop((yyvsp[-7].i_value), for_each_handling((yyvsp[-7].i_value),(yyvsp[-5].s_value),(yyvsp[-3].s_value),(yyvsp[-1].s_value)));
			free((yyvsp[-5].s_value)); free((yyvsp[-3].s_value)); free((yyvsp[-1].s_value));
		}
#line 3285 "parser.c" /* yacc.c:1646  */
    break;

  case 14:
#line 398 "parser.y" /* yacc.c:1646  */
    {
			char *s = run_shell((yyvsp[-1].s_value));
			if (s) free(s);
			free((yyvsp[-1].s_value));
		}
#line 3295 "parser.c" /* yacc.c:1646  */
    break;

  case 15:
#line 403 "parser.y" /* yacc.c:1646  */
    { enter_user_scope((yyvsp[0].i_value)); }
#line 3301 "parser.c" /* yacc.c:1646  */
    break;

  case 16:
#line 404 "parser.y" /* yacc.c:1646  */
    { leave_user_scope((yyvsp[0].i_value)); }
#line 3307 "parser.c" /* yacc.c:1646  */
    break;

  case 17:
#line 405 "parser.y" /* yacc.c:1646  */
    {
		    if (!parser_version_3_style_used) {
			parser_version_3_style_used = 1;
			define_config_variable(CONFNAME_V3USED);
		    }
		    if ((strpbrk((yyvsp[-2].s_value), "uhc") == (yyvsp[-2].s_value)) && ((yyvsp[-2].s_value)[1] == '_'))
			yyerror("reserved variable %s can't be set\n", (yyvsp[-2].s_value));
		    else {
			if (user_scope_level) {
			    char *s = malloc(strlen((yyvsp[-2].s_value))+sizeof(USERVAR_PREF));
			    strcpy(s, USERVAR_PREF);
			    strcat(s,(yyvsp[-2].s_value));
			    setenv(s, (yyvsp[0].s_value), 1);
			    free(s);
			}
			else IFCLASS(CL_VAR) setenv((yyvsp[-2].s_value), (yyvsp[0].s_value), 1);
		    }
		    free((yyvsp[-2].s_value)); free((yyvsp[0].s_value));
		}
#line 3331 "parser.c" /* yacc.c:1646  */
    break;

  case 19:
#line 425 "parser.y" /* yacc.c:1646  */
    {
		    if ((yyvsp[0].t_value).type == TYPE_REAL)
			c_printf("CONF TESTING: exprtest real %f\n", (yyvsp[0].t_value).value.r);
		    else
			c_printf("CONF TESTING: exprtest int %d\n", (yyvsp[0].t_value).value.i);
		}
#line 3342 "parser.c" /* yacc.c:1646  */
    break;

  case 20:
#line 436 "parser.y" /* yacc.c:1646  */
    { if ((yyvsp[0].s_value)[0]) fprintf(stderr,"CONF aborted with: %s\n", (yyvsp[0].s_value));
			exit(99);
		    }
#line 3350 "parser.c" /* yacc.c:1646  */
    break;

  case 21:
#line 439 "parser.y" /* yacc.c:1646  */
    { c_printf("CONF: %s\n", (yyvsp[0].s_value)); free((yyvsp[0].s_value)); }
#line 3356 "parser.c" /* yacc.c:1646  */
    break;

  case 22:
#line 441 "parser.y" /* yacc.c:1646  */
    {
		    free(config.emusys); config.emusys = (yyvsp[0].s_value);
		    c_printf("CONF: config.emusys = '%s'\n", (yyvsp[0].s_value));
		    }
#line 3365 "parser.c" /* yacc.c:1646  */
    break;

  case 23:
#line 446 "parser.y" /* yacc.c:1646  */
    {
		    free(config.emusys); config.emusys = (yyvsp[-1].s_value);
		    c_printf("CONF: config.emusys = '%s'\n", (yyvsp[-1].s_value));
		    }
#line 3374 "parser.c" /* yacc.c:1646  */
    break;

  case 24:
#line 451 "parser.y" /* yacc.c:1646  */
    {
		    DOSEMU_MAP_PATH = (yyvsp[0].s_value);
		    c_printf("CONF: dosemu.map path = '%s'\n", (yyvsp[0].s_value));
		    }
#line 3383 "parser.c" /* yacc.c:1646  */
    break;

  case 25:
#line 456 "parser.y" /* yacc.c:1646  */
    {
		    free(config.mappingdriver); config.mappingdriver = (yyvsp[0].s_value);
		    c_printf("CONF: mapping driver = '%s'\n", (yyvsp[0].s_value));
		    }
#line 3392 "parser.c" /* yacc.c:1646  */
    break;

  case 26:
#line 461 "parser.y" /* yacc.c:1646  */
    {
                    free(config.emuini); config.emuini = (yyvsp[0].s_value);
                    c_printf("CONF: config.emuini = '%s'\n", (yyvsp[0].s_value));
                    }
#line 3401 "parser.c" /* yacc.c:1646  */
    break;

  case 27:
#line 466 "parser.y" /* yacc.c:1646  */
    {
                    free(config.emuini); config.emuini = (yyvsp[-1].s_value);
                    c_printf("CONF: config.emuini = '%s'\n", (yyvsp[-1].s_value));
		    }
#line 3410 "parser.c" /* yacc.c:1646  */
    break;

  case 28:
#line 471 "parser.y" /* yacc.c:1646  */
    {
		    config.full_file_locks = ((yyvsp[0].i_value)!=0);
		    }
#line 3418 "parser.c" /* yacc.c:1646  */
    break;

  case 29:
#line 475 "parser.y" /* yacc.c:1646  */
    {
		    config.lfn = ((yyvsp[0].i_value)!=0);
		    }
#line 3426 "parser.c" /* yacc.c:1646  */
    break;

  case 30:
#line 479 "parser.y" /* yacc.c:1646  */
    {
			config.fastfloppy = ((yyvsp[0].i_value)!=0);
			c_printf("CONF: fastfloppy = %d\n", config.fastfloppy);
			}
#line 3435 "parser.c" /* yacc.c:1646  */
    break;

  case 31:
#line 484 "parser.y" /* yacc.c:1646  */
    {
			int cpu = cpu_override (((yyvsp[0].i_value)%100)==86?((yyvsp[0].i_value)/100)%10:0);
			if (cpu > 0) {
				c_printf("CONF: CPU set to %d86\n",cpu);
				vm86s.cpu_type = cpu;
			}
			else
				yyerror("error in CPU user override\n");
			}
#line 3449 "parser.c" /* yacc.c:1646  */
    break;

  case 32:
#line 494 "parser.y" /* yacc.c:1646  */
    {
			vm86s.cpu_type = 5;
#ifdef X86_EMULATOR
			config.cpuemu = 1;
			c_printf("CONF: CPUEMU set to %d for %d86\n",
				config.cpuemu, (int)vm86s.cpu_type);
#endif
			}
#line 3462 "parser.c" /* yacc.c:1646  */
    break;

  case 33:
#line 503 "parser.y" /* yacc.c:1646  */
    {
			config.cpu_vm = (yyvsp[0].i_value);
			c_printf("CONF: CPU VM set to %d\n", config.cpu_vm);
			}
#line 3471 "parser.c" /* yacc.c:1646  */
    break;

  case 34:
#line 508 "parser.y" /* yacc.c:1646  */
    {
#ifdef X86_EMULATOR
			config.cpuemu = (yyvsp[0].i_value);
			if (config.cpuemu > 4) {
				config.cpuemu -= 2;
#ifdef HOST_ARCH_X86
				config.cpusim = 1;
#endif
			}
			c_printf("CONF: %s CPUEMU set to %d for %d86\n",
				CONFIG_CPUSIM ? "simulated" : "JIT",
				config.cpuemu, (int)vm86s.cpu_type);
#endif
			}
#line 3490 "parser.c" /* yacc.c:1646  */
    break;

  case 35:
#line 523 "parser.y" /* yacc.c:1646  */
    { 
#if 0 /* no longer used, but left in for dosemu.conf compatibility */
			if (config.realcpu >= CPU_586) {
			  config.cpu_spd = ((double)LLF_US)/(yyvsp[0].r_value);
			  config.cpu_tick_spd = ((double)LLF_TICKS)/(yyvsp[0].r_value);
			  c_printf("CONF: CPU speed = %g\n", ((double)(yyvsp[0].r_value)));
			}
#endif
			}
#line 3504 "parser.c" /* yacc.c:1646  */
    break;

  case 36:
#line 533 "parser.y" /* yacc.c:1646  */
    { 
#if 0 /* no longer used, but left in for dosemu.conf compatibility */
			if (config.realcpu >= CPU_586) {
			  config.cpu_spd = (LLF_US*(yyvsp[0].i_value))/(yyvsp[-1].i_value);
			  config.cpu_tick_spd = (LLF_TICKS*(yyvsp[0].i_value))/(yyvsp[-1].i_value);
			  c_printf("CONF: CPU speed = %d/%d\n", (yyvsp[-1].i_value), (yyvsp[0].i_value));
			}
#endif
			}
#line 3518 "parser.c" /* yacc.c:1646  */
    break;

  case 37:
#line 543 "parser.y" /* yacc.c:1646  */
    {
			config.rdtsc = ((yyvsp[0].i_value)!=0);
			c_printf("CONF: %sabling use of pentium timer\n",
				(config.rdtsc?"En":"Dis"));
		    }
#line 3528 "parser.c" /* yacc.c:1646  */
    break;

  case 38:
#line 549 "parser.y" /* yacc.c:1646  */
    {
		      config.pci_video = ((yyvsp[0].i_value)!=0);
		      IFCLASS(CL_PCI) {}
		      config.pci = (abs((yyvsp[0].i_value))==2); 
		    }
#line 3538 "parser.c" /* yacc.c:1646  */
    break;

  case 39:
#line 555 "parser.y" /* yacc.c:1646  */
    {
                      if ((yyvsp[0].s_value)[0] == 0) {
		        config.hdiskboot = -1;
		      } else if ((yyvsp[0].s_value)[0] >= 'a') {
		        config.hdiskboot = (yyvsp[0].s_value)[0] - 'a';
		      } else {
		        error("wrong value for $_bootdrive\n");
		        config.hdiskboot = 2;
		      }
		      free((yyvsp[0].s_value));
		    }
#line 3554 "parser.c" /* yacc.c:1646  */
    break;

  case 40:
#line 567 "parser.y" /* yacc.c:1646  */
    {
		      config.swap_bootdrv = ((yyvsp[0].i_value)!=0);
		    }
#line 3562 "parser.c" /* yacc.c:1646  */
    break;

  case 41:
#line 571 "parser.y" /* yacc.c:1646  */
    {
		    config.freq = (yyvsp[0].i_value);
		    if ((yyvsp[0].i_value)) {
		        config.update = 1000000 / (yyvsp[0].i_value);
		    } else {
			config.update = 54925;
			config.freq = 18;
		    }
		    c_printf("CONF: timer freq=%d, update=%d\n",config.freq,config.update);
		    }
#line 3577 "parser.c" /* yacc.c:1646  */
    break;

  case 42:
#line 582 "parser.y" /* yacc.c:1646  */
    {
		      char *b;
		      flush_log();
		      b = malloc((yyvsp[0].i_value)+1024);
		      if (!b) {
			error("cannot get logbuffer\n");
			exit(1);
		      }
		      logptr = logbuf = b;
		      logbuf_size = (yyvsp[0].i_value);
		    }
#line 3593 "parser.c" /* yacc.c:1646  */
    break;

  case 43:
#line 594 "parser.y" /* yacc.c:1646  */
    {
		      logfile_limit = (yyvsp[0].i_value);
		    }
#line 3601 "parser.c" /* yacc.c:1646  */
    break;

  case 44:
#line 598 "parser.y" /* yacc.c:1646  */
    {
		    config.dosbanner = ((yyvsp[0].i_value)!=0);
		    c_printf("CONF: dosbanner %s\n", ((yyvsp[0].i_value)) ? "on" : "off");
		    }
#line 3610 "parser.c" /* yacc.c:1646  */
    break;

  case 45:
#line 603 "parser.y" /* yacc.c:1646  */
    { IFCLASS(CL_VPORT){
		    if ((yyvsp[0].i_value) && !config.emuretrace && priv_lvl)
		      yyerror("Can not modify video port access in user config file");
		    config.emuretrace = ((yyvsp[0].i_value)!=0);
		    c_printf("CONF: emu_retrace %s\n", ((yyvsp[0].i_value)) ? "on" : "off");
		    }}
#line 3621 "parser.c" /* yacc.c:1646  */
    break;

  case 47:
#line 611 "parser.y" /* yacc.c:1646  */
    {
		    if ((yyvsp[0].i_value) >= 0) config.ems_size = (yyvsp[0].i_value);
		    if ((yyvsp[0].i_value) > 0) c_printf("CONF: %dk bytes EMS memory\n", (yyvsp[0].i_value));
		    }
#line 3630 "parser.c" /* yacc.c:1646  */
    break;

  case 48:
#line 616 "parser.y" /* yacc.c:1646  */
    {
		    config.umb_a0 = (yyvsp[0].i_value);
		    if ((yyvsp[0].i_value) > 0) c_printf("CONF: umb at 0a0000: %s\n", ((yyvsp[0].i_value)) ? "on" : "off");
		    }
#line 3639 "parser.c" /* yacc.c:1646  */
    break;

  case 49:
#line 621 "parser.y" /* yacc.c:1646  */
    {
		    config.umb_b0 = ((yyvsp[0].i_value)!=0);
		    if ((yyvsp[0].i_value) > 0) c_printf("CONF: umb at 0b0000: %s\n", ((yyvsp[0].i_value)) ? "on" : "off");
		    }
#line 3648 "parser.c" /* yacc.c:1646  */
    break;

  case 50:
#line 626 "parser.y" /* yacc.c:1646  */
    {
		    config.umb_f0 = ((yyvsp[0].i_value)!=0);
		    if ((yyvsp[0].i_value) > 0) c_printf("CONF: umb at 0f0000: %s\n", ((yyvsp[0].i_value)) ? "on" : "off");
		    }
#line 3657 "parser.c" /* yacc.c:1646  */
    break;

  case 51:
#line 631 "parser.y" /* yacc.c:1646  */
    {
		    if ((yyvsp[0].i_value)>=0) config.dpmi = (yyvsp[0].i_value);
		    c_printf("CONF: DPMI-Server %s (%#x)\n", ((yyvsp[0].i_value)) ? "on" : "off", ((yyvsp[0].i_value)));
		    }
#line 3666 "parser.c" /* yacc.c:1646  */
    break;

  case 52:
#line 636 "parser.y" /* yacc.c:1646  */
    {
		    config.dpmi_lin_rsv_base = (yyvsp[0].i_value);
		    c_printf("CONF: DPMI linear reserve base addr = %#x\n", (yyvsp[0].i_value));
		    }
#line 3675 "parser.c" /* yacc.c:1646  */
    break;

  case 53:
#line 641 "parser.y" /* yacc.c:1646  */
    {
		    config.dpmi_lin_rsv_size = (yyvsp[0].i_value);
		    c_printf("CONF: DPMI linear reserve size = %#x\n", (yyvsp[0].i_value));
		    }
#line 3684 "parser.c" /* yacc.c:1646  */
    break;

  case 54:
#line 646 "parser.y" /* yacc.c:1646  */
    {
		    config.pm_dos_api = ((yyvsp[0].i_value)!=0);
		    c_printf("CONF: PM DOS API Translator %s\n", ((yyvsp[0].i_value)) ? "on" : "off");
		    }
#line 3693 "parser.c" /* yacc.c:1646  */
    break;

  case 55:
#line 651 "parser.y" /* yacc.c:1646  */
    {
		    config.no_null_checks = ((yyvsp[0].i_value)!=0);
		    c_printf("CONF: No DJGPP NULL deref checks: %s\n", ((yyvsp[0].i_value)) ? "on" : "off");
		    }
#line 3702 "parser.c" /* yacc.c:1646  */
    break;

  case 56:
#line 655 "parser.y" /* yacc.c:1646  */
    { if ((yyvsp[0].i_value)>=0) config.mem_size = (yyvsp[0].i_value); }
#line 3708 "parser.c" /* yacc.c:1646  */
    break;

  case 57:
#line 657 "parser.y" /* yacc.c:1646  */
    {
		    if ((yyvsp[0].i_value)>=0) config.ext_mem = (yyvsp[0].i_value);
		    if ((yyvsp[0].i_value) > 0) c_printf("CONF: %dk bytes XMS memory\n", (yyvsp[0].i_value));
		    }
#line 3717 "parser.c" /* yacc.c:1646  */
    break;

  case 58:
#line 661 "parser.y" /* yacc.c:1646  */
    { config.mathco = ((yyvsp[0].i_value)!=0); }
#line 3723 "parser.c" /* yacc.c:1646  */
    break;

  case 59:
#line 663 "parser.y" /* yacc.c:1646  */
    {
		    config.ipxsup = ((yyvsp[0].i_value)!=0);
		    c_printf("CONF: IPX support %s\n", ((yyvsp[0].i_value)) ? "on" : "off");
		    }
#line 3732 "parser.c" /* yacc.c:1646  */
    break;

  case 60:
#line 667 "parser.y" /* yacc.c:1646  */
    { config.ipx_net = (yyvsp[0].i_value); }
#line 3738 "parser.c" /* yacc.c:1646  */
    break;

  case 61:
#line 669 "parser.y" /* yacc.c:1646  */
    {
		      if (config.vnet == VNET_TYPE_TAP || config.vnet == VNET_TYPE_VDE || (yyvsp[0].i_value) == 0 || is_in_allowed_classes(CL_NET)) {
			config.pktdrv = ((yyvsp[0].i_value)!=0);
			c_printf("CONF: Packet Driver %s.\n", 
				((yyvsp[0].i_value)) ? "enabled" : "disabled");
		      }
		    }
#line 3750 "parser.c" /* yacc.c:1646  */
    break;

  case 62:
#line 676 "parser.y" /* yacc.c:1646  */
    { free(config.ethdev); config.ethdev = (yyvsp[0].s_value); }
#line 3756 "parser.c" /* yacc.c:1646  */
    break;

  case 63:
#line 677 "parser.y" /* yacc.c:1646  */
    { free(config.tapdev); config.tapdev = (yyvsp[0].s_value); }
#line 3762 "parser.c" /* yacc.c:1646  */
    break;

  case 64:
#line 678 "parser.y" /* yacc.c:1646  */
    { free(config.vdeswitch); config.vdeswitch = (yyvsp[0].s_value); }
#line 3768 "parser.c" /* yacc.c:1646  */
    break;

  case 65:
#line 679 "parser.y" /* yacc.c:1646  */
    { free(config.slirp_args); config.slirp_args = (yyvsp[0].s_value); }
#line 3774 "parser.c" /* yacc.c:1646  */
    break;

  case 66:
#line 680 "parser.y" /* yacc.c:1646  */
    { config.pktflags = ((yyvsp[0].i_value)!=0); }
#line 3780 "parser.c" /* yacc.c:1646  */
    break;

  case 67:
#line 681 "parser.y" /* yacc.c:1646  */
    { start_vnet((yyvsp[0].s_value)); free((yyvsp[0].s_value)); }
#line 3786 "parser.c" /* yacc.c:1646  */
    break;

  case 68:
#line 683 "parser.y" /* yacc.c:1646  */
    {
		    if ((yyvsp[0].i_value) == SPKR_NATIVE) {
		      if (can_do_root_stuff) {
                        c_printf("CONF: allowing speaker port access!\n");
		      } else {
                        c_printf("CONF: native speaker not allowed: emulate\n");
			(yyvsp[0].i_value) = SPKR_EMULATED;
		      }
		    }
		    else
                      c_printf("CONF: not allowing speaker port access\n");
		    config.speaker = (yyvsp[0].i_value);
		    }
#line 3804 "parser.c" /* yacc.c:1646  */
    break;

  case 69:
#line 697 "parser.y" /* yacc.c:1646  */
    { start_video(); }
#line 3810 "parser.c" /* yacc.c:1646  */
    break;

  case 70:
#line 699 "parser.y" /* yacc.c:1646  */
    { stop_video(); }
#line 3816 "parser.c" /* yacc.c:1646  */
    break;

  case 71:
#line 700 "parser.y" /* yacc.c:1646  */
    { free(config.xterm_title); config.xterm_title = (yyvsp[0].s_value); }
#line 3822 "parser.c" /* yacc.c:1646  */
    break;

  case 72:
#line 703 "parser.y" /* yacc.c:1646  */
    { stop_terminal(); }
#line 3828 "parser.c" /* yacc.c:1646  */
    break;

  case 73:
#line 704 "parser.y" /* yacc.c:1646  */
    {
			parse_debugflags((yyvsp[0].s_value), 1);
			free((yyvsp[0].s_value));
		}
#line 3837 "parser.c" /* yacc.c:1646  */
    break;

  case 74:
#line 709 "parser.y" /* yacc.c:1646  */
    { start_debug(); }
#line 3843 "parser.c" /* yacc.c:1646  */
    break;

  case 76:
#line 712 "parser.y" /* yacc.c:1646  */
    { start_mouse(); }
#line 3849 "parser.c" /* yacc.c:1646  */
    break;

  case 77:
#line 714 "parser.y" /* yacc.c:1646  */
    { stop_mouse(); }
#line 3855 "parser.c" /* yacc.c:1646  */
    break;

  case 78:
#line 717 "parser.y" /* yacc.c:1646  */
    { stop_ttylocks(); }
#line 3861 "parser.c" /* yacc.c:1646  */
    break;

  case 79:
#line 719 "parser.y" /* yacc.c:1646  */
    { start_serial(); }
#line 3867 "parser.c" /* yacc.c:1646  */
    break;

  case 80:
#line 721 "parser.y" /* yacc.c:1646  */
    { stop_serial(); }
#line 3873 "parser.c" /* yacc.c:1646  */
    break;

  case 81:
#line 723 "parser.y" /* yacc.c:1646  */
    { start_keyboard(); }
#line 3879 "parser.c" /* yacc.c:1646  */
    break;

  case 83:
#line 726 "parser.y" /* yacc.c:1646  */
    {keytable_start((yyvsp[0].i_value));}
#line 3885 "parser.c" /* yacc.c:1646  */
    break;

  case 84:
#line 728 "parser.y" /* yacc.c:1646  */
    {keytable_stop();}
#line 3891 "parser.c" /* yacc.c:1646  */
    break;

  case 85:
#line 730 "parser.y" /* yacc.c:1646  */
    {
		    append_pre_strokes((yyvsp[0].s_value));
		    c_printf("CONF: appending pre-strokes '%s'\n", (yyvsp[0].s_value));
		    free((yyvsp[0].s_value));
		    }
#line 3901 "parser.c" /* yacc.c:1646  */
    break;

  case 86:
#line 735 "parser.y" /* yacc.c:1646  */
    {
			dump_keytables_to_file((yyvsp[0].s_value));
			free((yyvsp[0].s_value));
		    }
#line 3910 "parser.c" /* yacc.c:1646  */
    break;

  case 87:
#line 740 "parser.y" /* yacc.c:1646  */
    { IFCLASS(CL_PORT) start_ports(); }
#line 3916 "parser.c" /* yacc.c:1646  */
    break;

  case 90:
#line 744 "parser.y" /* yacc.c:1646  */
    { start_disk(); }
#line 3922 "parser.c" /* yacc.c:1646  */
    break;

  case 91:
#line 746 "parser.y" /* yacc.c:1646  */
    { stop_disk(DISK); }
#line 3928 "parser.c" /* yacc.c:1646  */
    break;

  case 92:
#line 748 "parser.y" /* yacc.c:1646  */
    { start_floppy(); }
#line 3934 "parser.c" /* yacc.c:1646  */
    break;

  case 93:
#line 750 "parser.y" /* yacc.c:1646  */
    { stop_disk(L_FLOPPY); }
#line 3940 "parser.c" /* yacc.c:1646  */
    break;

  case 94:
#line 752 "parser.y" /* yacc.c:1646  */
    {
		    static int which = 0;
		    if (which >= 3) {
			c_printf("CONF: too many cdrom drives defined\n");
			free((yyvsp[-1].s_value));
		    }
		    else {
			Path_cdrom[which] = (yyvsp[-1].s_value);
			c_printf("CONF: cdrom MSCD000%d on %s\n", which+1 ,(yyvsp[-1].s_value));
			which++;
		    }
		    }
#line 3957 "parser.c" /* yacc.c:1646  */
    break;

  case 95:
#line 765 "parser.y" /* yacc.c:1646  */
    {
		    char *s = aspi_add_device((yyvsp[-5].s_value), (yyvsp[-3].s_value), (yyvsp[-1].i_value));
		    if (s) {
			c_printf("CONF: aspi available for %s\n", s);
			free(s);
		    }
		    else c_printf("CONF: aspi device %s not available\n", (yyvsp[-5].s_value));
		    free((yyvsp[-5].s_value));
		    free((yyvsp[-3].s_value));
		    }
#line 3972 "parser.c" /* yacc.c:1646  */
    break;

  case 96:
#line 776 "parser.y" /* yacc.c:1646  */
    { start_printer(); }
#line 3978 "parser.c" /* yacc.c:1646  */
    break;

  case 97:
#line 778 "parser.y" /* yacc.c:1646  */
    { stop_printer(); }
#line 3984 "parser.c" /* yacc.c:1646  */
    break;

  case 100:
#line 781 "parser.y" /* yacc.c:1646  */
    { config.sound = ((yyvsp[0].i_value)!=0); }
#line 3990 "parser.c" /* yacc.c:1646  */
    break;

  case 102:
#line 783 "parser.y" /* yacc.c:1646  */
    { if (! (yyvsp[0].i_value)) { config.joy_device[0] = config.joy_device[1] = NULL; } }
#line 3996 "parser.c" /* yacc.c:1646  */
    break;

  case 104:
#line 786 "parser.y" /* yacc.c:1646  */
    { IFCLASS(CL_IRQ) config.sillyint=0; }
#line 4002 "parser.c" /* yacc.c:1646  */
    break;

  case 106:
#line 789 "parser.y" /* yacc.c:1646  */
    { IFCLASS(CL_IRQ) if ((yyvsp[0].i_value)) {
		        config.sillyint = 1 << (yyvsp[0].i_value);
		        c_printf("CONF: IRQ %d for irqpassing\n", (yyvsp[0].i_value));
		      }
		    }
#line 4012 "parser.c" /* yacc.c:1646  */
    break;

  case 108:
#line 796 "parser.y" /* yacc.c:1646  */
    { IFCLASS(CL_HARDRAM) {}
		    if (priv_lvl)
		      yyerror("Can not change hardware ram access settings in user config file");
		    }
#line 4021 "parser.c" /* yacc.c:1646  */
    break;

  case 110:
#line 802 "parser.y" /* yacc.c:1646  */
    {
			handle_features((yyvsp[-3].i_value), (yyvsp[-1].i_value));
		    }
#line 4029 "parser.c" /* yacc.c:1646  */
    break;

  case 111:
#line 806 "parser.y" /* yacc.c:1646  */
    { config.cli_timeout = (yyvsp[0].i_value); }
#line 4035 "parser.c" /* yacc.c:1646  */
    break;

  case 112:
#line 808 "parser.y" /* yacc.c:1646  */
    {
		    config.timemode = parse_timemode((yyvsp[0].s_value));
		    c_printf("CONF: time mode = '%s'\n", (yyvsp[0].s_value));
		    free((yyvsp[0].s_value));
		    }
#line 4045 "parser.c" /* yacc.c:1646  */
    break;

  case 113:
#line 814 "parser.y" /* yacc.c:1646  */
    { yyerror("unrecognized command '%s'", (yyvsp[0].s_value)); free((yyvsp[0].s_value)); }
#line 4051 "parser.c" /* yacc.c:1646  */
    break;

  case 115:
#line 818 "parser.y" /* yacc.c:1646  */
    { (yyval.i_value) = TOF((yyvsp[0].t_value)); }
#line 4057 "parser.c" /* yacc.c:1646  */
    break;

  case 116:
#line 821 "parser.y" /* yacc.c:1646  */
    { (yyval.r_value) = TOF((yyvsp[0].t_value)); }
#line 4063 "parser.c" /* yacc.c:1646  */
    break;

  case 117:
#line 826 "parser.y" /* yacc.c:1646  */
    {(yyval.t_value).type = TYPE_INTEGER; (yyval.t_value).value.i=(yyvsp[0].i_value);}
#line 4069 "parser.c" /* yacc.c:1646  */
    break;

  case 118:
#line 827 "parser.y" /* yacc.c:1646  */
    {(yyval.t_value).type = TYPE_BOOLEAN; (yyval.t_value).value.i=(yyvsp[0].i_value);}
#line 4075 "parser.c" /* yacc.c:1646  */
    break;

  case 119:
#line 828 "parser.y" /* yacc.c:1646  */
    {(yyval.t_value).type = TYPE_REAL; (yyval.t_value).value.r=(yyvsp[0].r_value);}
#line 4081 "parser.c" /* yacc.c:1646  */
    break;

  case 120:
#line 830 "parser.y" /* yacc.c:1646  */
    {V_VAL((yyval.t_value),(yyvsp[-2].t_value),TOF((yyvsp[-2].t_value)) + TOF((yyvsp[0].t_value))); }
#line 4087 "parser.c" /* yacc.c:1646  */
    break;

  case 121:
#line 832 "parser.y" /* yacc.c:1646  */
    {V_VAL((yyval.t_value),(yyvsp[-2].t_value),TOF((yyvsp[-2].t_value)) - TOF((yyvsp[0].t_value))); }
#line 4093 "parser.c" /* yacc.c:1646  */
    break;

  case 122:
#line 834 "parser.y" /* yacc.c:1646  */
    {V_VAL((yyval.t_value),(yyvsp[-2].t_value),TOF((yyvsp[-2].t_value)) * TOF((yyvsp[0].t_value))); }
#line 4099 "parser.c" /* yacc.c:1646  */
    break;

  case 123:
#line 835 "parser.y" /* yacc.c:1646  */
    {
			if (TOF((yyvsp[0].t_value)))	V_VAL((yyval.t_value),(yyvsp[-2].t_value),TOF((yyvsp[-2].t_value)) / TOF((yyvsp[0].t_value)));
			else V_VAL((yyval.t_value),(yyvsp[-2].t_value),TOF((yyvsp[0].t_value)));
		}
#line 4108 "parser.c" /* yacc.c:1646  */
    break;

  case 124:
#line 840 "parser.y" /* yacc.c:1646  */
    {V_VAL((yyval.t_value),(yyvsp[0].t_value),-TOF((yyvsp[0].t_value))); }
#line 4114 "parser.c" /* yacc.c:1646  */
    break;

  case 125:
#line 842 "parser.y" /* yacc.c:1646  */
    {V_VAL((yyval.t_value),(yyvsp[0].t_value),TOF((yyvsp[0].t_value))); }
#line 4120 "parser.c" /* yacc.c:1646  */
    break;

  case 126:
#line 844 "parser.y" /* yacc.c:1646  */
    { unsigned int shift = (1 << (int)TOF((yyvsp[0].t_value)));
			if (!shift) (yyval.t_value) = (yyvsp[-2].t_value);
			else V_VAL((yyval.t_value), (yyvsp[-2].t_value), TOF((yyvsp[-2].t_value)) / shift);}
#line 4128 "parser.c" /* yacc.c:1646  */
    break;

  case 127:
#line 848 "parser.y" /* yacc.c:1646  */
    { unsigned int shift = (1 << (int)TOF((yyvsp[0].t_value)));
			if (!shift) (yyval.t_value) = (yyvsp[-2].t_value);
			else V_VAL((yyval.t_value), (yyvsp[-2].t_value), TOF((yyvsp[-2].t_value)) * shift);}
#line 4136 "parser.c" /* yacc.c:1646  */
    break;

  case 128:
#line 851 "parser.y" /* yacc.c:1646  */
    {
			char *s;
			(yyval.t_value).type = TYPE_INTEGER;
			(yyval.t_value).value.i = strtoul((yyvsp[0].s_value),&s,0);
			switch (*s) {
				case '.':  case 'e':  case 'E':
				/* we assume a real number */
				(yyval.t_value).type = TYPE_REAL;
				(yyval.t_value).value.r = strtod((yyvsp[0].s_value),0);
			}
			free((yyvsp[0].s_value));
		}
#line 4153 "parser.c" /* yacc.c:1646  */
    break;

  case 129:
#line 863 "parser.y" /* yacc.c:1646  */
    {(yyval.t_value) = (yyvsp[-1].t_value);}
#line 4159 "parser.c" /* yacc.c:1646  */
    break;

  case 131:
#line 868 "parser.y" /* yacc.c:1646  */
    {(yyval.i_value) = (int)TOF((yyvsp[-2].t_value)) & (int)TOF((yyvsp[0].t_value)); }
#line 4165 "parser.c" /* yacc.c:1646  */
    break;

  case 132:
#line 870 "parser.y" /* yacc.c:1646  */
    {(yyval.i_value) = (int)TOF((yyvsp[-2].t_value)) | (int)TOF((yyvsp[0].t_value)); }
#line 4171 "parser.c" /* yacc.c:1646  */
    break;

  case 133:
#line 872 "parser.y" /* yacc.c:1646  */
    {(yyval.i_value) = (int)TOF((yyvsp[-2].t_value)) ^ (int)TOF((yyvsp[0].t_value)); }
#line 4177 "parser.c" /* yacc.c:1646  */
    break;

  case 134:
#line 874 "parser.y" /* yacc.c:1646  */
    {(yyval.i_value) = (int)TOF((yyvsp[0].t_value)) ^ (-1); }
#line 4183 "parser.c" /* yacc.c:1646  */
    break;

  case 135:
#line 875 "parser.y" /* yacc.c:1646  */
    {(yyval.i_value) = -1; }
#line 4189 "parser.c" /* yacc.c:1646  */
    break;

  case 136:
#line 876 "parser.y" /* yacc.c:1646  */
    {(yyval.i_value) = TOF((yyvsp[-1].t_value));}
#line 4195 "parser.c" /* yacc.c:1646  */
    break;

  case 137:
#line 877 "parser.y" /* yacc.c:1646  */
    {
			(yyval.i_value) = strtol((yyvsp[-1].s_value),0,0);
			free((yyvsp[-1].s_value));
		}
#line 4204 "parser.c" /* yacc.c:1646  */
    break;

  case 138:
#line 881 "parser.y" /* yacc.c:1646  */
    {
			(yyval.i_value) = strlen((yyvsp[-1].s_value));
			free((yyvsp[-1].s_value));
		}
#line 4213 "parser.c" /* yacc.c:1646  */
    break;

  case 139:
#line 885 "parser.y" /* yacc.c:1646  */
    {
			(yyval.i_value) = strncmp((yyvsp[-5].s_value),(yyvsp[-3].s_value),(yyvsp[-1].i_value));
			free((yyvsp[-5].s_value)); free((yyvsp[-3].s_value));
		}
#line 4222 "parser.c" /* yacc.c:1646  */
    break;

  case 140:
#line 889 "parser.y" /* yacc.c:1646  */
    {
			char *s = strpbrk((yyvsp[-3].s_value),(yyvsp[-1].s_value));
			if (s) (yyval.i_value) = s - (yyvsp[-3].s_value);
			else (yyval.i_value) = -1;
			free((yyvsp[-3].s_value)); free((yyvsp[-1].s_value));
		}
#line 4233 "parser.c" /* yacc.c:1646  */
    break;

  case 141:
#line 895 "parser.y" /* yacc.c:1646  */
    {
			char *s = strchr((yyvsp[-3].s_value),(yyvsp[-1].s_value)[0]);
			if (s) (yyval.i_value) = s - (yyvsp[-3].s_value);
			else (yyval.i_value) = -1;
			free((yyvsp[-3].s_value)); free((yyvsp[-1].s_value));
		}
#line 4244 "parser.c" /* yacc.c:1646  */
    break;

  case 142:
#line 901 "parser.y" /* yacc.c:1646  */
    {
			char *s = strrchr((yyvsp[-3].s_value),(yyvsp[-1].s_value)[0]);
			if (s) (yyval.i_value) = s - (yyvsp[-3].s_value);
			else (yyval.i_value) = -1;
			free((yyvsp[-3].s_value)); free((yyvsp[-1].s_value));
		}
#line 4255 "parser.c" /* yacc.c:1646  */
    break;

  case 143:
#line 907 "parser.y" /* yacc.c:1646  */
    {
			char *s = strstr((yyvsp[-3].s_value),(yyvsp[-1].s_value));
			if (s) (yyval.i_value) = s - (yyvsp[-3].s_value);
			else (yyval.i_value) = -1;
			free((yyvsp[-3].s_value)); free((yyvsp[-1].s_value));
		}
#line 4266 "parser.c" /* yacc.c:1646  */
    break;

  case 144:
#line 913 "parser.y" /* yacc.c:1646  */
    {
			(yyval.i_value) = strspn((yyvsp[-3].s_value),(yyvsp[-1].s_value));
			free((yyvsp[-3].s_value)); free((yyvsp[-1].s_value));
		}
#line 4275 "parser.c" /* yacc.c:1646  */
    break;

  case 145:
#line 917 "parser.y" /* yacc.c:1646  */
    {
			(yyval.i_value) = strcspn((yyvsp[-3].s_value),(yyvsp[-1].s_value));
			free((yyvsp[-3].s_value)); free((yyvsp[-1].s_value));
		}
#line 4284 "parser.c" /* yacc.c:1646  */
    break;

  case 146:
#line 921 "parser.y" /* yacc.c:1646  */
    {
			if ( (yyvsp[0].s_value)[0] == '\'' && (yyvsp[0].s_value)[1] && (yyvsp[0].s_value)[2] == '\'' && !(yyvsp[0].s_value)[3] )
				(yyval.i_value) = (yyvsp[0].s_value)[1];
			else	yyerror("unrecognized expression '%s'", (yyvsp[0].s_value));
			free((yyvsp[0].s_value));
		}
#line 4295 "parser.c" /* yacc.c:1646  */
    break;

  case 147:
#line 930 "parser.y" /* yacc.c:1646  */
    {(yyval.i_value) = TOF((yyvsp[-2].t_value)) == TOF((yyvsp[0].t_value)); }
#line 4301 "parser.c" /* yacc.c:1646  */
    break;

  case 148:
#line 932 "parser.y" /* yacc.c:1646  */
    {(yyval.i_value) = TOF((yyvsp[-2].t_value)) != TOF((yyvsp[0].t_value)); }
#line 4307 "parser.c" /* yacc.c:1646  */
    break;

  case 149:
#line 934 "parser.y" /* yacc.c:1646  */
    {(yyval.i_value) = TOF((yyvsp[-2].t_value)) >= TOF((yyvsp[0].t_value)); }
#line 4313 "parser.c" /* yacc.c:1646  */
    break;

  case 150:
#line 936 "parser.y" /* yacc.c:1646  */
    {(yyval.i_value) = TOF((yyvsp[-2].t_value)) <= TOF((yyvsp[0].t_value)); }
#line 4319 "parser.c" /* yacc.c:1646  */
    break;

  case 151:
#line 938 "parser.y" /* yacc.c:1646  */
    {(yyval.i_value) = TOF((yyvsp[-2].t_value)) < TOF((yyvsp[0].t_value)); }
#line 4325 "parser.c" /* yacc.c:1646  */
    break;

  case 152:
#line 940 "parser.y" /* yacc.c:1646  */
    {(yyval.i_value) = TOF((yyvsp[-2].t_value)) > TOF((yyvsp[0].t_value)); }
#line 4331 "parser.c" /* yacc.c:1646  */
    break;

  case 153:
#line 942 "parser.y" /* yacc.c:1646  */
    {(yyval.i_value) = TOF((yyvsp[-2].t_value)) && TOF((yyvsp[0].t_value)); }
#line 4337 "parser.c" /* yacc.c:1646  */
    break;

  case 154:
#line 944 "parser.y" /* yacc.c:1646  */
    {(yyval.i_value) = TOF((yyvsp[-2].t_value)) || TOF((yyvsp[0].t_value)); }
#line 4343 "parser.c" /* yacc.c:1646  */
    break;

  case 155:
#line 946 "parser.y" /* yacc.c:1646  */
    {(yyval.i_value) = strcmp((yyvsp[-2].s_value),(yyvsp[0].s_value)) == 0; free((yyvsp[-2].s_value)); free((yyvsp[0].s_value)); }
#line 4349 "parser.c" /* yacc.c:1646  */
    break;

  case 156:
#line 948 "parser.y" /* yacc.c:1646  */
    {(yyval.i_value) = strcmp((yyvsp[-2].s_value),(yyvsp[0].s_value)) != 0; free((yyvsp[-2].s_value)); free((yyvsp[0].s_value)); }
#line 4355 "parser.c" /* yacc.c:1646  */
    break;

  case 157:
#line 949 "parser.y" /* yacc.c:1646  */
    {(yyval.i_value) = (TOF((yyvsp[0].t_value)) ? 0:1); }
#line 4361 "parser.c" /* yacc.c:1646  */
    break;

  case 158:
#line 950 "parser.y" /* yacc.c:1646  */
    {(yyval.i_value) = -2; }
#line 4367 "parser.c" /* yacc.c:1646  */
    break;

  case 159:
#line 951 "parser.y" /* yacc.c:1646  */
    {(yyval.i_value) = 0; }
#line 4373 "parser.c" /* yacc.c:1646  */
    break;

  case 160:
#line 952 "parser.y" /* yacc.c:1646  */
    {(yyval.i_value) = -2; }
#line 4379 "parser.c" /* yacc.c:1646  */
    break;

  case 161:
#line 953 "parser.y" /* yacc.c:1646  */
    {(yyval.i_value) = 0; }
#line 4385 "parser.c" /* yacc.c:1646  */
    break;

  case 162:
#line 954 "parser.y" /* yacc.c:1646  */
    {
			(yyval.i_value) = get_config_variable((yyvsp[-1].s_value)) !=0;
			free((yyvsp[-1].s_value));
		}
#line 4394 "parser.c" /* yacc.c:1646  */
    break;

  case 164:
#line 961 "parser.y" /* yacc.c:1646  */
    {(yyval.r_value) = TOF((yyvsp[-1].t_value));}
#line 4400 "parser.c" /* yacc.c:1646  */
    break;

  case 165:
#line 965 "parser.y" /* yacc.c:1646  */
    {
			char *s = (yyvsp[0].s_value);
			if (get_config_variable(s))
				s = "1";
			else if (strncmp("c_",s,2)
					&& strncmp("u_",s,2)
					&& strncmp("h_",s,2) ) {
				s = checked_getenv(s);
				if (!s) s = "";
			}
			else
				s = "0";
			(yyval.s_value) = strdup(s);
			free((yyvsp[0].s_value));
		}
#line 4420 "parser.c" /* yacc.c:1646  */
    break;

  case 166:
#line 982 "parser.y" /* yacc.c:1646  */
    {
			(yyval.s_value) = (yyvsp[0].s_value);
			if ((yyval.s_value)[0] == '\'' || (yyval.s_value)[0] == '\"') {
				size_t len = strlen((yyvsp[0].s_value)) - 2;
				memmove((yyval.s_value), (yyval.s_value)+1, len);
				(yyval.s_value)[len] = '\0';
			}
		}
#line 4433 "parser.c" /* yacc.c:1646  */
    break;

  case 168:
#line 993 "parser.y" /* yacc.c:1646  */
    {(yyval.s_value) = (yyvsp[-1].s_value); }
#line 4439 "parser.c" /* yacc.c:1646  */
    break;

  case 169:
#line 994 "parser.y" /* yacc.c:1646  */
    {
			int i = (yyvsp[-3].i_value);
			int len = (yyvsp[-1].i_value);
			int slen = strlen((yyvsp[-5].s_value));
			if ((i >=0) && (i < slen) && (len > 0)) {
				if ((i+len) > slen) len = slen - i;
				(yyvsp[-5].s_value)[i+len] = 0;
				(yyval.s_value) = strdup((yyvsp[-5].s_value) + i);
			}
			else
				(yyval.s_value) = strdup("");
			free((yyvsp[-5].s_value));
		}
#line 4457 "parser.c" /* yacc.c:1646  */
    break;

  case 170:
#line 1007 "parser.y" /* yacc.c:1646  */
    {
			int i = (yyvsp[-3].i_value);
			int len = (yyvsp[-1].i_value);
			int slen = strlen((yyvsp[-5].s_value));
			char *s = strdup((yyvsp[-5].s_value));
			if ((i >=0) && (i < slen) && (len > 0)) {
				if ((i+len) > slen) s[i] = 0;
				else memmove(s+i, s+i+len, slen-i-len+1);
			}
			free((yyvsp[-5].s_value));
			(yyval.s_value) = s;
		}
#line 4474 "parser.c" /* yacc.c:1646  */
    break;

  case 171:
#line 1019 "parser.y" /* yacc.c:1646  */
    {
			(yyval.s_value) = run_shell((yyvsp[-1].s_value));
			free((yyvsp[-1].s_value));
		}
#line 4483 "parser.c" /* yacc.c:1646  */
    break;

  case 172:
#line 1023 "parser.y" /* yacc.c:1646  */
    {(yyval.s_value) = (yyvsp[0].s_value);}
#line 4489 "parser.c" /* yacc.c:1646  */
    break;

  case 174:
#line 1027 "parser.y" /* yacc.c:1646  */
    {
			char *s = malloc(strlen((yyvsp[-2].s_value))+strlen((yyvsp[0].s_value))+1);
			strcpy(s, (yyvsp[-2].s_value));
			strcat(s, (yyvsp[0].s_value));
			(yyval.s_value) = s;
			free((yyvsp[-2].s_value)); free((yyvsp[0].s_value));
		}
#line 4501 "parser.c" /* yacc.c:1646  */
    break;

  case 176:
#line 1037 "parser.y" /* yacc.c:1646  */
    {
			int ret;
			if ((yyvsp[-1].t_value).type == TYPE_REAL) {
				ret = asprintf(&(yyval.s_value), "%g", (yyvsp[-1].t_value).value.r);
				assert(ret != -1);
			} else {
				ret = asprintf(&(yyval.s_value), "%d", (yyvsp[-1].t_value).value.i);
				assert(ret != -1);
			}
		}
#line 4516 "parser.c" /* yacc.c:1646  */
    break;

  case 177:
#line 1050 "parser.y" /* yacc.c:1646  */
    {
			check_user_var((yyvsp[0].s_value));
			free((yyvsp[0].s_value));
		}
#line 4525 "parser.c" /* yacc.c:1646  */
    break;

  case 178:
#line 1054 "parser.y" /* yacc.c:1646  */
    {
			check_user_var((yyvsp[0].s_value));
			free((yyvsp[0].s_value));
		}
#line 4534 "parser.c" /* yacc.c:1646  */
    break;

  case 181:
#line 1065 "parser.y" /* yacc.c:1646  */
    { free(config.X_display); config.X_display = (yyvsp[0].s_value); }
#line 4540 "parser.c" /* yacc.c:1646  */
    break;

  case 182:
#line 1066 "parser.y" /* yacc.c:1646  */
    { free(config.X_title); config.X_title = (yyvsp[0].s_value); }
#line 4546 "parser.c" /* yacc.c:1646  */
    break;

  case 183:
#line 1067 "parser.y" /* yacc.c:1646  */
    { config.X_title_show_appname = ((yyvsp[0].i_value)!=0); }
#line 4552 "parser.c" /* yacc.c:1646  */
    break;

  case 184:
#line 1068 "parser.y" /* yacc.c:1646  */
    { free(config.X_icon_name); config.X_icon_name = (yyvsp[0].s_value); }
#line 4558 "parser.c" /* yacc.c:1646  */
    break;

  case 185:
#line 1069 "parser.y" /* yacc.c:1646  */
    { config.X_keycode = (yyvsp[0].i_value); }
#line 4564 "parser.c" /* yacc.c:1646  */
    break;

  case 186:
#line 1070 "parser.y" /* yacc.c:1646  */
    { config.X_blinkrate = (yyvsp[0].i_value); }
#line 4570 "parser.c" /* yacc.c:1646  */
    break;

  case 187:
#line 1071 "parser.y" /* yacc.c:1646  */
    { config.X_sharecmap = 1; }
#line 4576 "parser.c" /* yacc.c:1646  */
    break;

  case 188:
#line 1072 "parser.y" /* yacc.c:1646  */
    { config.X_mitshm = 1; }
#line 4582 "parser.c" /* yacc.c:1646  */
    break;

  case 189:
#line 1073 "parser.y" /* yacc.c:1646  */
    { config.X_mitshm = ((yyvsp[0].i_value)!=0); }
#line 4588 "parser.c" /* yacc.c:1646  */
    break;

  case 190:
#line 1074 "parser.y" /* yacc.c:1646  */
    { free(config.X_font); config.X_font = (yyvsp[0].s_value); }
#line 4594 "parser.c" /* yacc.c:1646  */
    break;

  case 191:
#line 1075 "parser.y" /* yacc.c:1646  */
    { config.X_fixed_aspect = ((yyvsp[0].i_value)!=0); }
#line 4600 "parser.c" /* yacc.c:1646  */
    break;

  case 192:
#line 1076 "parser.y" /* yacc.c:1646  */
    { config.X_aspect_43 = 1; }
#line 4606 "parser.c" /* yacc.c:1646  */
    break;

  case 193:
#line 1077 "parser.y" /* yacc.c:1646  */
    { config.X_lin_filt = 1; }
#line 4612 "parser.c" /* yacc.c:1646  */
    break;

  case 194:
#line 1078 "parser.y" /* yacc.c:1646  */
    { config.X_bilin_filt = 1; }
#line 4618 "parser.c" /* yacc.c:1646  */
    break;

  case 195:
#line 1079 "parser.y" /* yacc.c:1646  */
    { config.X_mode13fact = (yyvsp[0].i_value); }
#line 4624 "parser.c" /* yacc.c:1646  */
    break;

  case 196:
#line 1081 "parser.y" /* yacc.c:1646  */
    {
                     config.X_winsize_x = (yyvsp[-1].i_value);
                     config.X_winsize_y = (yyvsp[0].i_value);
                   }
#line 4633 "parser.c" /* yacc.c:1646  */
    break;

  case 197:
#line 1086 "parser.y" /* yacc.c:1646  */
    {
                     config.X_winsize_x = (yyvsp[-2].i_value);
                     config.X_winsize_y = (yyvsp[0].i_value);
                   }
#line 4642 "parser.c" /* yacc.c:1646  */
    break;

  case 198:
#line 1090 "parser.y" /* yacc.c:1646  */
    { config.X_gamma = (yyvsp[0].i_value); }
#line 4648 "parser.c" /* yacc.c:1646  */
    break;

  case 199:
#line 1091 "parser.y" /* yacc.c:1646  */
    { config.X_fullscreen = (yyvsp[0].i_value); }
#line 4654 "parser.c" /* yacc.c:1646  */
    break;

  case 200:
#line 1092 "parser.y" /* yacc.c:1646  */
    { config.vgaemu_memsize = (yyvsp[0].i_value); }
#line 4660 "parser.c" /* yacc.c:1646  */
    break;

  case 201:
#line 1093 "parser.y" /* yacc.c:1646  */
    { set_vesamodes((yyvsp[-1].i_value),(yyvsp[0].i_value),0);}
#line 4666 "parser.c" /* yacc.c:1646  */
    break;

  case 202:
#line 1094 "parser.y" /* yacc.c:1646  */
    { set_vesamodes((yyvsp[-2].i_value),(yyvsp[-1].i_value),(yyvsp[0].i_value));}
#line 4672 "parser.c" /* yacc.c:1646  */
    break;

  case 203:
#line 1095 "parser.y" /* yacc.c:1646  */
    { set_vesamodes((yyvsp[-2].i_value),(yyvsp[0].i_value),0);}
#line 4678 "parser.c" /* yacc.c:1646  */
    break;

  case 204:
#line 1097 "parser.y" /* yacc.c:1646  */
    { set_vesamodes((yyvsp[-4].i_value),(yyvsp[-2].i_value),(yyvsp[0].i_value));}
#line 4684 "parser.c" /* yacc.c:1646  */
    break;

  case 205:
#line 1098 "parser.y" /* yacc.c:1646  */
    { config.X_lfb = ((yyvsp[0].i_value)!=0); }
#line 4690 "parser.c" /* yacc.c:1646  */
    break;

  case 206:
#line 1099 "parser.y" /* yacc.c:1646  */
    { config.X_pm_interface = ((yyvsp[0].i_value)!=0); }
#line 4696 "parser.c" /* yacc.c:1646  */
    break;

  case 207:
#line 1100 "parser.y" /* yacc.c:1646  */
    { free(config.X_mgrab_key); config.X_mgrab_key = (yyvsp[0].s_value); }
#line 4702 "parser.c" /* yacc.c:1646  */
    break;

  case 208:
#line 1101 "parser.y" /* yacc.c:1646  */
    { config.X_background_pause = ((yyvsp[0].i_value)!=0); }
#line 4708 "parser.c" /* yacc.c:1646  */
    break;

  case 211:
#line 1108 "parser.y" /* yacc.c:1646  */
    { config.sdl_hwrend = ((yyvsp[0].i_value)!=0); }
#line 4714 "parser.c" /* yacc.c:1646  */
    break;

  case 214:
#line 1115 "parser.y" /* yacc.c:1646  */
    { if (!priv_lvl) dexe_forbid_disk = 0; }
#line 4720 "parser.c" /* yacc.c:1646  */
    break;

  case 215:
#line 1116 "parser.y" /* yacc.c:1646  */
    {
			char *env = getenv("DISPLAY");
			if (env && env[0] && dexe_running) config.X = 1;
		}
#line 4729 "parser.c" /* yacc.c:1646  */
    break;

  case 216:
#line 1120 "parser.y" /* yacc.c:1646  */
    {
			char *env = getenv("DISPLAY");
			if (env && env[0] && dexe_running) config.X = 1;
			else if (dexe_running) {
			  yyerror("this DEXE requires X, giving up");
			  exit(99);
			}
		}
#line 4742 "parser.c" /* yacc.c:1646  */
    break;

  case 219:
#line 1135 "parser.y" /* yacc.c:1646  */
    { config.sb_base = (yyvsp[0].i_value); }
#line 4748 "parser.c" /* yacc.c:1646  */
    break;

  case 220:
#line 1136 "parser.y" /* yacc.c:1646  */
    { config.sb_dma = (yyvsp[0].i_value); }
#line 4754 "parser.c" /* yacc.c:1646  */
    break;

  case 221:
#line 1137 "parser.y" /* yacc.c:1646  */
    { config.sb_hdma = (yyvsp[0].i_value); }
#line 4760 "parser.c" /* yacc.c:1646  */
    break;

  case 222:
#line 1138 "parser.y" /* yacc.c:1646  */
    { config.sb_irq = (yyvsp[0].i_value); }
#line 4766 "parser.c" /* yacc.c:1646  */
    break;

  case 223:
#line 1139 "parser.y" /* yacc.c:1646  */
    { config.mpu401_base = (yyvsp[0].i_value); }
#line 4772 "parser.c" /* yacc.c:1646  */
    break;

  case 224:
#line 1140 "parser.y" /* yacc.c:1646  */
    { free(config.midi_synth); config.midi_synth = (yyvsp[0].s_value); }
#line 4778 "parser.c" /* yacc.c:1646  */
    break;

  case 225:
#line 1141 "parser.y" /* yacc.c:1646  */
    { config.mpu401_irq = (yyvsp[0].i_value); }
#line 4784 "parser.c" /* yacc.c:1646  */
    break;

  case 226:
#line 1142 "parser.y" /* yacc.c:1646  */
    { config.mpu401_irq_mt32 = (yyvsp[0].i_value); }
#line 4790 "parser.c" /* yacc.c:1646  */
    break;

  case 227:
#line 1143 "parser.y" /* yacc.c:1646  */
    { free(config.sound_driver); config.sound_driver = (yyvsp[0].s_value); }
#line 4796 "parser.c" /* yacc.c:1646  */
    break;

  case 228:
#line 1144 "parser.y" /* yacc.c:1646  */
    { free(config.midi_driver); config.midi_driver = (yyvsp[0].s_value); }
#line 4802 "parser.c" /* yacc.c:1646  */
    break;

  case 229:
#line 1146 "parser.y" /* yacc.c:1646  */
    {
				free(config.munt_roms_dir);
				config.munt_roms_dir = concat_dir(LOCALDIR, (yyvsp[0].s_value));
				free((yyvsp[0].s_value));
			}
#line 4812 "parser.c" /* yacc.c:1646  */
    break;

  case 230:
#line 1151 "parser.y" /* yacc.c:1646  */
    { free(config.snd_plugin_params); config.snd_plugin_params = (yyvsp[0].s_value); }
#line 4818 "parser.c" /* yacc.c:1646  */
    break;

  case 231:
#line 1152 "parser.y" /* yacc.c:1646  */
    { config.pcm_hpf = ((yyvsp[0].i_value)!=0); }
#line 4824 "parser.c" /* yacc.c:1646  */
    break;

  case 232:
#line 1153 "parser.y" /* yacc.c:1646  */
    { free(config.midi_file); config.midi_file = (yyvsp[0].s_value); }
#line 4830 "parser.c" /* yacc.c:1646  */
    break;

  case 233:
#line 1154 "parser.y" /* yacc.c:1646  */
    { free(config.wav_file); config.wav_file = (yyvsp[0].s_value); }
#line 4836 "parser.c" /* yacc.c:1646  */
    break;

  case 236:
#line 1162 "parser.y" /* yacc.c:1646  */
    { set_joy_device((yyvsp[0].s_value)); }
#line 4842 "parser.c" /* yacc.c:1646  */
    break;

  case 237:
#line 1163 "parser.y" /* yacc.c:1646  */
    { config.joy_dos_min = (yyvsp[0].i_value); }
#line 4848 "parser.c" /* yacc.c:1646  */
    break;

  case 238:
#line 1164 "parser.y" /* yacc.c:1646  */
    { config.joy_dos_max = (yyvsp[0].i_value); }
#line 4854 "parser.c" /* yacc.c:1646  */
    break;

  case 239:
#line 1165 "parser.y" /* yacc.c:1646  */
    { config.joy_granularity = (yyvsp[0].i_value); }
#line 4860 "parser.c" /* yacc.c:1646  */
    break;

  case 240:
#line 1166 "parser.y" /* yacc.c:1646  */
    { config.joy_latency = (yyvsp[0].i_value); }
#line 4866 "parser.c" /* yacc.c:1646  */
    break;

  case 243:
#line 1174 "parser.y" /* yacc.c:1646  */
    { config.cardtype = CARD_VGA; }
#line 4872 "parser.c" /* yacc.c:1646  */
    break;

  case 244:
#line 1175 "parser.y" /* yacc.c:1646  */
    { config.cardtype = CARD_MDA; }
#line 4878 "parser.c" /* yacc.c:1646  */
    break;

  case 245:
#line 1176 "parser.y" /* yacc.c:1646  */
    { config.cardtype = CARD_CGA; }
#line 4884 "parser.c" /* yacc.c:1646  */
    break;

  case 246:
#line 1177 "parser.y" /* yacc.c:1646  */
    { config.cardtype = CARD_EGA; }
#line 4890 "parser.c" /* yacc.c:1646  */
    break;

  case 247:
#line 1178 "parser.y" /* yacc.c:1646  */
    { config.cardtype = CARD_NONE; }
#line 4896 "parser.c" /* yacc.c:1646  */
    break;

  case 248:
#line 1180 "parser.y" /* yacc.c:1646  */
    {
		    config.chipset = (yyvsp[0].i_value);
                    c_printf("CHIPSET: %d\n", (yyvsp[0].i_value));
		    }
#line 4905 "parser.c" /* yacc.c:1646  */
    break;

  case 249:
#line 1184 "parser.y" /* yacc.c:1646  */
    { config.gfxmemsize = (yyvsp[0].i_value); }
#line 4911 "parser.c" /* yacc.c:1646  */
    break;

  case 250:
#line 1186 "parser.y" /* yacc.c:1646  */
    { config.vga = 1;
		    }
#line 4918 "parser.c" /* yacc.c:1646  */
    break;

  case 251:
#line 1189 "parser.y" /* yacc.c:1646  */
    { config.vga = -1;
		    }
#line 4925 "parser.c" /* yacc.c:1646  */
    break;

  case 252:
#line 1192 "parser.y" /* yacc.c:1646  */
    { config.console_video = 1;
		    }
#line 4932 "parser.c" /* yacc.c:1646  */
    break;

  case 253:
#line 1195 "parser.y" /* yacc.c:1646  */
    { config.console_video = -1;
		    }
#line 4939 "parser.c" /* yacc.c:1646  */
    break;

  case 254:
#line 1197 "parser.y" /* yacc.c:1646  */
    { config.fullrestore = 1; }
#line 4945 "parser.c" /* yacc.c:1646  */
    break;

  case 255:
#line 1198 "parser.y" /* yacc.c:1646  */
    { config.fullrestore = 0; }
#line 4951 "parser.c" /* yacc.c:1646  */
    break;

  case 256:
#line 1199 "parser.y" /* yacc.c:1646  */
    { free(config.vbios_file); config.vbios_file = (yyvsp[0].s_value);
					  config.mapped_bios = 1;
					  config.vbios_copy = 0; }
#line 4959 "parser.c" /* yacc.c:1646  */
    break;

  case 257:
#line 1202 "parser.y" /* yacc.c:1646  */
    { free(config.vgaemubios_file); config.vgaemubios_file = (yyvsp[0].s_value); }
#line 4965 "parser.c" /* yacc.c:1646  */
    break;

  case 258:
#line 1203 "parser.y" /* yacc.c:1646  */
    { free(config.vbios_file);
					  config.vbios_file = NULL;
					  config.mapped_bios = 1;
					  config.vbios_copy = 1; }
#line 4974 "parser.c" /* yacc.c:1646  */
    break;

  case 259:
#line 1207 "parser.y" /* yacc.c:1646  */
    { free(config.vbios_file);
					  config.vbios_file = NULL;
					  config.mapped_bios = 1;
					  config.vbios_copy = 1; }
#line 4983 "parser.c" /* yacc.c:1646  */
    break;

  case 260:
#line 1212 "parser.y" /* yacc.c:1646  */
    {
		   config.vbios_seg = (yyvsp[0].i_value);
		   c_printf("CONF: VGA-BIOS-Segment %x\n", (yyvsp[0].i_value));
		   if (((yyvsp[0].i_value) != 0xe000) && ((yyvsp[0].i_value) != 0xc000))
		      {
		      config.vbios_seg = detect_vbios_seg();
		      if (config.vbios_seg == -1) config.vbios_seg = 0xc000;
		      c_printf("CONF: VGA-BIOS-Segment set to 0x%x\n", config.vbios_seg);
		      }
		   }
#line 4998 "parser.c" /* yacc.c:1646  */
    break;

  case 261:
#line 1223 "parser.y" /* yacc.c:1646  */
    {
		   config.vbios_size = (yyvsp[0].i_value);
		   c_printf("CONF: VGA-BIOS-Size %x\n", (yyvsp[0].i_value));
		   if (((yyvsp[0].i_value) != 0x8000) && ((yyvsp[0].i_value) != 0x10000))
		      {
		      config.vbios_size = detect_vbios_size();
		      if (config.vbios_size == -1) config.vbios_size = 0x10000;
		      c_printf("CONF: VGA-BIOS-Size set to 0x%x\n", config.vbios_size);
		      }
		   }
#line 5013 "parser.c" /* yacc.c:1646  */
    break;

  case 262:
#line 1233 "parser.y" /* yacc.c:1646  */
    { config.vbios_post = 1; }
#line 5019 "parser.c" /* yacc.c:1646  */
    break;

  case 263:
#line 1234 "parser.y" /* yacc.c:1646  */
    { config.dualmon = 1; }
#line 5025 "parser.c" /* yacc.c:1646  */
    break;

  case 264:
#line 1235 "parser.y" /* yacc.c:1646  */
    { config.force_vt_switch = 1; }
#line 5031 "parser.c" /* yacc.c:1646  */
    break;

  case 265:
#line 1236 "parser.y" /* yacc.c:1646  */
    { config.pci_video = 1; }
#line 5037 "parser.c" /* yacc.c:1646  */
    break;

  case 266:
#line 1238 "parser.y" /* yacc.c:1646  */
    { yyerror("unrecognized video option '%s'", (yyvsp[0].s_value));
		      free((yyvsp[0].s_value)); }
#line 5044 "parser.c" /* yacc.c:1646  */
    break;

  case 270:
#line 1248 "parser.y" /* yacc.c:1646  */
    { config.term_esc_char = (yyvsp[0].i_value); }
#line 5050 "parser.c" /* yacc.c:1646  */
    break;

  case 271:
#line 1249 "parser.y" /* yacc.c:1646  */
    { config.term_color = ((yyvsp[0].i_value)!=0); }
#line 5056 "parser.c" /* yacc.c:1646  */
    break;

  case 272:
#line 1251 "parser.y" /* yacc.c:1646  */
    { yyerror("unrecognized terminal option '%s'", (yyvsp[0].s_value));
		      free((yyvsp[0].s_value)); }
#line 5063 "parser.c" /* yacc.c:1646  */
    break;

  case 276:
#line 1265 "parser.y" /* yacc.c:1646  */
    { set_debug_level('v', ((yyvsp[0].i_value)!=0)); }
#line 5069 "parser.c" /* yacc.c:1646  */
    break;

  case 277:
#line 1266 "parser.y" /* yacc.c:1646  */
    { set_debug_level('a', 0); }
#line 5075 "parser.c" /* yacc.c:1646  */
    break;

  case 278:
#line 1267 "parser.y" /* yacc.c:1646  */
    { set_debug_level('s', ((yyvsp[0].i_value)!=0)); }
#line 5081 "parser.c" /* yacc.c:1646  */
    break;

  case 279:
#line 1268 "parser.y" /* yacc.c:1646  */
    { set_debug_level('c', ((yyvsp[0].i_value)!=0)); }
#line 5087 "parser.c" /* yacc.c:1646  */
    break;

  case 280:
#line 1269 "parser.y" /* yacc.c:1646  */
    { set_debug_level('d', ((yyvsp[0].i_value)!=0)); }
#line 5093 "parser.c" /* yacc.c:1646  */
    break;

  case 281:
#line 1270 "parser.y" /* yacc.c:1646  */
    { set_debug_level('R', ((yyvsp[0].i_value)!=0)); }
#line 5099 "parser.c" /* yacc.c:1646  */
    break;

  case 282:
#line 1271 "parser.y" /* yacc.c:1646  */
    { set_debug_level('W', ((yyvsp[0].i_value)!=0)); }
#line 5105 "parser.c" /* yacc.c:1646  */
    break;

  case 283:
#line 1272 "parser.y" /* yacc.c:1646  */
    { set_debug_level('k', ((yyvsp[0].i_value)!=0)); }
#line 5111 "parser.c" /* yacc.c:1646  */
    break;

  case 284:
#line 1273 "parser.y" /* yacc.c:1646  */
    { set_debug_level('k', ((yyvsp[0].i_value)!=0)); }
#line 5117 "parser.c" /* yacc.c:1646  */
    break;

  case 285:
#line 1274 "parser.y" /* yacc.c:1646  */
    { set_debug_level('p', ((yyvsp[0].i_value)!=0)); }
#line 5123 "parser.c" /* yacc.c:1646  */
    break;

  case 286:
#line 1275 "parser.y" /* yacc.c:1646  */
    { set_debug_level('i', ((yyvsp[0].i_value)!=0)); }
#line 5129 "parser.c" /* yacc.c:1646  */
    break;

  case 287:
#line 1276 "parser.y" /* yacc.c:1646  */
    { set_debug_level('i', ((yyvsp[0].i_value)!=0)); }
#line 5135 "parser.c" /* yacc.c:1646  */
    break;

  case 288:
#line 1277 "parser.y" /* yacc.c:1646  */
    { set_debug_level('w', ((yyvsp[0].i_value)!=0)); }
#line 5141 "parser.c" /* yacc.c:1646  */
    break;

  case 289:
#line 1278 "parser.y" /* yacc.c:1646  */
    { set_debug_level('g', ((yyvsp[0].i_value)!=0)); }
#line 5147 "parser.c" /* yacc.c:1646  */
    break;

  case 290:
#line 1279 "parser.y" /* yacc.c:1646  */
    { set_debug_level('X', ((yyvsp[0].i_value)!=0)); }
#line 5153 "parser.c" /* yacc.c:1646  */
    break;

  case 291:
#line 1280 "parser.y" /* yacc.c:1646  */
    { set_debug_level('M', ((yyvsp[0].i_value)!=0)); }
#line 5159 "parser.c" /* yacc.c:1646  */
    break;

  case 292:
#line 1281 "parser.y" /* yacc.c:1646  */
    { set_debug_level('m', ((yyvsp[0].i_value)!=0)); }
#line 5165 "parser.c" /* yacc.c:1646  */
    break;

  case 293:
#line 1282 "parser.y" /* yacc.c:1646  */
    { set_debug_level('h', ((yyvsp[0].i_value)!=0)); }
#line 5171 "parser.c" /* yacc.c:1646  */
    break;

  case 294:
#line 1283 "parser.y" /* yacc.c:1646  */
    { set_debug_level('I', ((yyvsp[0].i_value)!=0)); }
#line 5177 "parser.c" /* yacc.c:1646  */
    break;

  case 295:
#line 1284 "parser.y" /* yacc.c:1646  */
    { set_debug_level('E', ((yyvsp[0].i_value)!=0)); }
#line 5183 "parser.c" /* yacc.c:1646  */
    break;

  case 296:
#line 1285 "parser.y" /* yacc.c:1646  */
    { set_debug_level('n', ((yyvsp[0].i_value)!=0)); }
#line 5189 "parser.c" /* yacc.c:1646  */
    break;

  case 297:
#line 1286 "parser.y" /* yacc.c:1646  */
    { set_debug_level('X', ((yyvsp[0].i_value)!=0)); }
#line 5195 "parser.c" /* yacc.c:1646  */
    break;

  case 298:
#line 1287 "parser.y" /* yacc.c:1646  */
    { set_debug_level('v', ((yyvsp[0].i_value)!=0)); }
#line 5201 "parser.c" /* yacc.c:1646  */
    break;

  case 299:
#line 1288 "parser.y" /* yacc.c:1646  */
    { set_debug_level('S', ((yyvsp[0].i_value)!=0)); }
#line 5207 "parser.c" /* yacc.c:1646  */
    break;

  case 300:
#line 1289 "parser.y" /* yacc.c:1646  */
    { set_debug_level('j', ((yyvsp[0].i_value)!=0)); }
#line 5213 "parser.c" /* yacc.c:1646  */
    break;

  case 301:
#line 1291 "parser.y" /* yacc.c:1646  */
    { yyerror("unrecognized debug flag '%s'", (yyvsp[0].s_value)); free((yyvsp[0].s_value)); }
#line 5219 "parser.c" /* yacc.c:1646  */
    break;

  case 305:
#line 1300 "parser.y" /* yacc.c:1646  */
    { free(mptr->dev); mptr->dev = (yyvsp[0].s_value); }
#line 5225 "parser.c" /* yacc.c:1646  */
    break;

  case 306:
#line 1301 "parser.y" /* yacc.c:1646  */
    { mptr->intdrv = TRUE; }
#line 5231 "parser.c" /* yacc.c:1646  */
    break;

  case 307:
#line 1302 "parser.y" /* yacc.c:1646  */
    { mptr->emulate3buttons = TRUE; }
#line 5237 "parser.c" /* yacc.c:1646  */
    break;

  case 308:
#line 1303 "parser.y" /* yacc.c:1646  */
    { mptr->baudRate = (yyvsp[0].i_value); }
#line 5243 "parser.c" /* yacc.c:1646  */
    break;

  case 309:
#line 1305 "parser.y" /* yacc.c:1646  */
    { if (mptr->type == MOUSE_MOUSESYSTEMS)
			 mptr->cleardtr = TRUE;
		      else
			 yyerror("option CLEARDTR is only valid for MicroSystems-mice");
		    }
#line 5253 "parser.c" /* yacc.c:1646  */
    break;

  case 310:
#line 1311 "parser.y" /* yacc.c:1646  */
    {
		  mptr->type = MOUSE_MICROSOFT;
		  mptr->flags = CS7 | CREAD | CLOCAL | HUPCL;
		  }
#line 5262 "parser.c" /* yacc.c:1646  */
    break;

  case 311:
#line 1316 "parser.y" /* yacc.c:1646  */
    {
		  mptr->type = MOUSE_MS3BUTTON;
		  mptr->flags = CS7 | CREAD | CLOCAL | HUPCL;
		  }
#line 5271 "parser.c" /* yacc.c:1646  */
    break;

  case 312:
#line 1321 "parser.y" /* yacc.c:1646  */
    {
		  mptr->type = MOUSE_MOUSESYSTEMS;
		  mptr->flags = CS8 | CREAD | CLOCAL | HUPCL;
/* is cstopb needed?  mptr->flags = CS8 | CSTOPB | CREAD | CLOCAL | HUPCL; */
		  }
#line 5281 "parser.c" /* yacc.c:1646  */
    break;

  case 313:
#line 1327 "parser.y" /* yacc.c:1646  */
    {
		  mptr->type = MOUSE_MMSERIES;
		  mptr->flags = CS8 | PARENB | PARODD | CREAD | CLOCAL | HUPCL;
		  }
#line 5290 "parser.c" /* yacc.c:1646  */
    break;

  case 314:
#line 1332 "parser.y" /* yacc.c:1646  */
    {
		  mptr->type = MOUSE_LOGITECH;
		  mptr->flags = CS8 | CSTOPB | CREAD | CLOCAL | HUPCL;
		  }
#line 5299 "parser.c" /* yacc.c:1646  */
    break;

  case 315:
#line 1337 "parser.y" /* yacc.c:1646  */
    {
		  mptr->type = MOUSE_PS2;
		  mptr->flags = 0;
		  }
#line 5308 "parser.c" /* yacc.c:1646  */
    break;

  case 316:
#line 1342 "parser.y" /* yacc.c:1646  */
    {
		  mptr->type = MOUSE_IMPS2;
		  mptr->flags = 0;
		  }
#line 5317 "parser.c" /* yacc.c:1646  */
    break;

  case 317:
#line 1347 "parser.y" /* yacc.c:1646  */
    {
		  mptr->type = MOUSE_MOUSEMAN;
		  mptr->flags = CS7 | CREAD | CLOCAL | HUPCL;
		  }
#line 5326 "parser.c" /* yacc.c:1646  */
    break;

  case 318:
#line 1352 "parser.y" /* yacc.c:1646  */
    {
		  mptr->type = MOUSE_HITACHI;
		  mptr->flags = CS8 | CREAD | CLOCAL | HUPCL;
		  }
#line 5335 "parser.c" /* yacc.c:1646  */
    break;

  case 319:
#line 1357 "parser.y" /* yacc.c:1646  */
    {
		  mptr->type = MOUSE_BUSMOUSE;
		  mptr->flags = 0;
		  }
#line 5344 "parser.c" /* yacc.c:1646  */
    break;

  case 320:
#line 1362 "parser.y" /* yacc.c:1646  */
    { yyerror("unrecognized mouse flag '%s'", (yyvsp[0].s_value)); free((yyvsp[0].s_value)); }
#line 5350 "parser.c" /* yacc.c:1646  */
    break;

  case 324:
#line 1371 "parser.y" /* yacc.c:1646  */
    { keyb_layout((yyvsp[0].i_value)); }
#line 5356 "parser.c" /* yacc.c:1646  */
    break;

  case 325:
#line 1372 "parser.y" /* yacc.c:1646  */
    {keyb_layout((yyvsp[0].i_value));}
#line 5362 "parser.c" /* yacc.c:1646  */
    break;

  case 327:
#line 1373 "parser.y" /* yacc.c:1646  */
    { keyb_layout(KEYB_NO); }
#line 5368 "parser.c" /* yacc.c:1646  */
    break;

  case 328:
#line 1374 "parser.y" /* yacc.c:1646  */
    { keyb_layout(-1); }
#line 5374 "parser.c" /* yacc.c:1646  */
    break;

  case 329:
#line 1375 "parser.y" /* yacc.c:1646  */
    { config.console_keyb = (yyvsp[0].i_value); }
#line 5380 "parser.c" /* yacc.c:1646  */
    break;

  case 330:
#line 1377 "parser.y" /* yacc.c:1646  */
    { yyerror("unrecognized keyboard flag '%s'", (yyvsp[0].s_value));
		      free((yyvsp[0].s_value));}
#line 5387 "parser.c" /* yacc.c:1646  */
    break;

  case 334:
#line 1386 "parser.y" /* yacc.c:1646  */
    { keyb_mod('C', (yyvsp[-1].i_value), 0); }
#line 5393 "parser.c" /* yacc.c:1646  */
    break;

  case 336:
#line 1387 "parser.y" /* yacc.c:1646  */
    { keyb_mod('a', (yyvsp[-1].i_value), 0); }
#line 5399 "parser.c" /* yacc.c:1646  */
    break;

  case 338:
#line 1388 "parser.y" /* yacc.c:1646  */
    { keyb_mod('c', (yyvsp[-1].i_value), 0); }
#line 5405 "parser.c" /* yacc.c:1646  */
    break;

  case 340:
#line 1389 "parser.y" /* yacc.c:1646  */
    { keyb_mod(' ', (yyvsp[-1].i_value), 0); }
#line 5411 "parser.c" /* yacc.c:1646  */
    break;

  case 342:
#line 1390 "parser.y" /* yacc.c:1646  */
    { keyb_mod('S', (yyvsp[-1].i_value), 0); }
#line 5417 "parser.c" /* yacc.c:1646  */
    break;

  case 344:
#line 1391 "parser.y" /* yacc.c:1646  */
    { keyb_mod('A', (yyvsp[-1].i_value), 0); }
#line 5423 "parser.c" /* yacc.c:1646  */
    break;

  case 346:
#line 1392 "parser.y" /* yacc.c:1646  */
    { keyb_mod('N', (yyvsp[-1].i_value), 0); }
#line 5429 "parser.c" /* yacc.c:1646  */
    break;

  case 350:
#line 1399 "parser.y" /* yacc.c:1646  */
    { keyb_mod(0, (yyvsp[0].i_value), 1); }
#line 5435 "parser.c" /* yacc.c:1646  */
    break;

  case 351:
#line 1400 "parser.y" /* yacc.c:1646  */
    { keyb_mod(0, DKY_DEAD_GRAVE, 1); }
#line 5441 "parser.c" /* yacc.c:1646  */
    break;

  case 352:
#line 1401 "parser.y" /* yacc.c:1646  */
    { keyb_mod(0, DKY_DEAD_ACUTE, 1); }
#line 5447 "parser.c" /* yacc.c:1646  */
    break;

  case 353:
#line 1402 "parser.y" /* yacc.c:1646  */
    { keyb_mod(0, DKY_DEAD_CIRCUMFLEX, 1); }
#line 5453 "parser.c" /* yacc.c:1646  */
    break;

  case 354:
#line 1403 "parser.y" /* yacc.c:1646  */
    { keyb_mod(0, DKY_DEAD_TILDE, 1); }
#line 5459 "parser.c" /* yacc.c:1646  */
    break;

  case 355:
#line 1404 "parser.y" /* yacc.c:1646  */
    { keyb_mod(0, DKY_DEAD_BREVE, 1); }
#line 5465 "parser.c" /* yacc.c:1646  */
    break;

  case 356:
#line 1405 "parser.y" /* yacc.c:1646  */
    { keyb_mod(0, DKY_DEAD_ABOVEDOT, 1); }
#line 5471 "parser.c" /* yacc.c:1646  */
    break;

  case 357:
#line 1406 "parser.y" /* yacc.c:1646  */
    { keyb_mod(0, DKY_DEAD_DIAERESIS, 1); }
#line 5477 "parser.c" /* yacc.c:1646  */
    break;

  case 358:
#line 1407 "parser.y" /* yacc.c:1646  */
    { keyb_mod(0, DKY_DEAD_ABOVERING, 1); }
#line 5483 "parser.c" /* yacc.c:1646  */
    break;

  case 359:
#line 1408 "parser.y" /* yacc.c:1646  */
    { keyb_mod(0, DKY_DEAD_DOUBLEACUTE, 1); }
#line 5489 "parser.c" /* yacc.c:1646  */
    break;

  case 360:
#line 1409 "parser.y" /* yacc.c:1646  */
    { keyb_mod(0, DKY_DEAD_CEDILLA, 1); }
#line 5495 "parser.c" /* yacc.c:1646  */
    break;

  case 361:
#line 1410 "parser.y" /* yacc.c:1646  */
    { keyb_mod(0, DKY_VOID, 1); }
#line 5501 "parser.c" /* yacc.c:1646  */
    break;

  case 362:
#line 1411 "parser.y" /* yacc.c:1646  */
    { keyb_mod(0,DKY_DEAD_OGONEK, 1); }
#line 5507 "parser.c" /* yacc.c:1646  */
    break;

  case 363:
#line 1412 "parser.y" /* yacc.c:1646  */
    { keyb_mod(0, DKY_DEAD_CARON, 1); }
#line 5513 "parser.c" /* yacc.c:1646  */
    break;

  case 364:
#line 1413 "parser.y" /* yacc.c:1646  */
    { keyb_mod(0, (yyvsp[0].i_value), 0); }
#line 5519 "parser.c" /* yacc.c:1646  */
    break;

  case 365:
#line 1414 "parser.y" /* yacc.c:1646  */
    { keyb_mod(0, (yyvsp[-1].i_value), 0); }
#line 5525 "parser.c" /* yacc.c:1646  */
    break;

  case 366:
#line 1415 "parser.y" /* yacc.c:1646  */
    {
			char *p = (yyvsp[0].s_value);
			while (*p) keyb_mod(0, *p++, 0);
			free((yyvsp[0].s_value));
		}
#line 5535 "parser.c" /* yacc.c:1646  */
    break;

  case 369:
#line 1427 "parser.y" /* yacc.c:1646  */
    { free(config.tty_lockdir); config.tty_lockdir = (yyvsp[0].s_value); }
#line 5541 "parser.c" /* yacc.c:1646  */
    break;

  case 370:
#line 1428 "parser.y" /* yacc.c:1646  */
    { free(config.tty_lockfile); config.tty_lockfile = (yyvsp[0].s_value); }
#line 5547 "parser.c" /* yacc.c:1646  */
    break;

  case 371:
#line 1429 "parser.y" /* yacc.c:1646  */
    { config.tty_lockbinary = TRUE; }
#line 5553 "parser.c" /* yacc.c:1646  */
    break;

  case 372:
#line 1431 "parser.y" /* yacc.c:1646  */
    { yyerror("unrecognized ttylocks flag '%s'", (yyvsp[0].s_value)); free((yyvsp[0].s_value)); }
#line 5559 "parser.c" /* yacc.c:1646  */
    break;

  case 376:
#line 1440 "parser.y" /* yacc.c:1646  */
    { free(sptr->dev); sptr->dev = (yyvsp[0].s_value); }
#line 5565 "parser.c" /* yacc.c:1646  */
    break;

  case 377:
#line 1441 "parser.y" /* yacc.c:1646  */
    {
					   if (isatty(0)) {
					     sptr->virtual = TRUE;
					     sptr->pseudo = TRUE;
					     no_local_video = 1;
					     sptr->dev = strdup(ttyname(0));
					   } else {
					     error("FD 0 is not a tty, can't "
					           "use a virtual com port\n");
					     exit(1);
					   }
					  }
#line 5582 "parser.c" /* yacc.c:1646  */
    break;

  case 378:
#line 1453 "parser.y" /* yacc.c:1646  */
    { sptr->pseudo = TRUE; }
#line 5588 "parser.c" /* yacc.c:1646  */
    break;

  case 379:
#line 1454 "parser.y" /* yacc.c:1646  */
    { sptr->vmodem = TRUE; }
#line 5594 "parser.c" /* yacc.c:1646  */
    break;

  case 380:
#line 1455 "parser.y" /* yacc.c:1646  */
    { sptr->system_rtscts = TRUE; }
#line 5600 "parser.c" /* yacc.c:1646  */
    break;

  case 381:
#line 1456 "parser.y" /* yacc.c:1646  */
    { sptr->low_latency = TRUE; }
#line 5606 "parser.c" /* yacc.c:1646  */
    break;

  case 382:
#line 1457 "parser.y" /* yacc.c:1646  */
    { sptr->custom = SER_CUSTOM_PCCOM; }
#line 5612 "parser.c" /* yacc.c:1646  */
    break;

  case 383:
#line 1458 "parser.y" /* yacc.c:1646  */
    { sptr->real_comport = (yyvsp[0].i_value); }
#line 5618 "parser.c" /* yacc.c:1646  */
    break;

  case 384:
#line 1459 "parser.y" /* yacc.c:1646  */
    { sptr->base_port = (yyvsp[0].i_value); }
#line 5624 "parser.c" /* yacc.c:1646  */
    break;

  case 385:
#line 1460 "parser.y" /* yacc.c:1646  */
    { sptr->irq = (yyvsp[0].i_value); }
#line 5630 "parser.c" /* yacc.c:1646  */
    break;

  case 386:
#line 1461 "parser.y" /* yacc.c:1646  */
    { sptr->mouse = 1; }
#line 5636 "parser.c" /* yacc.c:1646  */
    break;

  case 387:
#line 1463 "parser.y" /* yacc.c:1646  */
    { yyerror("unrecognized serial flag '%s'", (yyvsp[0].s_value)); free((yyvsp[0].s_value)); }
#line 5642 "parser.c" /* yacc.c:1646  */
    break;

  case 391:
#line 1472 "parser.y" /* yacc.c:1646  */
    { c_printers = (yyvsp[0].i_value) - 1; }
#line 5648 "parser.c" /* yacc.c:1646  */
    break;

  case 392:
#line 1473 "parser.y" /* yacc.c:1646  */
    { pptr->prtcmd = (yyvsp[0].s_value); }
#line 5654 "parser.c" /* yacc.c:1646  */
    break;

  case 393:
#line 1474 "parser.y" /* yacc.c:1646  */
    { pptr->delay = (yyvsp[0].i_value); }
#line 5660 "parser.c" /* yacc.c:1646  */
    break;

  case 394:
#line 1475 "parser.y" /* yacc.c:1646  */
    { pptr->dev = (yyvsp[0].s_value); }
#line 5666 "parser.c" /* yacc.c:1646  */
    break;

  case 395:
#line 1476 "parser.y" /* yacc.c:1646  */
    { pptr->base_port = (yyvsp[0].i_value); }
#line 5672 "parser.c" /* yacc.c:1646  */
    break;

  case 396:
#line 1478 "parser.y" /* yacc.c:1646  */
    { yyerror("unrecognized printer flag %s", (yyvsp[0].s_value)); free((yyvsp[0].s_value)); }
#line 5678 "parser.c" /* yacc.c:1646  */
    break;

  case 400:
#line 1487 "parser.y" /* yacc.c:1646  */
    { dptr->wantrdonly = 1; }
#line 5684 "parser.c" /* yacc.c:1646  */
    break;

  case 401:
#line 1488 "parser.y" /* yacc.c:1646  */
    { dptr->default_cmos = THREE_INCH_FLOPPY; }
#line 5690 "parser.c" /* yacc.c:1646  */
    break;

  case 402:
#line 1489 "parser.y" /* yacc.c:1646  */
    { dptr->default_cmos = THREE_INCH_2880KFLOP; }
#line 5696 "parser.c" /* yacc.c:1646  */
    break;

  case 403:
#line 1490 "parser.y" /* yacc.c:1646  */
    { dptr->default_cmos = THREE_INCH_720KFLOP; }
#line 5702 "parser.c" /* yacc.c:1646  */
    break;

  case 404:
#line 1491 "parser.y" /* yacc.c:1646  */
    { dptr->default_cmos = FIVE_INCH_FLOPPY; }
#line 5708 "parser.c" /* yacc.c:1646  */
    break;

  case 405:
#line 1492 "parser.y" /* yacc.c:1646  */
    { dptr->default_cmos = FIVE_INCH_360KFLOP; }
#line 5714 "parser.c" /* yacc.c:1646  */
    break;

  case 406:
#line 1494 "parser.y" /* yacc.c:1646  */
    {
		  struct stat st;

		  if (dptr->dev_name != NULL)
		    yyerror("Two names for a floppy-device given.");
		  if (stat((yyvsp[0].s_value), &st) < 0) {
		    yyerror("Could not stat floppy device.");
		  }
		  if (S_ISREG(st.st_mode)) {
		    dptr->type = IMAGE;
		  } else if (S_ISBLK(st.st_mode)) {
		    dptr->type = FLOPPY;
		  } else if (S_ISDIR(st.st_mode)) {
		    dptr->type = DIR_TYPE;
		  } else {
		    yyerror("Floppy device/file %s is wrong type", (yyvsp[0].s_value));
		  }
		  dptr->dev_name = (yyvsp[0].s_value);
		  dptr->floppy = 1;  // tell IMAGE and DIR we are a floppy
		  }
#line 5739 "parser.c" /* yacc.c:1646  */
    break;

  case 407:
#line 1515 "parser.y" /* yacc.c:1646  */
    {
		  if (dptr->dev_name != NULL)
		    yyerror("Two names for a disk-image file or device given.");
		  dptr->dev_name = (yyvsp[0].s_value);
		  }
#line 5749 "parser.c" /* yacc.c:1646  */
    break;

  case 408:
#line 1521 "parser.y" /* yacc.c:1646  */
    {
		  if (dptr->dev_name != NULL)
		    yyerror("Two names for a directory given.");
		  dptr->type = DIR_TYPE;
		  dptr->dev_name = (yyvsp[0].s_value);
		  }
#line 5760 "parser.c" /* yacc.c:1646  */
    break;

  case 409:
#line 1528 "parser.y" /* yacc.c:1646  */
    { yyerror("unrecognized floppy disk flag '%s'\n", (yyvsp[0].s_value)); free((yyvsp[0].s_value)); }
#line 5766 "parser.c" /* yacc.c:1646  */
    break;

  case 413:
#line 1535 "parser.y" /* yacc.c:1646  */
    { dptr->wantrdonly = 1; }
#line 5772 "parser.c" /* yacc.c:1646  */
    break;

  case 414:
#line 1536 "parser.y" /* yacc.c:1646  */
    { dptr->diskcyl4096 = 1; }
#line 5778 "parser.c" /* yacc.c:1646  */
    break;

  case 415:
#line 1537 "parser.y" /* yacc.c:1646  */
    { dptr->hdtype = 1; }
#line 5784 "parser.c" /* yacc.c:1646  */
    break;

  case 416:
#line 1538 "parser.y" /* yacc.c:1646  */
    { dptr->hdtype = 2; }
#line 5790 "parser.c" /* yacc.c:1646  */
    break;

  case 417:
#line 1539 "parser.y" /* yacc.c:1646  */
    { dptr->hdtype = 9; }
#line 5796 "parser.c" /* yacc.c:1646  */
    break;

  case 418:
#line 1540 "parser.y" /* yacc.c:1646  */
    { dptr->sectors = (yyvsp[0].i_value); }
#line 5802 "parser.c" /* yacc.c:1646  */
    break;

  case 419:
#line 1541 "parser.y" /* yacc.c:1646  */
    { dptr->tracks = (yyvsp[0].i_value); }
#line 5808 "parser.c" /* yacc.c:1646  */
    break;

  case 420:
#line 1542 "parser.y" /* yacc.c:1646  */
    { dptr->tracks = (yyvsp[0].i_value); }
#line 5814 "parser.c" /* yacc.c:1646  */
    break;

  case 421:
#line 1543 "parser.y" /* yacc.c:1646  */
    { dptr->heads = (yyvsp[0].i_value); }
#line 5820 "parser.c" /* yacc.c:1646  */
    break;

  case 422:
#line 1544 "parser.y" /* yacc.c:1646  */
    { dptr->header = (yyvsp[0].i_value); }
#line 5826 "parser.c" /* yacc.c:1646  */
    break;

  case 423:
#line 1546 "parser.y" /* yacc.c:1646  */
    {
		  if (dptr->dev_name != NULL)
		    yyerror("Two names for a disk-image file or device given.");
		  dptr->dev_name = (yyvsp[0].s_value);
		  }
#line 5836 "parser.c" /* yacc.c:1646  */
    break;

  case 424:
#line 1552 "parser.y" /* yacc.c:1646  */
    {
		  if (dptr->dev_name != NULL)
		    yyerror("Two names for a disk-image file or device given.");
		  dptr->dev_name = (yyvsp[0].s_value);
		  }
#line 5846 "parser.c" /* yacc.c:1646  */
    break;

  case 425:
#line 1558 "parser.y" /* yacc.c:1646  */
    {
		  if (dptr->dev_name != NULL)
		    yyerror("Two names for a harddisk-image file given.");
		  dptr->type = IMAGE;
		  dptr->header = HEADER_SIZE;
		  dptr->dev_name = (yyvsp[0].s_value);
		  }
#line 5858 "parser.c" /* yacc.c:1646  */
    break;

  case 426:
#line 1566 "parser.y" /* yacc.c:1646  */
    {
		  if (dptr->dev_name != NULL)
		    yyerror("Two names for a harddisk given.");
		  dptr->type = HDISK;
		  dptr->dev_name = (yyvsp[0].s_value);
		  }
#line 5869 "parser.c" /* yacc.c:1646  */
    break;

  case 427:
#line 1573 "parser.y" /* yacc.c:1646  */
    {
                  yywarn("{ partition \"%s\" %d } the"
			 " token '%d' is ignored and can be removed.",
			 (yyvsp[-1].s_value),(yyvsp[0].i_value),(yyvsp[0].i_value));
		  do_part((yyvsp[-1].s_value));
		  }
#line 5880 "parser.c" /* yacc.c:1646  */
    break;

  case 428:
#line 1580 "parser.y" /* yacc.c:1646  */
    { do_part((yyvsp[0].s_value)); }
#line 5886 "parser.c" /* yacc.c:1646  */
    break;

  case 429:
#line 1582 "parser.y" /* yacc.c:1646  */
    {
		  if (dptr->dev_name != NULL)
		    yyerror("Two names for a directory given.");
		  dptr->type = DIR_TYPE;
		  dptr->dev_name = (yyvsp[0].s_value);
		  }
#line 5897 "parser.c" /* yacc.c:1646  */
    break;

  case 430:
#line 1589 "parser.y" /* yacc.c:1646  */
    { yyerror("unrecognized disk flag '%s'\n", (yyvsp[0].s_value)); free((yyvsp[0].s_value)); }
#line 5903 "parser.c" /* yacc.c:1646  */
    break;

  case 434:
#line 1599 "parser.y" /* yacc.c:1646  */
    {
		   c_printf("CONF: I/O port 0x%04x\n", (unsigned short)(yyvsp[0].i_value));
	           allow_io((yyvsp[0].i_value), 1, ports_permission, ports_ormask,
	                    ports_andmask, portspeed, (char*)dev_name);
		   if (portspeed) portspeed += ((portspeed>0) ? 1 : -1);
	           }
#line 5914 "parser.c" /* yacc.c:1646  */
    break;

  case 435:
#line 1606 "parser.y" /* yacc.c:1646  */
    {
	           allow_io((yyvsp[-1].i_value), 1, ports_permission, ports_ormask,
	                    ports_andmask, portspeed, (char*)dev_name);
		   if (portspeed) portspeed += ((portspeed>0) ? 1 : -1);
	           }
#line 5924 "parser.c" /* yacc.c:1646  */
    break;

  case 436:
#line 1612 "parser.y" /* yacc.c:1646  */
    {
		   if (portspeed > 1) portspeed = 0;
		   c_printf("CONF: range of I/O ports 0x%04x-0x%04x\n",
			    (unsigned short)(yyvsp[-1].i_value), (unsigned short)(yyvsp[0].i_value));
		   allow_io((yyvsp[-1].i_value), (yyvsp[0].i_value) - (yyvsp[-1].i_value) + 1, ports_permission, ports_ormask,
			    ports_andmask, portspeed, (char*)dev_name);
		   portspeed=0;
		   strcpy(dev_name,"");
		   }
#line 5938 "parser.c" /* yacc.c:1646  */
    break;

  case 437:
#line 1622 "parser.y" /* yacc.c:1646  */
    {
		   if (portspeed > 1) portspeed = 0;
		   c_printf("CONF: range of I/O ports 0x%04x-0x%04x\n",
			    (unsigned short)(yyvsp[-2].i_value), (unsigned short)(yyvsp[0].i_value));
		   allow_io((yyvsp[-2].i_value), (yyvsp[0].i_value) - (yyvsp[-2].i_value) + 1, ports_permission, ports_ormask,
			    ports_andmask, portspeed, (char*)dev_name);
		   portspeed=0;
		   strcpy(dev_name,"");
		   }
#line 5952 "parser.c" /* yacc.c:1646  */
    break;

  case 438:
#line 1631 "parser.y" /* yacc.c:1646  */
    { ports_permission = IO_READ; }
#line 5958 "parser.c" /* yacc.c:1646  */
    break;

  case 439:
#line 1632 "parser.y" /* yacc.c:1646  */
    { ports_permission = IO_WRITE; }
#line 5964 "parser.c" /* yacc.c:1646  */
    break;

  case 440:
#line 1633 "parser.y" /* yacc.c:1646  */
    { ports_permission = IO_RDWR; }
#line 5970 "parser.c" /* yacc.c:1646  */
    break;

  case 441:
#line 1634 "parser.y" /* yacc.c:1646  */
    { ports_ormask = (yyvsp[0].i_value); }
#line 5976 "parser.c" /* yacc.c:1646  */
    break;

  case 442:
#line 1635 "parser.y" /* yacc.c:1646  */
    { ports_andmask = (yyvsp[0].i_value); }
#line 5982 "parser.c" /* yacc.c:1646  */
    break;

  case 443:
#line 1636 "parser.y" /* yacc.c:1646  */
    { portspeed = 1; }
#line 5988 "parser.c" /* yacc.c:1646  */
    break;

  case 444:
#line 1637 "parser.y" /* yacc.c:1646  */
    { portspeed = -1; }
#line 5994 "parser.c" /* yacc.c:1646  */
    break;

  case 445:
#line 1638 "parser.y" /* yacc.c:1646  */
    { strcpy(dev_name,(yyvsp[0].s_value)); free((yyvsp[0].s_value)); }
#line 6000 "parser.c" /* yacc.c:1646  */
    break;

  case 446:
#line 1640 "parser.y" /* yacc.c:1646  */
    { yyerror("unrecognized port command '%s'", (yyvsp[0].s_value));
		      free((yyvsp[0].s_value)); }
#line 6007 "parser.c" /* yacc.c:1646  */
    break;

  case 450:
#line 1649 "parser.y" /* yacc.c:1646  */
    { register_port_traceing((yyvsp[0].i_value), (yyvsp[0].i_value)); }
#line 6013 "parser.c" /* yacc.c:1646  */
    break;

  case 451:
#line 1651 "parser.y" /* yacc.c:1646  */
    { register_port_traceing((yyvsp[-1].i_value), (yyvsp[-1].i_value)); }
#line 6019 "parser.c" /* yacc.c:1646  */
    break;

  case 452:
#line 1653 "parser.y" /* yacc.c:1646  */
    { register_port_traceing((yyvsp[-1].i_value), (yyvsp[0].i_value)); }
#line 6025 "parser.c" /* yacc.c:1646  */
    break;

  case 453:
#line 1655 "parser.y" /* yacc.c:1646  */
    { register_port_traceing((yyvsp[-2].i_value), (yyvsp[0].i_value)); }
#line 6031 "parser.c" /* yacc.c:1646  */
    break;

  case 454:
#line 1656 "parser.y" /* yacc.c:1646  */
    { clear_port_traceing(); }
#line 6037 "parser.c" /* yacc.c:1646  */
    break;

  case 455:
#line 1658 "parser.y" /* yacc.c:1646  */
    { yyerror("unrecognized port trace command '%s'", (yyvsp[0].s_value));
		      free((yyvsp[0].s_value)); }
#line 6044 "parser.c" /* yacc.c:1646  */
    break;

  case 459:
#line 1668 "parser.y" /* yacc.c:1646  */
    { set_irq_value(1, (yyvsp[0].i_value)); }
#line 6050 "parser.c" /* yacc.c:1646  */
    break;

  case 460:
#line 1669 "parser.y" /* yacc.c:1646  */
    { set_irq_value(1, (yyvsp[-1].i_value)); }
#line 6056 "parser.c" /* yacc.c:1646  */
    break;

  case 461:
#line 1670 "parser.y" /* yacc.c:1646  */
    { set_irq_value(0x10001, (yyvsp[0].i_value)); }
#line 6062 "parser.c" /* yacc.c:1646  */
    break;

  case 462:
#line 1671 "parser.y" /* yacc.c:1646  */
    { set_irq_range(1, (yyvsp[-1].i_value), (yyvsp[0].i_value)); }
#line 6068 "parser.c" /* yacc.c:1646  */
    break;

  case 463:
#line 1672 "parser.y" /* yacc.c:1646  */
    { set_irq_range(1, (yyvsp[-2].i_value), (yyvsp[0].i_value)); }
#line 6074 "parser.c" /* yacc.c:1646  */
    break;

  case 464:
#line 1673 "parser.y" /* yacc.c:1646  */
    { set_irq_range(0x10001, (yyvsp[-1].i_value), (yyvsp[0].i_value)); }
#line 6080 "parser.c" /* yacc.c:1646  */
    break;

  case 465:
#line 1674 "parser.y" /* yacc.c:1646  */
    { set_irq_range(0x10001, (yyvsp[-2].i_value), (yyvsp[0].i_value)); }
#line 6086 "parser.c" /* yacc.c:1646  */
    break;

  case 466:
#line 1676 "parser.y" /* yacc.c:1646  */
    { yyerror("unrecognized irqpassing command '%s'", (yyvsp[0].s_value));
		      free((yyvsp[0].s_value)); }
#line 6093 "parser.c" /* yacc.c:1646  */
    break;

  case 470:
#line 1687 "parser.y" /* yacc.c:1646  */
    {
		     config.ems_size = (yyvsp[0].i_value);
		     if ((yyvsp[0].i_value) > 0) c_printf("CONF: %dk bytes EMS memory\n", (yyvsp[0].i_value));
	           }
#line 6102 "parser.c" /* yacc.c:1646  */
    break;

  case 471:
#line 1692 "parser.y" /* yacc.c:1646  */
    {
		     config.ems_size = (yyvsp[-1].i_value);
		     if ((yyvsp[-1].i_value) > 0) c_printf("CONF: %dk bytes EMS memory\n", (yyvsp[-1].i_value));
	           }
#line 6111 "parser.c" /* yacc.c:1646  */
    break;

  case 472:
#line 1697 "parser.y" /* yacc.c:1646  */
    {
		     config.ems_size = (yyvsp[0].i_value);
		     if ((yyvsp[0].i_value) > 0) c_printf("CONF: %dk bytes EMS memory\n", (yyvsp[0].i_value));
		   }
#line 6120 "parser.c" /* yacc.c:1646  */
    break;

  case 473:
#line 1702 "parser.y" /* yacc.c:1646  */
    {
/* is there a technical reason why the EMS frame can't be at 0xC0000 or
   0xA0000 if there's space? */
#if 0
		     if ( (((yyvsp[0].i_value) & 0xfc00)>=0xc800) && (((yyvsp[0].i_value) & 0xfc00)<=0xe000) ) {
		       config.ems_frame = (yyvsp[0].i_value) & 0xfc00;
		       c_printf("CONF: EMS-frame = 0x%04x\n", config.ems_frame);
		     }
		     else yyerror("wrong EMS-frame: 0x%04x", (yyvsp[0].i_value));
#endif
	             config.ems_frame = (yyvsp[0].i_value) & 0xfc00;
		     c_printf("CONF: EMS-frame = 0x%04x\n", config.ems_frame);
		   }
#line 6138 "parser.c" /* yacc.c:1646  */
    break;

  case 474:
#line 1716 "parser.y" /* yacc.c:1646  */
    {
		     config.ems_uma_pages = (yyvsp[0].i_value);
		   }
#line 6146 "parser.c" /* yacc.c:1646  */
    break;

  case 475:
#line 1720 "parser.y" /* yacc.c:1646  */
    {
		     config.ems_cnv_pages = (yyvsp[0].i_value);
		   }
#line 6154 "parser.c" /* yacc.c:1646  */
    break;

  case 476:
#line 1724 "parser.y" /* yacc.c:1646  */
    { yyerror("unrecognized ems command '%s'", (yyvsp[0].s_value));
		      free((yyvsp[0].s_value)); }
#line 6161 "parser.c" /* yacc.c:1646  */
    break;

  case 480:
#line 1735 "parser.y" /* yacc.c:1646  */
    {
                     if (!register_hardware_ram('h', (yyvsp[0].i_value), PAGE_SIZE)) {
                       yyerror("wrong hardware ram address : 0x%08x", (yyvsp[0].i_value));
                     }
	           }
#line 6171 "parser.c" /* yacc.c:1646  */
    break;

  case 481:
#line 1741 "parser.y" /* yacc.c:1646  */
    {
                     if (!register_hardware_ram('h', (yyvsp[-1].i_value), PAGE_SIZE)) {
                       yyerror("wrong hardware ram address : 0x%08x", (yyvsp[-1].i_value));
                     }
	           }
#line 6181 "parser.c" /* yacc.c:1646  */
    break;

  case 482:
#line 1747 "parser.y" /* yacc.c:1646  */
    {
                     if (register_hardware_ram('h', (yyvsp[-1].i_value), (yyvsp[0].i_value) - (yyvsp[-1].i_value)))
	               c_printf("CONF: hardware ram pages at 0x%08x-%08x\n", (yyvsp[-1].i_value), (yyvsp[0].i_value));
                     else
                       yyerror("wrong hardware ram address : 0x%08x", (yyvsp[-1].i_value));
		   }
#line 6192 "parser.c" /* yacc.c:1646  */
    break;

  case 483:
#line 1754 "parser.y" /* yacc.c:1646  */
    {
                     if (register_hardware_ram('h', (yyvsp[-2].i_value), (yyvsp[0].i_value) - (yyvsp[-2].i_value)))
	               c_printf("CONF: hardware ram pages at 0x%08x-%08x\n", (yyvsp[-2].i_value), (yyvsp[0].i_value));
                     else
                       yyerror("wrong hardware ram address : 0x%08x", (yyvsp[-2].i_value));
		   }
#line 6203 "parser.c" /* yacc.c:1646  */
    break;

  case 484:
#line 1761 "parser.y" /* yacc.c:1646  */
    { yyerror("unrecognized hardware ram command '%s'", (yyvsp[0].s_value));
		      free((yyvsp[0].s_value)); }
#line 6210 "parser.c" /* yacc.c:1646  */
    break;

  case 488:
#line 1775 "parser.y" /* yacc.c:1646  */
    {
			if ((yyvsp[0].i_value) == -2) {
				yyerror("got 'on', expected 'off' or an integer");
			}
		}
#line 6220 "parser.c" /* yacc.c:1646  */
    break;

  case 489:
#line 1782 "parser.y" /* yacc.c:1646  */
    {
			if ( (yyvsp[0].i_value) && (((yyvsp[0].i_value) < 2) || ((yyvsp[0].i_value) > 15)) ) {
				yyerror("got '%d', expected 'off' or an integer 2..15", (yyvsp[0].i_value));
			} 
		}
#line 6230 "parser.c" /* yacc.c:1646  */
    break;

  case 490:
#line 1791 "parser.y" /* yacc.c:1646  */
    { (yyval.i_value) = SPKR_OFF; }
#line 6236 "parser.c" /* yacc.c:1646  */
    break;

  case 491:
#line 1792 "parser.y" /* yacc.c:1646  */
    { (yyval.i_value) = SPKR_NATIVE; }
#line 6242 "parser.c" /* yacc.c:1646  */
    break;

  case 492:
#line 1793 "parser.y" /* yacc.c:1646  */
    { (yyval.i_value) = SPKR_EMULATED; }
#line 6248 "parser.c" /* yacc.c:1646  */
    break;

  case 493:
#line 1794 "parser.y" /* yacc.c:1646  */
    { yyerror("got '%s', expected 'emulated' or 'native'", (yyvsp[0].s_value));
				  free((yyvsp[0].s_value)); }
#line 6255 "parser.c" /* yacc.c:1646  */
    break;

  case 494:
#line 1796 "parser.y" /* yacc.c:1646  */
    { yyerror("expected 'emulated' or 'native'"); }
#line 6261 "parser.c" /* yacc.c:1646  */
    break;

  case 495:
#line 1801 "parser.y" /* yacc.c:1646  */
    { (yyval.i_value) = 0; }
#line 6267 "parser.c" /* yacc.c:1646  */
    break;

  case 496:
#line 1802 "parser.y" /* yacc.c:1646  */
    { (yyval.i_value) = 3; }
#line 6273 "parser.c" /* yacc.c:1646  */
    break;

  case 497:
#line 1803 "parser.y" /* yacc.c:1646  */
    { (yyval.i_value) = 4; }
#line 6279 "parser.c" /* yacc.c:1646  */
    break;

  case 498:
#line 1804 "parser.y" /* yacc.c:1646  */
    { (yyval.i_value) = 5; }
#line 6285 "parser.c" /* yacc.c:1646  */
    break;

  case 499:
#line 1805 "parser.y" /* yacc.c:1646  */
    { (yyval.i_value) = 6; }
#line 6291 "parser.c" /* yacc.c:1646  */
    break;

  case 500:
#line 1806 "parser.y" /* yacc.c:1646  */
    { yyerror("got '%s', expected 'off', 'vm86' or 'full'", (yyvsp[0].s_value));
				  free((yyvsp[0].s_value)); }
#line 6298 "parser.c" /* yacc.c:1646  */
    break;

  case 501:
#line 1808 "parser.y" /* yacc.c:1646  */
    { yyerror("expected 'off', 'vm86' or 'full'"); }
#line 6304 "parser.c" /* yacc.c:1646  */
    break;

  case 502:
#line 1811 "parser.y" /* yacc.c:1646  */
    { (yyval.i_value) = -1; }
#line 6310 "parser.c" /* yacc.c:1646  */
    break;

  case 503:
#line 1812 "parser.y" /* yacc.c:1646  */
    { (yyval.i_value) = CPUVM_VM86; }
#line 6316 "parser.c" /* yacc.c:1646  */
    break;

  case 504:
#line 1813 "parser.y" /* yacc.c:1646  */
    { (yyval.i_value) = CPUVM_KVM; }
#line 6322 "parser.c" /* yacc.c:1646  */
    break;

  case 505:
#line 1814 "parser.y" /* yacc.c:1646  */
    { (yyval.i_value) = CPUVM_EMU; }
#line 6328 "parser.c" /* yacc.c:1646  */
    break;

  case 506:
#line 1815 "parser.y" /* yacc.c:1646  */
    { yyerror("got '%s' for cpu_vm", (yyvsp[0].s_value));
				  free((yyvsp[0].s_value)); }
#line 6335 "parser.c" /* yacc.c:1646  */
    break;

  case 507:
#line 1817 "parser.y" /* yacc.c:1646  */
    { yyerror("bad value for cpu_vm"); }
#line 6341 "parser.c" /* yacc.c:1646  */
    break;

  case 510:
#line 1824 "parser.y" /* yacc.c:1646  */
    { set_internal_charset ((yyvsp[0].s_value)); free((yyvsp[0].s_value)); }
#line 6347 "parser.c" /* yacc.c:1646  */
    break;

  case 511:
#line 1825 "parser.y" /* yacc.c:1646  */
    { set_external_charset ((yyvsp[0].s_value)); free((yyvsp[0].s_value)); }
#line 6353 "parser.c" /* yacc.c:1646  */
    break;


#line 6357 "parser.c" /* yacc.c:1646  */
      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);

  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
# define YYSYNTAX_ERROR yysyntax_error (&yymsg_alloc, &yymsg, \
                                        yyssp, yytoken)
      {
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = YYSYNTAX_ERROR;
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == 1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = (char *) YYSTACK_ALLOC (yymsg_alloc);
            if (!yymsg)
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = 2;
              }
            else
              {
                yysyntax_error_status = YYSYNTAX_ERROR;
                yymsgp = yymsg;
              }
          }
        yyerror (yymsgp);
        if (yysyntax_error_status == 2)
          goto yyexhaustedlab;
      }
# undef YYSYNTAX_ERROR
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYTERROR;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  yystos[yystate], yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined yyoverflow || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  yystos[*yyssp], yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  return yyresult;
}
#line 1828 "parser.y" /* yacc.c:1906  */


	/* features */

static void handle_features(int which, int value)
{
  if ((which < 0)
	|| (which >= (sizeof(config.features) / sizeof(config.features[0])))) {
    c_printf("CONF: wrong feature number %d\n", which);
    return;
  }
  config.features[which] = value;
  c_printf("CONF: feature %d set to %d\n", which, value);
}

	/* joystick */

static void set_joy_device(char *devstring)
{
  char *spacepos;

  free(config.joy_device[0]);
  config.joy_device[0] = devstring;
  config.joy_device[1] = NULL;
  spacepos = strchr(devstring, ' ');
  if (spacepos != NULL) {
    *spacepos = '\0';
    config.joy_device[1] = spacepos + 1;
  }
}

	/* mouse */

static void start_mouse(void)
{
  mptr = &config.mouse;
  mptr->fd = -1;
  mptr->com = -1;
  mptr->has3buttons = 1;	// drivers can disable this
}

static void stop_mouse(void)
{
  char *p, *p1;
  if (mptr->dev && (p = strstr(mptr->dev, "com")) && strlen(p) > 3) {
    /* parse comX setting */
    mptr->com = atoi(p + 3);
    /* see if something else is specified and remove comX */
    if (p > mptr->dev) {
      p[-1] = 0;
    } else if ((p1 = strchr(p, ','))) {
      int l;
      p1++;
      l = strlen(p1);
      memmove(mptr->dev, p1, l + 1);
    } else {
      free(mptr->dev);
      mptr->dev = NULL;
    }
    c_printf("MOUSE: using COM%i\n", mptr->com);
  }
  c_printf("MOUSE: %s, type %x using internaldriver: %s, emulate3buttons: %s baudrate: %d\n", 
        mptr->dev && mptr->dev[0] ? mptr->dev : "no device specified",
        mptr->type, mptr->intdrv ? "yes" : "no", 
        mptr->emulate3buttons ? "yes" : "no", mptr->baudRate);
}

	/* debug */

static void start_ports(void)
{
  if (priv_lvl)
    yyerror("Can not change port privileges in user config file");
  ports_permission = IO_RDWR;
  ports_ormask = 0;
  ports_andmask = 0xFFFF;
}

	/* debug */

static void start_debug(void)
{
  set_debug_level('a', 0);	      /* Default is no debugging output at all */
}

	/* video */

static void start_video(void)
{
  free(config.vbios_file);
  config.vbios_file = NULL;
  config.vbios_copy = 0;
  config.vbios_seg  = 0xc000;
  config.vbios_size = 0x10000;
  config.console_video = 0;
  config.cardtype = CARD_NONE;
  config.chipset = PLAINVGA;
  config.mapped_bios = 0;
  config.vga = 0;
  config.gfxmemsize = 256;
  config.fullrestore = 0;
  config.dualmon = 0;
  config.force_vt_switch = 0;
}

static void stop_video(void)
{
  if (priv_lvl)
    config.console_video = 0;

  if ((config.cardtype != CARD_VGA) || !config.console_video) {
    config.vga = 0;
  }
}

	/* vesa modes */
static void set_vesamodes(int width, int height, int color_bits)
{
  vesamode_type *vmt = malloc(sizeof *vmt);
  if(vmt != NULL) {
    vmt->width = width;
    vmt->height = height;
    vmt->color_bits = color_bits;
    vmt->next = config.vesamode_list;
    config.vesamode_list = vmt;
  }
}

	/* vbios detection */
static int auto_vbios_seg = -1;
static int auto_vbios_size = -1;

static void detect_vbios(void)
{
  unsigned char c[0x21];
  int foffset;

  if (auto_vbios_seg != -1) return;
  if (!can_do_root_stuff || config.vbios_file) return;
  for (foffset = 0xc0000; foffset < 0xf0000; foffset += 0x800) {
    load_file("/dev/mem", foffset, c, sizeof(c));
    if (c[0]==0x55 && c[1]==0xaa
        && c[0x1e]=='I' && c[0x1f]=='B' && c[0x20]=='M') {
      auto_vbios_seg = foffset >> 4;
      auto_vbios_size = c[2]*0x200;
      break;
    }
  }
}

static int detect_vbios_seg(void)
{
  detect_vbios();
  return auto_vbios_seg;
}

static int detect_vbios_size(void)
{
  detect_vbios();
  return auto_vbios_size;
}

static void stop_ttylocks(void)
{
  c_printf("SER: directory %s namestub %s binary %s\n", config.tty_lockdir,
	   config.tty_lockfile,(config.tty_lockbinary?"Yes":"No"));
}

	/* serial */

static void start_serial(void)
{
  if (c_ser >= MAX_SER)
    sptr = &nullser;
  else {
    /* The defaults for interrupt, base_port, real_comport and dev are 
    ** automatically filled in inside the do_ser_init routine of serial.c
    */
    sptr = &com_cfg[c_ser];
    sptr->dev = NULL;
    sptr->irq = 0; 
    sptr->base_port = 0;
    sptr->end_port = 0;
    sptr->real_comport = 0;
    sptr->mouse = 0;
    sptr->virtual = FALSE;
    sptr->pseudo = FALSE;
    sptr->system_rtscts = FALSE;
    sptr->low_latency = FALSE;
    sptr->dmx_port = 0;
    sptr->custom = SER_CUSTOM_NONE;
  }
}


static void stop_serial(void)
{
  if (c_ser >= MAX_SER) {
    c_printf("SER: too many ports, ignoring %s\n", sptr->dev);
    return;
  }
  c_printf("SER%d: %s", c_ser, sptr->dev ?: "none");
  if (sptr->base_port)
    c_printf(" port %x", sptr->base_port);
  if (sptr->irq)
    c_printf(" irq %x", sptr->irq);
  c_printf("\n");
  c_ser++;
  config.num_ser = c_ser;
}

	/* keyboard */

static int keyboard_statement_already = 0;

static void start_keyboard(void)
{
  keyb_layout(KEYB_USER); /* NOTE: the default has changed, --Hans, 971204 */
  config.console_keyb = 0;
  keyboard_statement_already = 1;
}

static void stop_terminal(void)
{
}

	/* printer */

static void start_printer(void)
{
  pptr->prtcmd = NULL;
  pptr->dev = NULL;
  pptr->remaining = -1;
  pptr->delay = 10;
}

static void stop_printer(void)
{
  printer_config(c_printers, pptr);
  c_printf("CONF(LPT%d) f: %s   c: %s  t: %d  port: %x\n",
           c_printers, pptr->dev, pptr->prtcmd,
           pptr->delay, pptr->base_port);
  c_printers++;
  if (c_printers > config.num_lpt)
    config.num_lpt = c_printers;
}

	/* disk */

static void start_floppy(void)
{
  if (c_fdisks >= MAX_FDISKS)
    {
    yyerror("There are too many floppy disks defined");
    dptr = &nulldisk;          /* Dummy-Entry to avoid core-dumps */
    }
  else
    dptr = &disktab[c_fdisks];

  dptr->sectors = 0;             /* setup default values */
  dptr->heads   = 0;
  dptr->tracks  = 0;
  dptr->type    = FLOPPY;
  dptr->default_cmos = THREE_INCH_FLOPPY;
  dptr->timeout = 0;
  dptr->dev_name = NULL;              /* default-values */
  dptr->wantrdonly = 0;
  dptr->header = 0;
}

static void start_disk(void)
{
  if (c_hdisks >= MAX_HDISKS) 
    {
    yyerror("There are too many hard disks defined");
    dptr = &nulldisk;          /* Dummy-Entry to avoid core-dumps */
    }
  else
    dptr = &hdisktab[c_hdisks];

  dptr->type    =  NODISK;
  dptr->sectors = -1;
  dptr->heads   = -1;
  dptr->tracks  = -1;
  dptr->fdesc   = -1;
  dptr->hdtype = 0;
  dptr->timeout = 0;
  dptr->dev_name = NULL;              /* default-values */
  dptr->wantrdonly = 0;
  dptr->header = 0;
  dptr->dexeflags = 0;
}

static void start_vnet(char *mode) {
  if (strcmp(mode, "") == 0) {
    config.vnet = VNET_TYPE_AUTO;
    return;
  }
  if (strcmp(mode, "tap") == 0) {
    config.vnet = VNET_TYPE_TAP;
    return;
  }
  if (strcmp(mode, "vde") == 0) {
    config.vnet = VNET_TYPE_VDE;
    return;
  }
  IFCLASS(CL_NET) {}
  if (strcmp(mode, "eth") == 0)
    config.vnet = VNET_TYPE_ETH;
  else {
    error("Unknown vnet mode \"%s\"\n", mode);
    config.exitearly = 1;
  }
}

static void do_part(char *dev)
{
  if (dptr->dev_name != NULL)
    yyerror("Two names for a partition given.");
  dptr->type = PARTITION;
  dptr->dev_name = dev;
#ifdef __linux__
  dptr->part_info.number = atoi(dptr->dev_name+8);
#endif
  if (dptr->part_info.number == 0)
    yyerror("%s must be a PARTITION, can't find number suffix!\n",
	    dptr->dev_name);
}

static void stop_disk(int token)
{
#ifdef __linux__
  FILE   *f;
  struct mntent *mtab;
#endif
  int    mounted_rw;

  if (dexe_running && dexe_forbid_disk)
    return;
  if (dptr == &nulldisk)              /* is there any disk? */
    return;                           /* no, nothing to do */

  if (!dptr->dev_name)                /* Is there a file/device-name? */
    yyerror("disk: no device/file-name given!");
  else                                /* check the file/device for existance */
    {
      struct stat st;

      if (stat(dptr->dev_name, &st) != 0) { /* Does this file exist? */
        yyerror("disk: device/file %s doesn't exist.", dptr->dev_name);
      }
    }

  if (dptr->type == NODISK)    /* Is it one of image, floppy, harddisk ? */
    yyerror("disk: no device/file-name given!"); /* No, error */
  else
    c_printf("CONF: disk type '%s'", disk_t_str(dptr->type));

  if (dptr->type == PARTITION) {
    c_printf(" partition# %d", dptr->part_info.number);
#ifdef __linux__
    mtab = NULL;
    if ((f = setmntent(MOUNTED, "r")) != NULL) {
      while ((mtab = getmntent(f)))
        if (!strcmp(dptr->dev_name, mtab->mnt_fsname)) break;
      endmntent(f);
    }
    if (mtab) {
      mounted_rw = ( hasmntopt(mtab, MNTOPT_RW) != NULL );
      if (mounted_rw && !dptr->wantrdonly) 
        yyerror("\n\nYou specified '%s' for read-write Direct Partition Access,"
                "\nit is currently mounted read-write on '%s' !!!\n",
                dptr->dev_name, mtab->mnt_dir);
      else if (mounted_rw) 
        yywarn("You specified '%s' for read-only Direct Partition Access,"
               "\n         it is currently mounted read-write on '%s'.\n",
               dptr->dev_name, mtab->mnt_dir);
      else if (!dptr->wantrdonly) 
        yywarn("You specified '%s' for read-write Direct Partition Access,"
               "\n         it is currently mounted read-only on '%s'.\n",
               dptr->dev_name, mtab->mnt_dir);
    }
#endif
  }

  if (dptr->header)
    c_printf(" header_size: %ld", (long) dptr->header);

  if (token == L_FLOPPY) {
    c_printf(" floppy %c:\n", 'A'+c_fdisks);
    c_fdisks++;
    config.fdisks = c_fdisks;
  }
  else {
    c_printf(" drive %c:\n", 'C'+c_hdisks);
    c_hdisks++;
    config.hdisks = c_hdisks;
  }
}

	/* keyboard */

void keyb_layout(int layout)
{
  struct keytable_entry *kt = keytable_list;
  if (layout == -1) {
    /* auto: do it later */
    config.keytable = NULL;
    return;
  }
  while (kt->name) {
    if (kt->keyboard == layout) {
      if (kt->flags & KT_ALTERNATE) {
        c_printf("CONF: Alternate keyboard-layout %s\n", kt->name);
        config.altkeytable = kt;
      } else {
      c_printf("CONF: Keyboard-layout %s\n", kt->name);
      config.keytable = kt;
      }
      return;
    }
    kt++;
  }
  c_printf("CONF: ERROR -- Keyboard has incorrect number!!!\n");
}

static void keytable_start(int layout)
{
  static struct keytable_entry *saved_kt = 0;
  if (layout == -1) {
    if (keyboard_statement_already) {
      if (config.keytable != saved_kt) {
        yywarn("keytable changed to %s table, but previously was defined %s\n",
                config.keytable->name, saved_kt->name);
      }
    }
  }
  else {
    saved_kt = config.keytable;
    keyb_layout(layout);
  }
}

static void keytable_stop(void)
{
  keytable_start(-1);
}

static void dump_keytables_to_file(char *name)
{
  FILE * f;
  struct keytable_entry *kt = keytable_list;

  f = fopen(name, "w");
  if (!f) {
    error("cannot create keytable file %s\n", name);
    exit(1);
  }
  
  while (kt->name) {
    dump_keytable(f, kt);
    kt++;
  }
  fclose(f);
  exit(0);
}

static void set_irq_value(int bits, int i1)
{
  if ((i1>2) && (i1<=15)) {
    config.sillyint |= (bits << i1);
    c_printf("CONF: IRQ %d for irqpassing", i1);
    if (bits & 0x10000)  c_printf(" uses SIGIO\n");
    else c_printf("\n");
  }
  else yyerror("wrong IRQ for irqpassing command: %d", i1);
}

static void set_irq_range(int bits, int i1, int i2) {
  int i;
  if ( (i1<3) || (i1>15) || (i2<3) || (i2>15) || (i1 > i2 ) ) {
    yyerror("wrong IRQ range for irqpassing command: %d .. %d", i1, i2);
  }
  else {
    for (i=i1; i<=i2; i++) config.sillyint |= (bits << i);
    c_printf("CONF: range of IRQs for irqpassing %d .. %d", i1, i2);
    if (bits & 0x10000)  c_printf(" uses SIGIO\n");
    else c_printf("\n");
  }
}


	/* errors & warnings */

void yywarn(char* string, ...)
{
  va_list vars;
  va_start(vars, string);
  fprintf(stderr, "Warning: ");
  vfprintf(stderr, string, vars);
  fprintf(stderr, "\n");
  va_end(vars);
  warnings++;
}

void yyerror(char* string, ...)
{
  va_list vars;
  va_start(vars, string);
  if (include_stack_ptr != 0 && !last_include) {
	  int i;
	  fprintf(stderr, "In file included from %s:%d\n",
		  include_fnames[0], include_lines[0]);
	  for(i = 1; i < include_stack_ptr; i++) {
		  fprintf(stderr, "                 from %s:%d\n",
			  include_fnames[i], include_lines[i]);
	  }
	  last_include = 1;
  }
  fprintf(stderr, "Error in %s: (line %.3d) ", 
	  include_fnames[include_stack_ptr], line_count);
  vfprintf(stderr, string, vars);
  fprintf(stderr, "\n");
  va_end(vars);
  errors++;
}


/*
 * open_file - opens the configuration-file named *filename and returns
 *             a file-pointer. The error/warning-counters are reset to zero.
 */

static FILE *open_file(char *filename)
{
  errors   = 0;                  /* Reset error counter */
  warnings = 0;                  /* Reset counter for warnings */

  if (!filename) return 0;
  return fopen(filename, "r"); /* Open config-file */
}

/*
 * close_file - Close the configuration file and issue a message about
 *              errors/warnings that occured. If there were errors, the
 *              flag early-exit is that, so dosemu won't really.
 */

static void close_file(FILE * file)
{
  if (file) fclose(file);                  /* Close the config-file */

  if(errors)
    fprintf(stderr, "%d error(s) detected while parsing the configuration-file\n",
	    errors);
  if(warnings)
    fprintf(stderr, "%d warning(s) detected while parsing the configuration-file\n",
	    warnings);

  if (errors != 0)               /* Exit dosemu on errors */
    {
      config.exitearly = TRUE;
    }
}

/* write_to_syslog */
static void write_to_syslog(char *message)
{
  openlog("dosemu", LOG_PID, LOG_USER | LOG_NOTICE);
  syslog(LOG_PID | LOG_USER | LOG_NOTICE, "%s", message);
  closelog();
}

static void move_dosemu_lib_dir(char *path)
{
  char *commands_path;
  if (dosemu_lib_dir_path != path) {
    if (dosemu_lib_dir_path != dosemulib_default)
      free(dosemu_lib_dir_path);
    dosemu_lib_dir_path = strdup(path);
  }
  fddir_default = assemble_path(dosemu_lib_dir_path, FREEDOS_DIR, 0);
  setenv("DOSEMU_LIB_DIR", dosemu_lib_dir_path, 1);
  commands_path = assemble_path(dosemu_lib_dir_path, CMDS_SUFF, 0);
  setenv("DOSEMU_COMMANDS_DIR", commands_path, 1);
  free(commands_path);

  if (keymap_load_base_path != keymaploadbase_default)
    free(keymap_load_base_path);
  keymap_load_base_path = assemble_path(path, "", 0);
}

static FILE *open_dosemu_users(void)
{
  FILE *fp;
  fp = open_file(DOSEMU_USERS_FILE);
  if (fp) return fp;
  return 0;
}

static void setup_home_directories(void)
{
  setenv("DOSEMU_HDIMAGE_DIR", dosemu_hdimage_dir_path, 1);
  LOCALDIR = get_dosemu_local_home();
  RUNDIR = mkdir_under(LOCALDIR, "run", 0);
  DOSEMU_MIDI_PATH = assemble_path(RUNDIR, DOSEMU_MIDI, 0);
  DOSEMU_MIDI_IN_PATH = assemble_path(RUNDIR, DOSEMU_MIDI_IN, 0);
}

static void lax_user_checking(void)
{
  char *p;
  define_config_variable("c_all");
  p = getenv("USER");
  if (!p) p = "guest";
  setenv("DOSEMU_USER", p, 1);
  setenv("DOSEMU_REAL_USER", p, 1);
  setup_home_directories();
}

/* Parse TimeMode, Paul Crawford and Andrew Brooks 2004-08-01 */
/* Accepts "bios", "pit", "linux", default is "bios". Use with TIMEMODE token */
int parse_timemode(const char *timemodestr)
{
   if (timemodestr == NULL || timemodestr[0] == '\0')
     return(TM_BIOS); /* default */
   if (strcmp(timemodestr, "linux")==0)
     return(TM_LINUX);
   if (strcmp(timemodestr, "pit")==0)
     return(TM_PIT);
   if (strcmp(timemodestr, "bios")==0)
     return(TM_BIOS);
   yyerror("Unrecognised time mode (not bios, pit or linux)");
   return(TM_BIOS);
}

/* Parse Users for DOSEMU, by Alan Hourihane, alanh@fairlite.demon.co.uk */
/* Jan-17-1996: Erik Mouw (J.A.K.Mouw@et.tudelft.nl)
 *  - added logging facilities
 * In 1998:     Hans
 *  - havy changes and re-arangments
 */
void
parse_dosemu_users(void)
{
#define ALL_USERS "all"
#define PBUFLEN 256

  FILE *volatile fp;
  struct passwd *pwd;
  char buf[PBUFLEN];
  int userok = 0;
  char *ustr;
  int uid;
  int have_vars=0;

  /* We come here _very_ early (at top of main()) to avoid security conflicts.
   * priv_init() has already been called, but nothing more.
   *
   * We will exit, if /etc/dosemu.users says that the user has no right
   * to run a suid root dosemu (and we are on), but will continue, if the user
   * is running a non-suid copy _and_ is mentioned in dosemu users.
   * The dosemu.users entry for such a user is:
   *
   *      joeodd  ... nosuidroot
   *
   * The functions we call rely on the following setting:
   */
  after_secure_check = 0;
  priv_lvl = 0;

  setenv("DOSEMU_CONF_DIR", DOSEMU_CONF_DIR, 1);
  /* we check for some vital global settings
   * which we need before proceeding
   */
  setenv("DOSEMU_LIB_DIR", dosemulib_default, 1);
  move_dosemu_lib_dir(dosemu_lib_dir_path);

  fp = open_dosemu_users();
  if (fp) while (fgets(buf, PBUFLEN, fp) != NULL) {
    int l = strlen(buf);
    if (l && (buf[l-1] == '\n')) buf[l-1] = 0;
    ustr = strtok(buf, " \t\n=,;:");
    if (ustr && (ustr[0] != '#')) {
      if (!strcmp(ustr, "default_lib_dir")) {
        ustr=strtok(0, " \t\n=,;:");
        if (ustr) {
          if (!exists_dir(ustr)) {
            char *tx = "default_lib_dir %s does not exist\n";
            fprintf(stderr, tx, ustr);
            fprintf(stdout, tx, ustr);
            exit(1);
          }
          move_dosemu_lib_dir(ustr);
        }
      }
      if (!strcmp(ustr, "default_hdimage_dir")) {
        ustr=strtok(0, " \t\n=,;:");
        if (ustr) {
          if (!exists_dir(ustr)) {
            char *tx = "default_hdimage_dir %s does not exist\n";
            fprintf(stderr, tx, ustr);
            fprintf(stdout, tx, ustr);
            exit(1);
          }
          if (dosemu_hdimage_dir_path != dosemuhdimage_default)
            free(dosemu_hdimage_dir_path);
          dosemu_hdimage_dir_path = strdup(ustr);
	  dexe_load_path = dosemu_hdimage_dir_path;
        }
      }
      else if (!strcmp(ustr, "log_level")) {
        int ll = 0;
        ustr=strtok(0, " \t\n=,;:");
        if (ustr) {
          ll = atoi(ustr);
          if (ll < 0) ll = 0;
          if (ll > 2) ll = 2;
        }
      }
      else if (!strcmp(ustr, "config_script")) {
        ustr=strtok(0, " \t\n=,;:");
        if (ustr && strcmp(ustr, DEFAULT_CONFIG_SCRIPT)) {
          config_script_path = strdup(ustr);
          if (!exists_file(config_script_path)) {
            char *tx = "config_script %s does not exist\n";
            fprintf(stderr, tx, ustr);
            fprintf(stdout, tx, ustr);
            exit(1);
          }
	  config_script_name = strdup(ustr);
	}
      }
    }
  }
  if (fp) fclose(fp);

  if (!can_do_root_stuff || under_root_login) {
     /* simply ignore -- we're not suid-root */
     lax_user_checking();
     after_secure_check = 1;
     return;
  }

  /* We want to test if the _user_ is allowed to do certain privileged    */
  /* things, o check if the username connected to the get_orig_uid() is   */
  /* in the DOSEMU_USERS_FILE file (usually /etc/dosemu.users).           */
   
  uid = get_orig_uid();

  errno = 0; /* man says this is necessary?! */
  pwd = getpwuid(uid);

  /* Sanity Check, Shouldn't be anyone logged in without a userid */
  if (!pwd) 
     {
       error("Illegal User: uid=%i, error=%s\n", uid, strerror(errno));
       sprintf(buf, "Illegal DOSEMU user: uid=%i", uid);
       write_to_syslog(buf);
       exit(1);
     }

  /* preset DOSEMU_*USER env, such that a user can't fake it */
  setenv("DOSEMU_USER", "unknown", 1);
  setenv("DOSEMU_REAL_USER", pwd->pw_name, 1);

  {
       int can_have_privsetup = 0;
       fp = open_dosemu_users();
       if (fp) {
	   for(userok=0; fgets(buf, PBUFLEN, fp) != NULL && !userok; ) {
	     int l = strlen(buf);
	     if (l && (buf[l-1] == '\n')) buf[l-1] = 0;
	     ustr = strtok(buf, " \t\n,;:");
	     if (ustr && (ustr[0] != '#')) {
	       if (strcmp(ustr, pwd->pw_name)== 0) 
		 userok = 1;
	       else if (strcmp(ustr, ALL_USERS)== 0)
		 userok = 1;
	       if (userok) {
		 setenv("DOSEMU_USER", ustr, 1);
		 while ((ustr=strtok(0, " \t,;:")) !=0) {
		   if (ustr[0] == '#') break;
		   define_config_variable(ustr);
		   have_vars = 1;
                   if (!strcmp(ustr,"private_setup")) {
                     can_have_privsetup = 1;
                   }
		 }
	         if (!have_vars && !using_sudo)
		   define_config_variable("restricted");
	       }
	     }
	   }
           fclose(fp);
       }
       

       if (can_have_privsetup
              && (   get_config_variable("unrestricted")
                  || under_root_login || !can_do_root_stuff)) {
         /* this user is allowed to have a privat ~/.dosemu/lib
          * (which replaces DOSEMULIB_DEFAULT if existing).
          * Hence this user can have its own global.conf e.t.c.
          * However, this is only possible with non-suid-root
          * binary or when running under root loggin or when 'unrestricted'
          * also is set.       -- Hans
          */
         char *lpath = get_path_in_HOME(LOCALDIR_BASE_NAME "/lib");
         if (exists_dir(lpath)) move_dosemu_lib_dir(lpath);
         free(lpath);
       }
  }

  define_config_variable("c_all");
  if(userok==0 && !using_sudo) {
    define_config_variable("restricted");
  }
  if (get_config_variable("nosuidroot") || (get_config_variable("restricted") && !on_console())) {
    fprintf(stderr, "Dropping root privileges: guest or a restricted user not on console.\n");
    priv_drop();
    lax_user_checking();
    after_secure_check = 1;
    return;
  }

  /* now we setup up our local DOSEMU home directory, where we
   * have (among other things) all temporary stuff in
   * (since 0.97.10.2)
   */
  setup_home_directories();
  after_secure_check = 1;
}


char *commandline_statements=0;

static int has_dexe_magic(char *name)
{
  int fd, magic, ret;
  fd = open(name, O_RDONLY);
  if (fd <0) return 0;
  ret = (read(fd, &magic, 4) == 4) && (magic == DEXE_MAGIC);
  close(fd);
  return ret;
}

static int stat_dexe(char *name)
{
  struct stat s;
  if (stat(name, &s)) return 0;
  if ( ! S_ISREG(s.st_mode)) return 0;
  if ((s.st_mode & S_IXUSR) && (s.st_uid == get_orig_uid()))
    return has_dexe_magic(name);
  if ((s.st_mode & S_IXGRP) && (is_in_groups(s.st_gid)))
    return  has_dexe_magic(name); 
  if (s.st_mode & S_IXOTH) return has_dexe_magic(name);
  return 0;
}

static char *resolve_exec_path(char *dexename, char *ext)
{
  enum { maxn=0x255 };
  static char n[maxn+1];
  static char name[maxn+1];
  char *p, *path=getenv("PATH");

  strncpy(name,dexename,maxn);
  name[maxn] = 0;
  n[maxn] = 0;
  p = rindex(name, '.');
  if ( ext && ((p && strcmp(p, ext)) || !p) )
    strncat(name,ext,maxn);


  /* first try the pure file name */
  if (!path || (name[0] == '/') || (!strncmp(name, "./", 2))) {
    if (stat_dexe(name)) return name;
    return 0;
  }

  /* next try the standard path for DEXE files */
  snprintf(n, maxn, "%s/%s", dexe_load_path, name);
  if (stat_dexe(n)) return n;

  /* now search in the users normal PATH */
  path = strdup(path);
  p= strtok(path,":");
  while (p) {
    snprintf(n, maxn, "%s/%s", p, name);
    if (stat_dexe(n)) {
      free(path);
      return n;
    }
    p=strtok(0,":");
  }
  free(path);
  return 0;
}

void prepare_dexe_load(char *name)
{
  char *n, *cbuf;
  int fd, csize;
  struct image_header ihdr;

  n = resolve_exec_path(name, ".dexe");
  if (!n) {
    n = resolve_exec_path(name, 0);
    if (!n) {
      error("DEXE file not found or not executable\n");
      exit(1);
    }
  }

  /* now we extract the configuration file and the access flags */
  fd = open(n, O_RDONLY);
  if (read(fd, &ihdr, sizeof(struct image_header)) != sizeof(struct image_header)) {
    error("broken DEXE format, can't read image header\n");
    close(fd);
    exit(1);
  }

  lseek(fd, HEADER_SIZE + 0x200, SEEK_SET); /* just behind the MBR */
  if ((read(fd, &csize, 4) != 4) || (csize > 0x2000)) {
    error("broken DEXE format, configuration not found\n");
    close(fd);
    exit(1);
  }
  
  /* we use the -I option to feed in the configuration,
   * and we put ours in front of eventually existing options
   */
  if (commandline_statements) {
    cbuf = malloc(csize+1+strlen(commandline_statements)+1);
    read(fd, cbuf, csize);
    cbuf[csize] = '\n';
    strcpy(cbuf+csize+1, commandline_statements);
  }
  else {
    cbuf = malloc(csize+1);
    read(fd, cbuf, csize);
    cbuf[csize] = 0;
  }
  commandline_statements = cbuf;
  close(fd);

  start_disk();
  dptr->type = IMAGE;
  dptr->header = HEADER_SIZE;
  dptr->dev_name = n;
  dptr->dexeflags = ihdr.dexeflags | DISK_IS_DEXE;
  stop_disk(DISK);
  dexe_running = 1;
}


static void do_parse(FILE* fp, char *confname, char *errtx)
{
        yyin = fp;
        line_count = 1;
	include_stack_ptr = 0;
        c_printf("CONF: Parsing %s file.\n", confname);
	file_being_parsed = strdup(confname);
	include_fnames[include_stack_ptr] = file_being_parsed;
	yyrestart(fp);
        if (yyparse()) yyerror(errtx, confname);
        close_file(fp);
	include_stack_ptr = 0;
	include_fnames[include_stack_ptr] = 0;
	free(file_being_parsed);
}

int parse_config(char *confname, char *dosrcname)
{
  FILE *fd;
  int is_user_config;
#if YYDEBUG != 0
  yydebug  = 1;
#endif

  define_config_variable(PARSER_VERSION_STRING);

  /* Let's try confname if not null, and fail if not found */
  /* Else try the user's own .dosrc (old) or .dosemurc (new) */
  /* If that doesn't exist we will default to CONFIG_FILE */

  { 
    if (!dosrcname) {
      char *name = get_path_in_HOME(DOSEMU_RC);
      setenv("DOSEMU_RC", name, 1);
      free(name);
    }
    else {
      setenv("DOSEMU_RC",dosrcname,1);
    }

    /* privileged options allowed? */
    is_user_config = (confname && config_script_path && strcmp(confname, config_script_path));
    priv_lvl = !under_root_login && can_do_root_stuff && is_user_config;

    /* DEXE together with option F ? */
    if (priv_lvl && dexe_running) {
      /* for security reasons we cannot allow this */
      fprintf(stderr, "user cannot load DEXE file together with option -F\n");
      exit(1);
    }

    if (is_user_config) define_config_variable("c_user");
    else define_config_variable("c_system");
    if (dexe_running) define_config_variable("c_dexerun");

    yy_vbuffer = dosemu_conf;
    do_parse(NULL, "built-in dosemu.conf", "error in built-in dosemu.conf");
    yy_vbuffer = global_conf;
    do_parse(NULL, "built-in global.conf", "error in built-in global.conf");
    if (confname) {
      yy_vbuffer = NULL;
      fd = open_file(confname);
      if (!fd) {
        if (!dexe_running) {
          fprintf(stderr, "Cannot open base config file %s, Aborting DOSEMU.\n",confname);
          exit(1);
        }
      }
      do_parse(fd, confname, "error in configuration file %s");
    }

    if (priv_lvl) undefine_config_variable("c_user");
    else undefine_config_variable("c_system");

    if (!get_config_variable(CONFNAME_V3USED)) {
	/* we obviously have an old configuration file
         * ( or a too simple one )
	 * giving up
	 */
	yyerror("\nYour %s script or configuration file is obviously\n"
		"an old style or a too simple one\n"
		"Please read README.txt on how to upgrade\n", confname);
	exit(1);
    }

    /* privileged options allowed for user's config? */
    priv_lvl = !under_root_login && can_do_root_stuff;
    if (priv_lvl) define_config_variable("c_user");

    /* Now we parse any commandline statements from option '-I'
     * We do this under priv_lvl set above, so we have the same secure level
     * as with .dosrc
     */

    if (commandline_statements) {
      #define XX_NAME "commandline"

      open_file(0);
      define_config_variable("c_comline");
      c_printf("Parsing " XX_NAME  " statements.\n");
      yyin=0;				 /* say: we have no input file */
      yy_vbuffer=commandline_statements; /* this is the input to scan */
      do_parse(0, XX_NAME, "error in user's %s statement");
      undefine_config_variable("c_comline");
    }
  }

  /* check for global settings, that should know the whole settings
   * This we only can do, after having parsed all statements
   */

  if (dexe_running) {
    /* force a BootC,
     * regardless what ever was set in the config files
     */
    config.hdiskboot = 2;
  }
  else {
    if (get_config_variable("c_dexeonly")) {
       c_printf("CONF: only execution of DEXE files allowed\n");
       fprintf(stderr, "only execution of DEXE files allowed\n");
       exit(99);
    }
  }

#ifdef TESTING
  error("TESTING: parser is terminating program\n");
  exit(0);
#endif
  return 1;
}

#define MAX_CONFIGVARIABLES 128
char *config_variables[MAX_CONFIGVARIABLES+1] = {0};
static int config_variables_count = 0;
static int config_variables_last = 0;
static int allowed_classes = -1;
static int saved_allowed_classes = -1;



static int is_in_allowed_classes(int mask)
{
  if (!(allowed_classes & mask)) {
    yyerror("insufficient class privilege to use this configuration option\n");
    exit(99);
  }
  return 1;
}

struct config_classes {
	char *class;
	int mask;
} config_classes[] = {
	{"c_all", CL_ALL},
	{"c_normal", CL_ALL & (~(CL_VAR | CL_VPORT | CL_IRQ | CL_HARDRAM | CL_PCI | CL_NET))},
	{"c_var", CL_VAR},
	{"c_system", CL_ALL},
	{"c_vport", CL_VPORT},
	{"c_port", CL_PORT},
	{"c_irq", CL_IRQ},
	{"c_pci", CL_PCI},
	{"c_hardram", CL_HARDRAM},
	{"c_net", CL_NET},
	{0,0}
};

static int get_class_mask(char *name)
{
  struct config_classes *p = &config_classes[0];
  while (p->class) {
    if (!strcmp(p->class,name)) return p->mask;
    p++;
  }
  return 0;
}

static void update_class_mask(void)
{
  int i, m;
  allowed_classes = 0;
  for (i=0; i< config_variables_count; i++) {
    if ((m=get_class_mask(config_variables[i])) != 0) {
      allowed_classes |= m;
    }
  }
}

static void enter_user_scope(int incstackptr)
{
  if (user_scope_level) return;
  saved_priv_lvl = priv_lvl;
  priv_lvl = 1;
  saved_allowed_classes = allowed_classes;
  allowed_classes = 0;
  user_scope_level = incstackptr;
  c_printf("CONF: entered user scope, includelevel %d\n", incstackptr-1);
}

static void leave_user_scope(int incstackptr)
{
  if (user_scope_level != incstackptr) return;
  priv_lvl = saved_priv_lvl;
  allowed_classes = saved_allowed_classes;
  user_scope_level = 0;
  c_printf("CONF: left user scope, includelevel %d\n", incstackptr-1);
}

char *get_config_variable(char *name)
{
  int i;
  for (i=0; i< config_variables_count; i++) {
    if (!strcmp(name, config_variables[i])) {
      config_variables_last = i;
      return config_variables[i];
    }
  }
  return 0;
}

int define_config_variable(char *name)
{
  if (priv_lvl) {
    if (strcmp(name, CONFNAME_V3USED) && strncmp(name, "u_", 2)) {
      c_printf("CONF: not enough privilege to define config variable %s\n", name);
      return 0;
    }
  }
  if (!get_config_variable(name)) {
    if (config_variables_count < MAX_CONFIGVARIABLES) {
      config_variables[config_variables_count++] = strdup(name);
      if (!priv_lvl) update_class_mask();
    }
    else {
      if (after_secure_check)
        c_printf("CONF: overflow on config variable list\n");
      return 0;
    }
  }
  if (after_secure_check)
    c_printf("CONF: config variable %s set\n", name);
  return 1;
}

static int undefine_config_variable(char *name)
{
  if (priv_lvl) {
    if (strncmp(name, "u_", 2)) {
      c_printf("CONF: not enough privilege to undefine config variable %s\n", name);
      return 0;
    }
  }
  if (get_config_variable(name)) {
    int i;
    if (!strcmp(name, CONFNAME_V3USED)) parser_version_3_style_used = 0;
    free(config_variables[config_variables_last]);
    for (i=config_variables_last; i<(config_variables_count-1); i++) {
      config_variables[i] = config_variables[i+1];
    }
    config_variables_count--;
    if (!priv_lvl) update_class_mask();
    c_printf("CONF: config variable %s unset\n", name);
    return 1;
  }
  return 0;
}

char *checked_getenv(const char *name)
{
  if (user_scope_level) {
     char *s, *name_ = malloc(strlen(name)+sizeof(USERVAR_PREF));
     strcpy(name_, USERVAR_PREF);
     strcat(name_, name);
     s = getenv(name_);
     free(name_);
     if (s) return s;
  }
  return getenv(name);
}

static void check_user_var(char *name)
{
	char *name_;
	char *s;

	if (user_scope_level) return;
	name_ = malloc(strlen(name)+sizeof(USERVAR_PREF));
	strcpy(name_, USERVAR_PREF);
	strcat(name_, name);
	s = getenv(name_);
	if (s) {
		if (getenv(name))
			c_printf("CONF: variable %s replaced by user\n", name);
		setenv(name, s, 1);
		unsetenv(name_);
	}
	free(name_);
}


static char *run_shell(char *command)
{
	int pipefds[2];
	pid_t pid;
	char excode[16] = "1";

	setenv("DOSEMU_SHELL_RETURN", excode, 1);
	if (pipe(pipefds)) return strdup("");
	pid = fork();
	if (pid == -1) return strdup("");
	if (!pid) {
		/* child */
		int ret;
		close(pipefds[0]);	/* we won't read from the pipe */
		dup2(pipefds[1], 1);	/* make the pipe child's stdout */
		priv_drop();	/* drop any priviledges */
		ret = system(command);
			/* tell the parent: "we have finished",
			 * this way we need not to play games with select()
			 */
		if (ret == -1) ret = errno;
		else ret >>=8;
		write(pipefds[1],"\0\0\0",4);
		close(pipefds[1]);
		_exit(ret);
	}
	else {
		/* parent */
		char *buf = 0;
		int recsize = 128;
		int bufsize = 0;
		int ptr =0;
		int ret;
		int status;

		close(pipefds[1]);	/* we won't write to the pipe */
		do {
			bufsize = ptr + recsize;
			if (!buf) buf = malloc(bufsize);
			else buf = realloc(buf, bufsize);
			ret = read(pipefds[0], buf+ptr, recsize -1);
			if (ret > 0) {
				ptr += ret;
			}
		} while (ret >0 && (ret < 4 || memcmp(buf+ptr-4,"\0\0\0",4)));
		close(pipefds[0]);
		waitpid(pid, &status, 0);
		buf[ptr] = 0;
		if (!buf[0]) {
			free(buf);
			buf = strdup("");
		}
		sprintf(excode, "%d", WEXITSTATUS(status));
		setenv("DOSEMU_SHELL_RETURN", excode, 1);
		return buf;
	}
}


struct for_each_entry {
	char *list;
	char *ptr;
	int skip_restart;
};

#define FOR_EACH_DEPTH	16
static struct for_each_entry *for_each_list = 0;

static int for_each_handling(int loopid, char *varname, char *delim, char *list)
{
	struct for_each_entry *fe;
	char * new;
	char saved;
	if (!for_each_list) {
		int size = FOR_EACH_DEPTH * sizeof(struct for_each_entry);
		for_each_list = malloc(size);
		memset(for_each_list, 0, size);
	}
	if (loopid > FOR_EACH_DEPTH) {
		yyerror("too deeply nested foreach\n");
		return 0;
	}
	fe = for_each_list + loopid;
	if (!fe->list) {
		/* starting the loop */
		fe->ptr = fe->list = strdup(list);
		fe->skip_restart = 0;
		if (loopid) {
			/* in inner loops we need to skip the restart */
			fe->skip_restart = 1;
		}
	}
	else {
		if (fe->skip_restart) {
			fe->skip_restart = 0;
			return 1;
		}
	}
	while (fe->ptr[0] && strchr(delim,fe->ptr[0])) fe->ptr++;
	/* subsequent call */
	if (!fe->ptr[0]) {
		/* loop end */
		free(fe->list);
		fe->list = 0;
		return (0);
	}
	new = strpbrk(fe->ptr, delim);
	if (!new) new = strchr(fe->ptr,0);
	saved = *new;
	*new = 0;
	setenv(varname,fe->ptr,1);
	if (saved) new++;
	fe->ptr = new;
	return (1);
}

#ifdef TESTING_MAIN

static void die(char *reason)
{
  error("par dead: %s\n", reason);
  exit(0);
}

int
main(int argc, char **argv)
{
  if (argc != 2)
    die("no filename!");

  if (!parse_config(argv[1], argv[2] /* will be NULL if not given */))
    die("parse failed!\n");
}

#endif

/* for keyboard plugin */



static void keyb_mod(int wich, t_keysym keynum, int unicode)
{
	static t_keysym *table = 0;
	static int count = 0;
	
	if (wich == ' ') {
		switch (keynum & 0xFF00) {
		case 0x000: wich = ' '; break;
		case 0x100: wich = 'S'; break;
		case 0x200: wich = 'A'; break;
		case 0x300: wich = 'N'; break;
		case 0x400: wich = 'C'; break;
		case 0x500: wich = 'a'; break;
		case 0x600: wich = 'c'; break;
		default: 
			/* It's a bad value ditch it */
			wich ='X'; table = 0; count = 0; break;
		}
		keynum &= 0xFF;
	}

	switch (wich) {
	case ' ': table = config.keytable->key_map;
		count=config.keytable->sizemap;
		break;
	case 'S': table = config.keytable->shift_map;
		count=config.keytable->sizemap;
		break;
	case 'A': table = config.keytable->alt_map;
		count=config.keytable->sizemap;
		break;
	case 'C': table = config.keytable->ctrl_map;
		count=config.keytable->sizemap;
		break;
	case 'a': table = config.keytable->shift_alt_map;
		count=config.keytable->sizemap;
		break;
	case 'c': table = config.keytable->ctrl_alt_map;
		count=config.keytable->sizemap;
		break;
	case 'N': table = config.keytable->num_table;
		count=config.keytable->sizepad;
		break;
	}


	if (!table || (count == 0) || (wich != 0 && keynum >= count)) {
		count = 0;
		table = 0;
		return;
	}
	if (wich != 0) {
		table += keynum;
		count -= keynum;
		return;
	}
	if (!unicode) {
		if (keynum == 0) {
			keynum = DKY_VOID;
		} else {
			keynum = keynum + 0xEF00;
		}
	}
	if (count > 0) {
		*table++ = keynum;
		count--;
	}
}


static char *get_key_name(t_keysym key)
{
	struct key_names {
		t_keysym key;
		char *name;
	};
	static struct key_names names[] =
	{
		{ DKY_DEAD_GRAVE,	"dgrave"},
		{ DKY_DEAD_ACUTE,	"dacute"},
		{ DKY_DEAD_CIRCUMFLEX,	"dcircum"},
		{ DKY_DEAD_TILDE,	"dtilde"},
		{ DKY_DEAD_BREVE,	"dbreve"},
		{ DKY_DEAD_ABOVEDOT,	"daboved"},
		{ DKY_DEAD_DIAERESIS,	"ddiares"},
		{ DKY_DEAD_ABOVERING,	"dabover"},
		{ DKY_DEAD_DOUBLEACUTE,	"ddacute"},
		{ DKY_DEAD_CEDILLA,	"dcedilla"},
		{ DKY_DEAD_OGONEK,	"dogonek"},
		{ DKY_DEAD_CARON,	"dcaron"},
	};
	int i;
	for(i = 0; i < sizeof(names)/sizeof(names[0]); i++) {
		if (names[i].key == key) {
			return names[i].name;
		}
	}
	return 0;
}

static void dump_keytable_part(FILE *f, t_keysym *map, int size)
{
  int i, in_string=0;
  t_keysym c;
  char *cc, comma=' ', buf[16];

  /* Note: This code assumes every font is a superset of ascii */
  if (!map) {
	  return;
  }
  size--;
  for (i=0; i<=size; i++) {
    c = map[i];
    if (!(i & 15)) fprintf(f,"    ");
    cc = get_key_name(c);
    if (!cc && (c < 128) && isprint(c) && !strchr("\\\"\'`", c)) {
      if (in_string) fputc(c,f);
      else {
        fprintf(f, "%c\"%c", comma, c);
        in_string = 1;
      }
    }
    else {
      if (!cc) {
	if (((c > 0) && (c < 128)) || ((c >= 0xEF00) && (c <= 0xEFFF))) {
	  sprintf(buf, "%d", c & 0xFF);
	} else if (c == DKY_VOID) {
	  strcpy(buf, "0");
	} else {
	  sprintf(buf, "\\u%04x", c);
	}
	cc = buf;
      }
      if (!in_string) fprintf(f, "%c%s", comma, cc);
      else {
        fprintf(f, "\",%s", cc);
        in_string = 0;
      }
    }
    if ((i & 15) == 15) {
      if (in_string) fputc('"', f);
      if (i < size) fputc(',', f);
      fputc('\n', f);
      in_string = 0;
      comma = ' ';
    }
    else comma = ',';
  }
  if (in_string) fputc('"', f);
  fputc('\n', f);
}


void dump_keytable(FILE *f, struct keytable_entry *kt)
{
    fprintf(f, "keytable %s {\n", kt->name);
    fprintf(f, "  0=\n");
    dump_keytable_part(f, kt->key_map, kt->sizemap);
    fprintf(f, "  shift 0=\n");
    dump_keytable_part(f, kt->shift_map, kt->sizemap);
    fprintf(f, "  alt 0=\n");
    dump_keytable_part(f, kt->alt_map, kt->sizemap);
    fprintf(f, "  numpad 0=\n");
    dump_keytable_part(f, kt->num_table, kt->sizepad-1);
    fprintf(f, "  ctrl 0=\n");
    dump_keytable_part(f, kt->ctrl_map, kt->sizemap);
    fprintf(f, "  shift-alt 0=\n");
    dump_keytable_part(f, kt->shift_alt_map, kt->sizemap);
    fprintf(f, "  ctrl-alt 0=\n");
    dump_keytable_part(f, kt->ctrl_alt_map, kt->sizemap);
    fprintf(f, "}\n\n\n");
}



	/* charset */
static struct char_set *get_charset(char *name)
{
	struct char_set *charset;

	charset = lookup_charset(name);
	if (!charset) {
		yyerror("Can't find charset %s", name);
	}
	return charset;

}

static void set_external_charset(char *charset_name)
{
	struct char_set *charset;
	charset = get_charset(charset_name);
	charset = get_terminal_charset(charset);
	if (charset) {
		if (!trconfig.output_charset) {
			trconfig.output_charset = charset;
		}
		if (!trconfig.keyb_charset) {
			trconfig.keyb_charset = charset;
		}
	}
	return;
}

static void set_internal_charset(char *charset_name)
{
	struct char_set *charset_video, *charset_config;
	charset_video = get_charset(charset_name);
	if (!is_display_charset(charset_video)) {
		yyerror("%s not suitable as an internal charset", charset_name);
	}
	charset_config = get_terminal_charset(charset_video);
	if (charset_video && !trconfig.video_mem_charset) {
		trconfig.video_mem_charset = charset_video;
	}
	if (charset_config && !trconfig.keyb_config_charset) {
		trconfig.keyb_config_charset = charset_config;
	}
	if (charset_config && !trconfig.dos_charset) {
		trconfig.dos_charset = charset_config;
	}
	return;
}

